/*
 * $Id: Corpfuns.h,v 1.4 2005-10-03 14:52:43 tonydodd Exp $
 *
 * $Log: not supported by cvs2svn $
 * Revision 1.2  1996/05/12 23:36:15  scotty
 * v927 fixes from Tony.
 *
 * Revision 1.1  1996/02/15 01:29:20  scotty
 * Initial revision
 *
 */
#ifdef __cplusplus
extern "C" {
#endif

#ifndef CORPFUNS_H
# define CORPFUNS_H

# include "Exttypes.h"
# include "Corpdefs.h"

# if defined(_WIN32)
void        syslogw(int, const xairo_uchar *, ...);
# endif /* ! __unix__ */
void        bootlog(char *, ...);
void        opensyslog(char *, int, int, BOOL);
void        syslog(int, char *, ...);

# if defined(SERVER)
int __cdecl fscanf(FILE *, const char *,...);
# endif /* SERVER */

void           UtilPerform(int);
int            Menu(struct menu *);
void           BuildIndex(void);
BOOL			BuildOneIndex(char*);
void           corperr(const char *, ...);
BOOL           Excluded(char *);
void           BuildHeader(void);
BOOL           is_nc(char);
FILE          *FirstFile(char *);
FILE          *NexFile(char *);
void           MergeIndex(void);
void           Sorts(void);
void           Compression(void);
void           Measure(void);
void 			IndexSig();
void           EditGetWord(char *, char *);
unsigned int   hashval(char *);
void           QueryMenu(void);
void           GetPath(char *, char *);
BOOL           AdvanceStream(struct stream *);
BOOL           XAdvanceStream(struct stream *);
void           RewindStream(struct stream *);
void           ClearBuffers(void);
void           ViewMenu(void);
void           RestorePos(struct stream *, STRSAVE *);
void           SavePos(struct stream *, STRSAVE *);
sara_long      CountStream(struct stream *);
sara_long      XCountStream(struct stream *);
void           MakeSortTab(void);
sara_long      LastSGML(WORDNO, sara_ulong, char *, int);
sara_long      NextSGML(WORDNO, sara_ulong, char *, int);
sara_long      LastSGMLw(WORDNO, sara_ulong, char *, int);
sara_long      NextSGMLw(WORDNO, sara_ulong, char *, int);
sara_long      LastSGMLp(sara_long, sara_ulong, char *, int);
sara_long      NextSGMLp(sara_long, sara_ulong, char *, int);
char* LastSGMLv(sara_long*, sara_ulong, char *, int);
char* NextSGMLv(sara_long*, sara_ulong, char *, int);
int AKStat(xairo_uchar*,xairo_uchar*,int*);
void AKFilter(xairo_uchar*,xairo_uchar*);
void AKClear(xairo_uchar*);

BOOL           ynq(char *);
void           NewQuery(void);
void           ClearBookmarks(void);
void           DiscardUnmarked(void);
void           CloseQuery(void);
void           EditGetNumber(char *, int *);
void           Retain(int, int);
struct stream *MakeAtomStream(char *, int, int);
struct stream *MakeAtomStreamW(const xairo_uchar *, int, int);
void           WordList(void);
void           DelAllWL(void);
void           KillFileBuffers(FILE *f);
void           FullQuery(void);
struct stream *MakeAllPOSStream(const char *, BOOL,BOOL);
struct stream *MakeAllPOSStreamW(const xairo_uchar *, BOOL,BOOL);
struct stream *MakeCSAllPOSStream(const char *, BOOL);
struct stream *MakePosStream(char *);
struct stream *MakePosStreamW(xairo_uchar *);
struct stream *MakePosStream2(const char *,int);
struct stream *MakePosStream2W(const xairo_uchar *,const xairo_uchar*);
struct stream *MakePosStream3W(const xairo_uchar *,const xairo_uchar*,const xairo_uchar*);
struct stream *MakeAllPosStream(const xairo_uchar*,const xairo_uchar*);
//struct stream *MakeAllPOSStreamN(const char **, int, BOOL);
struct stream *MakeDictionaryStream(int);
struct stream* MakeLemmaStream(const xairo_uchar*);
struct stream* MakeFormStream(const xairo_uchar*,int);
void           FreeStreams(void);
struct stream *GrabStream(void);
struct stream *MakeSGMLStream2(char *, int, char *[], char *[], char *[]);
struct stream *MakeSGMLStream2W(xairo_uchar *, int, xairo_uchar *[], xairo_uchar *[], xairo_uchar *[]);
struct stream *MakeFileStream(char *);
struct stream *MakeFileStreamW(xairo_uchar *);
struct stream *MakeSCStream(char *);
struct stream *MakeSCStreamW(xairo_uchar *);
struct stream *MakeIDStream(char *, char *, int);
struct stream *MakeIDCStream(int, WORDNO[10], char *, int);
long CountWords(sara_ulong);

BOOL           bMayHashChar(unsigned, xairo_uchar, int);
char          *IndexDir(unsigned i);
void           Server(void);
sara_long      Solve(char *, xairo_uchar *, int *);
sara_long      SolveX(char *, xairo_uchar *, int *,char*);
sara_long      Solve0(char *, int *);
void           FreeStream(struct stream *);
void           FreeStreamR(struct stream *);
int            WoL(xairo_uchar *,int,char*);
void CountQuery(char*,const char*,int,int*,int*);
void CountContent(char*,const char*,int,char*,int*,int*);
sara_long      SaveQueryFile(struct stream *, char *, int *);
void           GetIndex(void);
int            PosList(char *, int[]);
struct stream *MakeRegExpStream(char *);
struct stream *MakeRegExpStreamW(xairo_uchar *,int);
struct stream *MakeRegExpStreamA(xairo_uchar *,xairo_uchar*,xairo_uchar*,BOOL);
struct stream *MakeCaseFilter(struct stream *s, xairo_uchar *);
void           GetPath2(char *code, char *id, char *path);
void           WriteHeader2();
int				IsFrob(char*);
void           MakeElttabs(void);
void           GetName(char **, char *);
void           Dictionary(void);
void           SCDictionary(const char*);
BOOL			SCRead(char*,char*);
void SCDel(char*);
void			SCWriteAll();
void			SCReadAll();
int				SCCount();
const char*     SCName(int);
void           GetDict(void);
char          *GetQPath(char *);
char          *GetQTPath(char *);
sara_long      cscore(struct stream *, struct stream *, int);
sara_long      xscore(struct locent1 *, struct stream *, int,int);
sara_long      colloc_score(char *, xairo_uchar *, int,int, int*);
void           GetDocPath(sara_ulong, char *, char *);
void           GetPIndex();
void GetBIndex();
int            FindDoc(char *);
void           PackIndex();
BOOL           idcomp(char *, char *, char *, WORDNO *);
BOOL           Get1Sol(sara_ulong, xairo_uchar *, xairo_uchar *, xairo_uchar*, xairo_uchar *,int);
void           TextExtract(sara_ulong, sara_long, sara_long, xairo_uchar *);
BOOL           SetPassword(char *, char *, char *);
BOOL           LogUser(char *name, char *password);
void           MakeFIndex(void);
void           NewSortHash(char *);
void           IndexFile(int hash, int k, char *path);
FILE          *Accelerated(xairo_uchar *, int, int);
BOOL           GetAccels(void);
int            WoL1(xairo_uchar *);
void           WoL2(int, xairo_uchar *, int, sara_long *, sara_long *);
void           GetDictEntry(FILE *, sara_long, xairo_uchar *, int, sara_long *, sara_long *);
int            GetFirstDictEntry(xairo_uchar *);
xairo_uchar          *GetNextDictEntry();
int            NDirs(void);
int				ustrcmp(unsigned char*,unsigned char*);
int				uccmp(unsigned char,unsigned char);
extern unsigned int g_uc0;
char*          GetWordList(int);
xairo_uchar*          GetWordListW(int);
BOOL lemmata(char*,int,char*,BOOL);
BOOL initialise_lexrules(char*);
int LemmaNSchemes();
void LemmaSetScheme(int,BOOL);
int LemmaGetScheme();
const char* LemmaName(int);
char* LemmInfo();
void RefreshDict();
void QADSave(const char*);
void QADLoad(const char*);
void QADLims(const char*,int*,int*);
void LemmaEnable(int,char*);
BOOL LemmaIsEnabled(int);
void LemmaDescribe(int,char**);
BOOL LemmaTest(int,int,char*,char*,char*);
void SGMLFold(char*);
BOOL SGMLComp(const char*,const char*);
BOOL SGMLCompW(const char*,const xairo_uchar*);
int LocToDoc(sara_long pos,sara_ulong code);
int LocToDocW(sara_long pos,sara_ulong code);
void GetDocName(sara_ulong k, char *name);
xairo_uchar* Wide(const char* s);
void DW(xairo_uchar* w);
void MkNorm(xairo_uchar*);
void MkLC(xairo_uchar*);
int Tokenise(xairo_uchar*, xairo_uchar*);
BOOL StrComp(xairo_uchar,xairo_uchar,int);

BOOL           CLine(char *,int*);
void           BuildMerge(void);
int            AllocBuffers(int);
void           Bibliography(void);
int            IndexAdd(FILE *, sara_ulong);
BOOL           TestInterrupt(void);
void           trace(char *, char *,...);
void           MakeFrob(void);
void           ScratchFile(char *);
BOOL Tests();
BOOL ReadDescFile(char*);
BOOL omitted(char*);
struct regexpnew *ParseRegExp(const xairo_uchar *,BOOL);
BOOL pMatch(const xairo_uchar*,struct regexpnew *);

int CompareWord(int,int,int,int);
int ComparePos(int,int,int,int);
BOOL GetLims(FILE *f, sara_long i1, sara_long i2, const xairo_uchar *patt,
             sara_long *x1, sara_long *x2);

#endif /* CORPFUNS_H */

#ifdef __cplusplus
}
#endif
