/*
 * $Id: Corphash.c,v 1.4 2005-10-17 15:11:43 tonydodd Exp $
 *
 * $Log: not supported by cvs2svn $
 * Revision 1.4  1996/05/12 23:36:15  scotty
 * v927 fixes from Tony.
 *
 * Revision 1.3  1996/02/26 21:04:20  scotty
 * Removed some variable declarations that were never used in this
 * file. They're now in corpprm.c and corpserv.c.
 *
 * Revision 1.2  1996/02/14 22:01:04  scotty
 * GetDict() now abort()s under DOS rather than exit()ing.
 *
 * Revision 1.1  1996/01/30 20:48:12  scotty
 * Initial revision
 *
 */
#include "Corpinc.h"

#include "xarastruc0old.h"



struct locent  locs[MAXILOC0];
struct dicent  dict[MAXIDICT];
struct ihdr    header;

char           words[MAXIWORDS];

FILE          *fDict, *fDicta;
FILE			**fLocs;
FILE **fThread;
FILE		  *fStreamBase;
FILE			*fWL;	

char           corppath[_MAX_PATH];

sara_long      ndix;

struct xara_lemma_header dicthead;

void RefreshDict();
unsigned       hashchar(xairo_uchar);
int            idig(char);
void           CLBuff(char *);

sara_int nhash=nhash0;
sara_int nhashsig=nhashsig0;
sara_int hashshift=hashshift0;
sara_int hashlast=hashlast0;
int hashcharmask;
int hashlastmask;
int hashrange;
sara_int maxiloc=MAXILOC0;
sara_int npages=0;
sara_int maxiloct=MAXILOC0;
sara_int npagest=0;

int       ntexts;

#define MAXPART 10

#if !defined(_WIN32)
int       nroots = 3;
int       nroots2 = 3;

char      rpath[MAXPART][_MAX_PATH] = {
   "/corpus/Index/index0/",
   "/corpus/Index/index1/",
   "/corpus/Index/index2/"
};

char      rpath2[MAXPART][_MAX_PATH];
unsigned  rlim[MAXPART] = {200, 260};
unsigned  rlim2[MAXPART];
int       igran = 100;

#else /* ! __unix__ */

int       nroots = 1;
int       nroots2 = 1;

char      rpath[1][_MAX_PATH] = {
   "\\sgml\\index\\"
};

char      rpath2[MAXPART][_MAX_PATH];

unsigned  rlim[1] = {0};
unsigned  rlim2[MAXPART];

int       igran;

#endif /* __unix__ */

char      idpath[_MAX_PATH];


int NDirs(void)
{
   return (hashrange + igran - 1) / igran;
}


char *IndexRoot(unsigned i)
{
   int   j;

   for (j = 0; j < nroots - 1; j++)
      if (i < rlim[j])
         break;

   if (rpath[j][0] == 0)
      return NULL;
   return rpath[j];
}


char *IndexDir(unsigned i)
{
   int   i2;

   i2 = i / igran;
   if (IndexRoot(i2) == NULL)
      return NULL;
	if (i >= HASHPOS) 
	sprintf(idpath, "%spos%c", IndexRoot(i2), SEPCHAR);
	else 
	sprintf(idpath, "%s%03i%c", IndexRoot(i2), i2, SEPCHAR);

   return idpath;
}


unsigned hashval(char *s)
{
   unsigned  hc = 0,
             hd = 0;
   int       i;
   for (i = 0; i < nhashsig; i++) {
      if (s[i] == 0)
         return hc;

      hc += (hashchar(s[i]) & hashcharmask)
         << (hashshift * (nhashsig - i - 1) + hashlast);
   }

   while (i < nhash && s[i] != 0)
      hd += hashchar(s[i++]);

   hc += hd & hashlastmask;

   return hc;
}


unsigned hashchar(xairo_uchar c)
{
   return c & hashcharmask;
}


BOOL bMayHashChar(unsigned h, xairo_uchar c, int i)
{
   unsigned  k;

   if (i >= nhashsig)
      return TRUE;

   k = h >> (hashshift * (nhashsig - i - 1) + hashlast) & hashcharmask;

   return k == (hashchar(c) & hashcharmask);
}

int nlem=-1;

void GetDict(void)
{
	char  dpath[_MAX_PATH];
	char nm[20];
	sprintf(nm,"xdblemma%d",nlem+1);
   strcpy(dpath, idxpath);
   strcat(dpath, nm);

   if ((fDict = fopen(dpath, "r")) == 0) {
//	   m_server->Bootlog(L"The file xdblemma is missing\n");
		return;
	}
   fread(&dicthead, sizeof(dicthead), 1, fDict);
  	ndix=dicthead.ndix;
	strcpy(dpath, idxpath);
	strcat(dpath,"xdbdict");
	if ((fDict = fopen(dpath, "r")) == 0) {
//	   m_server->BootLog(L"The file xdbdict is missing\n");
		return;
	}
}                                            




#undef toupper
#define UC toupper

BOOL idcomp(char *s, char *prefix, char *code, WORDNO * id)
{
   long   local = 0;
   char *s0 = s;                   
   long locp=oldid?100:0x1000000;
   int mulfac=oldid?10:64;

   while (*code != 0) {
      if (*code != *s)
         break;
	  code++; s++;
	  }

   if (*code == 0)
      local = locp;
   else
      s = s0;

   while (*prefix != 0)
      if (UC(*(prefix++)) != UC(*(s++)))
         return FALSE;

   *id = 0;
   while (*s != 0)
      *id = (*id) * mulfac + idig(*(s++));
   *id += local;

   return TRUE;
}


int idig(char c)
{
   if (isdigit(c))
      return c - '0';
   if (isalpha(c))
      return toupper(c) - 'A' + 10;
   return 0;
}

#if !defined(_WIN32)

void assert (BOOL b)
{
}

_stricmp(const char *s1, const char *s2)
{
   return strcasecmp(s1, s2);
}

_strnicmp(char *s1,char* s2,int n)
{
	return strncasecmp(s1,s2,n);
}

_strlwr(char* s)
{
	while (*s)  {*s=tolower(*s); s++;}
}

_strupr(char *s)
{
   while (*s != 0) {
      *s = toupper(*s);
      s++;
   }
}

int min(int m,int n)
{
	if (m<n) return m; else return n;
}

#endif

void IndexFile(int h, int k, char *path)
{
if (oldnames)
  sprintf(path,"%s%i.H%i",IndexDir(h),h,k);
else
	sprintf(path,"%s%iX%i.sid",IndexDir(h),h,k);
}


FILE *Accelerated(xairo_uchar *word, int type, int extra)
{
   int   i;
   char  path[_MAX_PATH];

   for (i = 0; i < nacc; i++)
      if (!wcscmp(word, acctab[i].word) && acctab[i].type == type
          && acctab[i].extra == extra)
         break;

   if (i == nacc)
      return NULL;

   sprintf(path, "%s%i.acc", etcpath, i);

   return fopen(path, "w");
}

unsigned int g_uc0;

int uccmp(unsigned char c1,unsigned char c2)
{
	if (c1==g_uc0) c1=1;
	if (c2==g_uc0) c2=1;
	return c1-c2;
}

int ustrcmp(unsigned char* s1,unsigned char* s2)
{
	int k;
	do {
		unsigned char c1=*s1;
		unsigned char c2=*s2;
		k=uccmp(c1,c2);
	} while (*s1++ && *s2++ && (k==0));
	return k;
}

/*
int qad[256*256];

void QADLoad(const char* path)
{
	FILE* f=fopen(path,"r");
	fread(qad,1,256*256*sizeof (int),f);
	fclose(f);
}

void QADLims(const xairo_uchar* s,int* l1,int* l2)
{
	int c1, c2; unsigned char x0, x1;
	if (s[0]==0) {
		*l1=0;
		*l1=ndix-1;
		return;
	}
	x0=s[0]; x1=s[1];
	if (x0==g_uc0) x0=1;
	if (x1==g_uc0) x1=1;
	c1=x0*256+x1;
	c2=x1?x0*256+x1+1:(x0+1)*256;
	*l1=qad[c1];
	*l2=qad[c2]-1;
}
*/


void SGMLFold(char* s)
{
//	if (bNameCase) return;
//	_strupr(s);
}

BOOL SGMLComp(const char* a,const char* b)
{
	return !strcmp(a,b);
//	if (bNameCase) return !strcmp(a,b);
//	return !_stricmp(a,b);
}

BOOL SGMLCompW(const char* a,const xairo_uchar* b)
{
	xairo_uchar* aa=Wide(a);
	BOOL bb=!wcscmp(aa,b);
	DW(aa);
	return bb;
}

sara_int letobe2(sara_int x)
{
	return ((x & 0xff) << 8) | ((x >> 8) & 0xff);
}

sara_long letobe4(sara_long x)
{
	return (letobe2((sara_int) (x & 0xffff)) << 16) | (letobe2((sara_int) (x >> 16)) & 0xffff);
}

