/*
 * $Id: Corpqy.cpp,v 1.7 2005-12-30 12:36:20 tonydodd Exp $
 *
 * $Log: not supported by cvs2svn $
 * Revision 1.4  1996/05/12 23:36:15  scotty
 * v927 fixes from Tony.
 *
 * Revision 1.3  1996/03/01 23:52:17  scotty
 * Changed MAXSIG to MAX_SIG since MAXSIG is defined by Solaris.
 *
 * Revision 1.2  1996/02/14 22:01:04  scotty
 * Some fixes by Tony.
 *
 * Revision 1.1  1996/01/30 20:47:53  scotty
 * Initial revision
 *
 */
#include "Corpinc.h"

extern "C" {

//#define CASE_KLUDGE


#define SERVER 1

#define MAXCODE 0x1000000L
#define MAXPOS 0x1000000L

sara_long      nload = 0;
BOOL           bStreamErr;

BOOL           LookUpWord(struct lookup *, int);
void           GetPos(struct lookup *);
BOOL           GetPos1(struct lookup *, int, int);
void           MakeSigDesc(int, int, char *);
void           SimpleQuery(void);
BOOL           SetPos(struct stream *);
BOOL           SetPosEnd(struct stream *);
BOOL           CalcK(struct stream *, int *, int *);
int            ReadIndex(int);
int            ReadIndexFile(FILE *, int);
int            ReadStreamIndex(struct stream *, int);
int            FreeBuffer(void);
void           SetLimits(struct stream *, sara_long, sara_ulong);
void           SetLimitsW(struct stream *, WORDNO, sara_ulong);
void           NormSpaces(char *);
BOOL           SameAttribute(xairo_uchar *, xairo_uchar *, xairo_uchar *, xairo_uchar *, xairo_uchar *);
struct stream *MakeAttributeStream(char*, char*, char*, char*);
struct stream *MakeAttributeStreamW(xairo_uchar*, xairo_uchar*, xairo_uchar*, xairo_uchar*);

int            GetWords(char *, char[][MAXWORD]);
BOOL           poscmp(sara_ulong, sara_long, sara_ulong, sara_long);
BOOL           WAdStream(struct stream *, sara_ulong, WORDNO, int, BOOL);
BOOL           WAdStreamp(struct stream *, sara_ulong, sara_long, BOOL);
BOOL           WAdStreamb(struct stream *, sara_ulong, WORDNO, int, BOOL);
BOOL           WAdStreambp(struct stream *, sara_ulong, sara_long, BOOL);
void           FreeStreams(void);
void           PhraseQuery(void);
void           SaveStreamPos(struct stream *);
void           RestoreStreamPos(struct stream *);
void           Subquery(void);
void           SaveQuery(void);
void           SaveSubCorpus(void);
void           LoadQuery(void);
void           QueryOptions(void);
BOOL           bFilterCase(sara_long, sara_ulong, xairo_uchar *, int, int);
BOOL           RegressStream(struct stream *);
BOOL           Get1Att(char *, sara_ulong, int, WORDNO *);
BOOL		Get1AttText(sara_ulong,xairo_uchar*,xairo_uchar*,xairo_uchar*);
BOOL		Get1Val(sara_ulong,xairo_uchar*,xairo_uchar*,xairo_uchar*,xairo_uchar*);

BOOL           Get1Elt(sara_ulong, xairo_uchar *, xairo_uchar *,int);
BOOL           GetNElt(sara_ulong, const xairo_uchar *, xairo_uchar *,int,int);
BOOL           bIDValOK(struct stream *s);
struct stream *AccelerateStream(char *, int, int, sara_ulong);
struct stream *AccelerateStreamW(xairo_uchar *, int, int, sara_ulong);
BOOL           GetAccels(void);
void           LoadAccel(int);
BOOL           TestSpan(struct stream *);
struct stream* PCQStream(char* ,char* ,char* ,WORDNO );
BOOL TestSubCorpus(sara_ulong);
BOOL TestSubCorpus2(sara_ulong,int,int);
int FindSubCorpus(const char*);
struct stream *MakeAttStream(const xairo_uchar *elt, const xairo_uchar *attname, xairo_uchar *val, typ it);
struct stream *MakeVarStream(xairo_uchar* elt,xairo_uchar* att,xairo_uchar* val,typ it);

int DicSB(const char*);
int LastIndex(struct stream*);
int ClassifyPOS(char*);

//#define LOGTHIS

#ifdef LOGTHIS
FILE* fLogThis=NULL;
#endif

int stricmp(const char*,const char*);
char* strupr(char*);
char* strlwr(char*);
struct stream  qs;
BOOL           bFilter;
int            filter[MAXSORTQUERY];
int            nfil;
sara_long      nuse = 0;
BOOL           bCase = FALSE;
BOOL           bHdr = FALSE;

int            BinChop(int, int, int, sara_long, WORDNO);
int            BinChopp(int, int, int, sara_long, sara_long);
int            BinChop1(int, int, int, sara_long, WORDNO);
int            BinChop1p(int, int, int, sara_long, sara_long);
int            BinChopb(int, int, int, sara_long, WORDNO);
int            BinChop1b(int, int, int, sara_long, WORDNO);
int            BinChopbp(int, int, int, sara_long, sara_long);
int            BinChop1bp(int, int, int, sara_long, sara_long);
void           FreeStream(struct stream *);
int            ReadSubCorpus(struct stream *);
BOOL			WordStream(struct stream*);

BOOL           bAutoAlloc = TRUE;

int            nba = 0;
int            nbt = 0;

BOOL           bTrace = FALSE;
             
#define NVARS 20                               

struct {
   BOOL      bSet;
   int       val;
   struct stream *setter;
} vars[NVARS];

struct menu qm = {
   "Query menu",
   10,
   {
      { MN_SQUERY,   "Simple query"    },
      { MN_PHRASE,   "Phrase"          },
      { MN_WORDLIST, "Word list"       },
      { MN_SUBQUERY, "Subquery"        },
      { MN_SAVE,     "Save query"      },
      { MN_SSC,      "Save subcorpus"  },
      { MN_LOAD,     "Load query"      },
      { MN_VIEW,     "View"            },
      { MN_OPTIONS,  "Search options"  },
      { MN_MAIN,     "Main menu" }
   }
};

struct menu sqm = {
   "Sub-query menu",
   3,
   {
      { MN_DISCARD,     "Discard unmarked"   },
      { MN_SELECTION,   "Selection"          },
      { MN_MAIN,        "Query menu"         }
   }
};

struct menu oqm = {
   "Search options menu",
   2,
   {
      { MN_CASE, "Case sensitive"   },
      { MN_MAIN, "Query menu"       }
   }
};

#if !defined(SERVER)

void QueryMenu(void)
{
   while (TRUE)
      switch (Menu(&qm)) {

       case MN_SQUERY:
         if (qs.type != 0)
            CloseQuery();
         SimpleQuery();
         MakeSortTab();
         break;

       case MN_PHRASE:
         if (qs.type != 0)
            CloseQuery();
         FullQuery();
         break;

       case MN_VIEW:
         if (qs.type == 0)
            printf("No query to view\n");
         else
            ViewMenu();
         break;

       case MN_SUBQUERY:
         Subquery();
         break;

       case MN_SAVE:
         SaveQuery();
         break;

       case MN_SSC:
         SaveSubCorpus();
         break;

       case MN_LOAD:
         if (qs.type != 0)
            CloseQuery();
         LoadQuery();
         break;

       case MN_OPTIONS:
         QueryOptions();
         break;

       case MN_WORDLIST:
         WordList();
         break;

       case MN_MAIN:
         return;
      }
}


void QueryOptions(void)
{
   while (TRUE) {
      switch (Menu(&oqm)) {

       case MN_CASE:
         bCase = !bCase;
         oqm.mi[0].item = bCase ? "Case insensitive" : "Case sensitive";
         break;

       case MN_MAIN:
         return;
      }
   }
}

void SimpleQuery(void)
{
   struct lookup  lur;
   int            i,
                  n;
   char           text[MAXMENUITEM];

   NewQuery();

   EditGetWord("Enter word: ", lur.word);
   strcpy(qs.xword, lur.word);

   if (!LookUpWord(&lur, 0)) {
      preproc(lur.word);
      if (!LookUpWord(&lur, 0)) {
         printf("%s not found in dictionary\n", lur.word);
         return;
      }
   }

   GetPos(&lur);
   qs.type = TY_ATOM;
   strcpy(qs.word, lur.word);

   i = lur.sel;
   qs.ihash = lur.ihash;
   qs.count = -1;
   qs.extra = lur.sig[i].extra;
   qs.wtype = lur.sig[i].type;
   qs.first = lur.sig[i].first;
   qs.ff = lur.sig[i].ff;
   qs.last = (i + 1 < lur.nsig) ? lur.sig[i + 1].first : lur.last;
   qs.lf = (i + 1 < lur.nsig) ? lur.sig[i + 1].ff : lur.lf;
   qs.lw = strlen(lur.word);
   qs.lw0=0;

   if (bCase && qs.wtype == ID_WORD)
      MakeCaseFilter();

   n = CountStream(&qs);
   MakeSigDesc(qs.wtype, qs.extra, text);

   printf("%s (%s)\n", qs.word, text);
   printf("%i instance%s found\n", n, (n > 1 ? "s" : ""));

   return;
}


#endif /* !SERVER */






int PosListW(xairo_uchar *w, int nsig[])
{
   struct lookup  lur;
   int            i,
                  j = 0;

   wcscpy(lur.word, w);
   if (!LookUpWord(&lur, 0))
      return 0;

   for (i = 0; i < lur.nsig; i++) {
	   int e; int ii;
	   if (lur.sig[i].type != ID_WORD || lur.sig[i].extra == HDRPOS) continue;
		e=lur.sig[i].extra%10000;
		for (ii=0;ii<j;ii++)
			if (nsig[ii]==e) break;
		if (ii<j) continue;
         nsig[j++] = e;
		 }

   return j;
}

int PosList(char *s, int nsig[])
{
	xairo_uchar* w=Wide(s);
	int k=PosListW(w,nsig);
	DW(w);
	return k;
}

#if !defined(SERVER)

void GetPos(struct lookup *lur)
{
   int            nps = 0;
   int            i;
   char           v[sizeof(struct menu) + (sizeof(char *)) *MAX_SIG];
   struct menu   *mnu = (struct menu *) v;
   char           title[MAXMENUTITLE];
   char           mdesc[MAX_SIG][MAXMENUITEM];

   lur->sel = 0;
   if (lur->nsig == 1)
      return;

   for (i = 0; i < lur->nsig; i++) {
      mnu->mi[i].code = i;
      MakeSigDesc(lur->sig[i].type, lur->sig[i].extra, mdesc[i]);
      mnu->mi[i].item = mdesc[i];
   }

   mnu->nitems = lur->nsig;
   sprintf(title, "Part of speech menu for %s", lur->word);
   mnu->title = title;
   lur->sel = Menu(mnu);
   return;
}

#endif /* ! SERVER */

BOOL GetPos1(struct lookup *lur, int extra, int type)
{
   int   i;

   for (i = 0; i < lur->nsig; i++)
      if (lur->sig[i].extra == extra && lur->sig[i].type == type)
         break;
   lur->sel = i;

   return i < lur->nsig;
}

/*
void  MakeSigDesc(int type, int extra, char *text)
{
   int   k,
         e,
         i;
   switch (type) {

    case ID_WORD:
      if (extra >= C6OFFSET) {
         k = 1;
         e = extra - C6OFFSET;
      } else {
         k = 0;
         e = extra;
      }
      sprintf(text, "%s", postab[k][e]);
      break;

    case ID_TAGO:
      sprintf(text, "SGML open tag");
      break;

    case ID_TAGE:
      sprintf(text, "SGML close tag");
      break;

    default:
      for (i = 0; i < natts; i++)
         if (atttab[i].val == type)
            break;
      if (i == natts)
         sprintf(text, "Unknown (%i)", type);
      else
         sprintf(text, "Attribute %s of %s", atttab[i].name,
                 atttab[i].element);
      break;
   }

   return;
}
*/

#if !defined(SERVER)

void PhraseQuery(void)
{
   struct stream *qso[MAXOPS];
   char           s[MAXWORD * MAXOPS];
   int            nw;
   char           w[MAXOPS][MAXWORD];
   int            i;
   int            n;

   NewQuery();
   FreeStreams();

   EditGetWord("Enter phrase: ", s);
   nw = GetWords(s, w);

   if (nw > MAXOPS) {
      printf("Too many words\n");
      return;
   }

   for (i = 0; i < nw; i++) {
      if (!strcmp(w[i], "*")) {
         qso[i] = GrabStream();
         qso[i]->type = TY_ALL;
         continue;
      }
      qso[i] = MakeAllPOSStream(w[i]);
   }

   qs.type = TY_SEQ;
   qs.lw = -1;
   qs.nw=nw-1;

   for (i = 0; i < nw; i++) {
      qs.op[i] = qso[i];
      qs.lw += qso[i]->lw + 1;
   }

   qs.ops = nw;
   strcpy(qs.word, s);
   qs.wtype = ID_ALLPOS;
   qs.count = -1;

   /*
    * qs.first=lur.sig[i].first; qs.ff=lur.sig[i].ff;
    * qs.last=(i+1<lur.nsig)?lur.sig[i+1].first:lur.last;
    * qs.lf=(i+1<lur.nsig)?lur.sig[i+1].ff:lur.lf;
    */
   n = CountStream(&qs);
   printf("%s\n", qs.word);
   printf("%i instance%s found\n", n, (n != 1 ? "s" : ""));
   return;
}


#endif /* ! SERVER */

struct stream *MakeCaseFilter(struct stream *s, xairo_uchar *w)
{
   struct stream *s1 = GrabStream();     
   if (s1==NULL) return NULL;

   s1->type = TY_CASE;
   s1->wc = s->wc;
   s1->op[0] = s;
   s1->ops = 0;
   wcscpy(s1->xword, w);
   return s1;
}




struct stream *MakeDictionaryStream(int k) // dead
{

	struct strb sb; int j; struct stream *s;
    struct stream *ops[MAX_SIG]; int n0=0;
	fseek(fStreamBase,k*sizeof sb,SEEK_SET);
	while (fread(&sb,sizeof sb,1,fStreamBase)) {
		struct stream *s1=GrabStream();
		if (s1==NULL) return NULL;
		fix_strb(&sb,1);
		ops[n0++] = s1;
		wcscpy(s1->word, GetWordListW(sb.word));
		wcscpy(s1->xword, GetWordListW(sb.word));
		s1->type = TY_ATOM;
		s1->ihash = sb.ihash;
		s1->extra = sb.extra;
		s1->wtype = sb.type;
		s1->first = sb.first;
		s1->ff = sb.ff;
		s1->last = sb.last;
		s1->lf = sb.lf;
		s1->count = -1;
		s1->wc = 1;
		s1->lw = wcslen(s1->word);
		s1->lw0=0;
		s1->frobpos=sb.frobpos;
		s1->frobno=sb.frobno;
		if (sb.bLast) break;
	}
	if (n0 == 1)
		return ops[0];

	s = GrabStream();
	if (s==NULL) return NULL;
	s->type = TY_OR;
	s->ops = n0;
	s->wc = 1;
	for (j = 0; j < n0; j++)
		s->op[j] = ops[j];
	return s;
}


struct stream *MakeAllPOSStreamW(const xairo_uchar *w, BOOL bH,BOOL bCase)
{
   struct stream *s;
   int            j;
   xairo_uchar           normw[MAXWORD + 1];
   int            n0 = 0;
   struct stream *ops[MAX_SIG];
   struct lookup  lur;

   wcscpy(lur.word, w);
	MkLC(lur.word);
   MkNorm(lur.word);

   wcscpy(normw, w);
	MkNorm(normw);
   if (!LookUpWord(&lur, 0))
   	  lur.nsig=0;

   for (j = 0; j < lur.nsig; j++) {
      struct stream *s1;

      if (lur.sig[j].type != it_content)
         continue;
      if (!bNoPos && lur.sig[j].extra == HDRPOS && !bHdr)
         continue;
	  if (bCase && wcscmp(normw,lur.sig[j].spell)!= 0) continue;
      s1 = GrabStream();

      if (!s1)
         return NULL;

      ops[n0++] = s1;
      wcscpy(s1->word, lur.word);
      wcscpy(s1->xword, w);
      s1->type = TY_ATOM;
      s1->ihash = lur.ihash;
      s1->extra = lur.sig[j].extra;
      s1->wtype = lur.sig[j].type;
      s1->first = lur.sig[j].first;
      s1->count = -1;
      s1->wc = 1;
      s1->ff = lur.sig[j].ff;
      s1->lw = wcslen(w);
	  s1->lw0=0;

      if (j + 1 < lur.nsig) {
         s1->last = lur.sig[j + 1].first;
         s1->lf = lur.sig[j + 1].ff;
      } else {
         s1->last = lur.last;
         s1->lf = lur.lf;
      }
   }
   if (n0 == 0) {
#if !defined(SERVER)
      printf("Word %s not in dictionary\n", w);
#endif /* ! SERVER */
      return NULL;
   }

   if (n0 == 1)
      return ops[0];

   s = GrabStream();
   if (s==NULL) return NULL;
   wcscpy(s->xword, normw);
   s->type = TY_OR;
   s->ops = n0;
   s->wc = 1;

   for (j = 0; j < n0; j++)
      s->op[j] = ops[j];

   return s;
}


struct stream *MakePosStream2W(const xairo_uchar *w, const xairo_uchar* pos)
{
   struct stream *s;
   int            j;
   xairo_uchar           normw[MAXWORD + 1];
   int            n0 = 0;
   struct stream *ops[MAX_SIG];
   struct lookup  lur;

   wcscpy(lur.word, w);
   wcscpy(normw, lur.word);

   if (!LookUpWord(&lur, 0))
   	  lur.nsig=0;

   for (j = 0; j < lur.nsig; j++) {
      struct stream *s1;

      if (lur.sig[j].type != ID_WORD)
         continue;
//      if (lur.sig[j].extra%10000 != extra)
  //       continue;
      s1 = GrabStream();

      if (!s1)
         return NULL;

      ops[n0++] = s1;
      wcscpy(s1->word, lur.word);
      wcscpy(s1->xword, w);
      s1->type = TY_ATOM;
      s1->ihash = lur.ihash;
      s1->extra = lur.sig[j].extra;
      s1->wtype = lur.sig[j].type;
      s1->first = lur.sig[j].first;
      s1->count = -1;
      s1->wc = 1;
      s1->ff = lur.sig[j].ff;
      s1->lw = wcslen(w);
	  s1->lw0=0;

      if (j + 1 < lur.nsig) {
         s1->last = lur.sig[j + 1].first;
         s1->lf = lur.sig[j + 1].ff;
      } else {
         s1->last = lur.last;
         s1->lf = lur.lf;
      }
   }

   if (n0 == 1)
      return ops[0];

   s = GrabStream();
   if (s==NULL) return NULL;
   wcscpy(s->xword, w);
   s->type = TY_OR;
   s->ops = n0;
   s->wc = 1;

   for (j = 0; j < n0; j++)
      s->op[j] = ops[j];

   return s;
}


sara_long CountStream(struct stream *s)
{
   sara_long   n;
   sara_long   c;
   int         i;

   if (s->count >= 0)
      return s->count;

   switch (s->type) {

    case TY_ATOM:
      if (s->lf > s->ff)
         c = (  s->last + (maxiloc - s->first)
              + ((sara_long) maxiloc) * (s->lf - s->ff - 1));
      else
         c = s->last - s->first;
      break;

    case TY_OR:
      n = 0;
      for (i = 0; i < s->ops; i++)
         n += CountStream(s->op[i]);
      c = n;
      break;

    case TY_ALL:
      c = 0;                    /* cheat */
      break;

    default:
      n = 0;
      RewindStream(s);
      while (XAdvanceStream(s))
         n++;
      c = n;
      break;
   }

   s->count = c;
   return c;
}

sara_long XCountStream(struct stream *s)
{
   sara_long   n=0;
#ifdef LOGTHIS
   fLogThis=fopen("c:\\logthis.txt","w");
#endif
   RewindStream(s);
   while (XAdvanceStream(s))
         n++;
#ifdef LOGTHIS
   fclose(fLogThis);
   fLogThis=NULL;
#endif
   return n;
}


void ThrashStream(struct stream *s)
{
   RewindStream(s);
   while (AdvanceStream(s));
   return;
}


void RewindStream(struct stream *s)
{
   int   i;

   switch (s->type) {

    case TY_ATOM:               /* FALLTHROUGH */
    case TY_FILE:               /* FALLTHROUGH */
    case TY_SUBCORPUS:
      s->cursor = -1;
      SetPos(s);
      return;

    case TY_ALL:                /* FALLTHROUGH */
    case TY_NEG:
      s->wpos = -1;
      s->pos = 0;
      s->lcode = 0;
      return;

    default:
      s->wpos = -1;
      s->pos = 0;
      s->lcode = 0;

      for (i = 0; i < s->ops; i++)
         RewindStream(s->op[i]);

      return;
   }
}


void WindStream(struct stream *s)
{
   int   i;

   switch (s->type) {
    case TY_ATOM:               /* FALLTHROUGH */
    case TY_FILE:               /* FALLTHROUGH */
    case TY_SUBCORPUS:
      SetPosEnd(s);
      return;

    case TY_ALL:
      s->wpos = -1;
      s->pos = 0;
      s->lcode = 0;
      return;

    default:
      s->wpos = -1;
      s->pos = 0;
      s->lcode = 0;

      for (i = 0; i < s->ops; i++)
         WindStream(s->op[i]);

      return;
   }
}


BOOL XAdvanceStream(struct stream *s)
{
   int   i; 
   for (i = 0; i < NVARS; i++) {
      vars[i].bSet = FALSE;
      vars[i].setter = NULL;
   }

   
   while (AdvanceStream(s)) {
	   int d=LocToDoc(s->pos,s->lcode);
	   int b=TestSubCorpus(d);
#ifdef LOGTHIS
	   if (fLogThis && d==2) fprintf(fLogThis,"%d\t%d\n",s->lcode,s->pos);
#endif
	   if (b) return TRUE;
   }

   return FALSE;
}


void CopyProps(struct stream *s, int ii)
{
   s->pos = s->op[ii]->pos;
   s->wpos = s->op[ii]->wpos;
   s->lcode = s->op[ii]->lcode;
   s->lw = s->op[ii]->lw;
   s->lw0=s->op[ii]->lw0;
   s->wc = s->op[ii]->wc;
   s->frobno = s->op[ii]->frobno;
   s->pre=s->op[ii]->pre;
   s->nxt=s->op[ii]->nxt;
}                     

void FakePos(struct stream* s,sara_long p)
{
	if (s->type==TY_ALL) s->pos=p;
}	


BOOL IsMarkup(struct stream *s)
{
   return s->wtype != ID_WORD;
}




void NextWord(struct stream *s,int* i0,int* f0)
{
		*i0= s->wpos+s->wc;
		*f0=-1;
}

void PrevWord(struct stream *s, int* i1, int* f1, BOOL* b)
{
		*b=TRUE;
		*i1=s->wpos;
		*f1=-1;
}


BOOL AdvanceStream(struct stream *s)
{
   BOOL           b,
                  b1,
                  bAll;
   sara_ulong     maxcode;
   sara_long      maxpos;
   int            i,
                  ii;
   sara_ulong     mincode;
   sara_long      minpos;
   WORDNO         i0,
                  i1;
   int f0,f1;
   BOOL				bStrict;

   if (TestInterrupt())
      return FALSE;

   switch (s->type) {
    case TY_ATOM:               /* FALLTHROUGH */
    case TY_FILE:               /* FALLTHROUGH */
    case TY_SUBCORPUS:
      if (s->cursor >= CountStream(s))
         return FALSE;
      s->cursor++;
      return SetPos(s);

    case TY_ID: // better to clear settings globally
      if (vars[s->kvar].bSet && vars[s->kvar].setter != s) {
         do {
            if (!AdvanceStream(s->op[0]))
               return FALSE;
         } while (s->op[0]->wpos != vars[s->kvar].val);
      } else {
         if (!AdvanceStream(s->op[0]))
            return FALSE;
         vars[s->kvar].bSet = TRUE;
         vars[s->kvar].setter = s;
         vars[s->kvar].val = (int) s->op[0]->wpos;
      }
      CopyProps(s, 0);
      return TRUE;

    case TY_IDC:
      do
         if (!AdvanceStream(s->op[0]))
            return FALSE;
      while (!bIDValOK(s));
      CopyProps(s, 0);
      return TRUE;

    case TY_AND:
      while (TRUE) {
         maxcode = 0;
         maxpos = -1;
         ii = -1;
         for (i = 0; i < s->ops; i++) {
            if (!AdvanceStream(s->op[i]))
               return FALSE;
            if (poscmp(s->op[i]->lcode, s->op[i]->pos, maxcode, maxpos)) {
               maxcode = s->op[i]->lcode;
               maxpos = s->op[i]->pos;
               ii = i;
            }
         }

         for (i = 0; i < s->ops; i++) {
            if (i == ii)
               continue;
            if (!WAdStreamp(s->op[i], maxcode, maxpos, FALSE))
               return FALSE;
            if (s->op[i]->pos != maxpos || s->op[i]->lcode != maxcode)
               break;
         }

         if (i < s->ops)
            continue;
         CopyProps(s, 0);
         return TRUE;
      }

    case TY_OR:
      ii = -1;
      mincode = MAXCODE;
      minpos = MAXPOS;
      for (i = 0; i < s->ops; i++) {
         if (   !poscmp(s->op[i]->lcode, s->op[i]->pos,
                        s->lcode, s->pos)
             || (s->op[i]->type == TY_ATOM && s->op[i]->cursor == -1))
            if (!AdvanceStream(s->op[i]))
               continue;
         if (poscmp(mincode, minpos, s->op[i]->lcode, s->op[i]->pos)) {
            ii = i;
            mincode = s->op[i]->lcode;
            minpos = s->op[i]->pos;
         }
      }

      if (ii < 0)
         return FALSE;

      s->pos = s->op[ii]->pos;
      s->wpos = s->op[ii]->wpos;
      s->pre = s->op[ii]->pre;
      s->nxt = s->op[ii]->nxt;
      s->lcode = s->op[ii]->lcode;
      s->lw = s->op[ii]->lw;
	  s->lw0=s->op[ii]->lw0;
      s->wc = s->op[ii]->wc;
	  s->frobno=s->op[ii]->frobno;
      return TRUE;

    case TY_ALL:                /* FALLTHROUGH */
    case TY_NEG:
      s->wpos++;
      return TRUE;

    case TY_SEQ:
      bAll = TRUE;
      for (i = 0; i < s->ops; i++) {
         if (s->op[i]->bOptional)
            if (s->op[i]->cursor == -1)
               AdvanceStream(s->op[i]);
            else;
         else
            bAll &= AdvanceStream(s->op[i]);
      }

    xd:

      if (!bAll)
         return FALSE;
      maxcode = 0;
      maxpos = 0;
      ii = -1;
      for (i = 0; i < s->ops; i++)
         if (!s->op[i]->bOptional && s->op[i]->type != TY_NEG
             && poscmp(s->op[i]->lcode, s->op[i]->pos,
                       maxcode, maxpos)) {
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
            ii = i;
         }
//      wi = s->op[ii]->wpos;
      b = TRUE;
      if (bTrace)
         trace("SEQ", "Stream %d wins at %ld, %ld",
               ii, maxcode, maxpos);
//      i0 = wi + s->op[ii]->wc;
		NextWord(s->op[ii],&i0,&f0);
      for (i = ii + 1; i < s->ops; i++) {
         BOOL  b2;

         b1 = b2 = WAdStream(s->op[i], maxcode, i0, f0, FALSE);     
         if (b1) FakePos(s->op[i],s->op[i-1]->pos+1);
         b1 &= (s->op[i]->wpos == i0) && (s->op[i]->lcode == maxcode)
             && (s->op[i]->pos>s->op[i - 1]->pos) ; 
         if (bTrace)
            if (b1)
               trace("SEQ", "Fitted %d", i);
            else
               trace("SEQ", "Failed fit %d", i);
         if (!b1 && s->op[i]->bOptional)
            continue;
         b &= b1;
         bAll &= b2;
         if (b)
            NextWord(s->op[i],&i0,&f0);
      }
      PrevWord(s->op[ii],&i1,&f1,&bStrict);

      for (i = ii - 1; i >= 0; i--) {
         BOOL  b2;

         b1 = b2 = WAdStream(s->op[i], maxcode, i1, f1, bStrict);
         if (b1) FakePos(s->op[i],s->op[i+1]->pos-1);
         if (bTrace)
            if (b1)
               trace("SEQ", "Fitted %d", i);
            else
               trace("SEQ", "Failed fit %d", i);
			b1 &= (s->op[i]->wpos + (bStrict?s->op[i]->wc:0) == i1)
            && (s->op[i]->lcode == maxcode)
            && (s->op[i]->pos<s->op[i + 1]->pos);

         if (!b1 && s->op[i]->bOptional)
            continue;
         b &= b1;
         bAll &= b2;
         if (b)
//            i1 -= s->op[i]->wc;
				PrevWord(s->op[i],&i1,&f1,&bStrict);
      }

      if (!b) {
         bAll &= AdvanceStream(s->op[ii]);
         goto xd;
      }
      s->pos = s->op[0]->pos;
      s->wpos = s->op[0]->wpos;
      s->lcode = s->op[0]->lcode;
      s->lw = (int) ((s->op[LastIndex(s)]->pos) - (s->op[0]->pos)) // omg!
         + (s->op[LastIndex(s)]->lw);
//	  if (s->lw >MAXHIT) s->lw=MAXHIT; 
	  s->lw0= (int) ((s->op[LastIndex(s)]->pos) - (s->op[0]->pos));
      s->wc = (int) (i0 - i1);
	  s->pre=s->op[0]->pre;
	  s->nxt=s->op[LastIndex(s)]->nxt;
      return TRUE;

    case TY_LIMIT:
      if (s->limtype == LT_SGML) {
         while (AdvanceStream(s->op[0])) {
            SetLimits(s->limit1, s->op[0]->pos, s->op[0]->lcode);
            SetLimits(s->limit2, s->op[0]->pos, s->op[0]->lcode);
            WindStream(s->limit1);
			RewindStream(s->limit2); /* new */

            if (!WAdStreambp(s->limit1, s->op[0]->lcode,
                             s->op[0]->pos, FALSE))
               continue;
            RewindStream(s->limit2);
            if (!WAdStreamp(s->limit2, s->limit1->lcode,
                            s->limit1->pos+1, FALSE))
               continue;
            if (s->limit2->lcode != s->op[0]->lcode ||
                s->limit2->pos < s->op[0]->pos)
               continue;
            s->pos = s->op[0]->pos;
            s->wpos = s->op[0]->wpos;
            s->lcode = s->op[0]->lcode;
            s->lw = s->op[0]->lw;
            s->lw0 = s->op[0]->lw0;
            s->wc = s->op[0]->wc;
            return TRUE;
         }

         return FALSE;
      } else {                  /* SGML outside */
         while (AdvanceStream(s->op[0])) {
            WORDNO      w0,
                        wlim;
            sara_ulong  lc;

            lc = s->op[0]->lcode;

            WindStream(s->limit1);
            if (   !WAdStreamb(s->limit1, lc, s->op[0]->wpos, -1, FALSE)
                || s->limit1->lcode != lc)
               w0 = 0;
            else
               w0 = s->op[0]->wpos;
            RewindStream(s->limit2);

            if (   !WAdStream(s->limit2, lc, w0, -1, FALSE)
                || s->limit2->lcode != lc)
               wlim = 0xfffffff;
            else
               wlim = s->limit2->wpos;

            if (s->op[0]->wpos > wlim)
               continue;
            s->pos = s->op[0]->pos;
            s->wpos = s->op[0]->wpos;
            s->lcode = s->op[0]->lcode;
            s->lw = s->op[0]->lw;
            s->lw0 = s->op[0]->lw0;
            s->wc = s->op[0]->wc;
			s->pre = s->op[0]->pre;
			s->nxt = s->op[0]->nxt;
            return TRUE;
         }

         return FALSE;
      }

    case TY_PROD:
      if (s->limtype == LT_SGML)
         RewindStream(s->limit2);
      while (TRUE) {
         WORDNO      w0,
                     wx,
                     wlim;
         BOOL        bOK;
         int         ni = 0;
         int         nd;
         sara_long   p0;
         sara_long   px;
         sara_long   plim;
         sara_ulong  maxcode;
         WORDNO      maxw;
         int         ii;
      /* sara_ulong  nt; */

         bOK = FALSE;
         maxcode = 0;
         maxw = 0;
         ii = -1;

         /* Advance the last stream, which is the solution value. */

         if (!AdvanceStream(s->op[s->ops - 1]))
            return FALSE;

         /* Use the result to fix the limit values */
         switch (s->limtype) {

          case LT_SGML:
            maxcode = s->op[s->ops - 1]->lcode;
            px = s->op[s->ops - 1]->pos;
            SetLimits(s->limit1, px, maxcode);
            SetLimits(s->limit2, px, maxcode);
            WindStream(s->limit1);
			RewindStream(s->limit2); /* new */
            if (!WAdStreambp(s->limit1, maxcode, px, FALSE))
               break;

            wx = w0 = s->limit1->wpos;
            p0 = s->limit1->pos;
            nd = 1;

            if (!WAdStreamp(s->limit2, maxcode, p0 + 1, FALSE))
               break;

            plim = s->limit2->pos;
            wlim = s->limit2->wpos;

            if (s->limit2->lcode != maxcode || plim < px)
               break;

            bOK = TRUE;
            break;

          case LT_XSGML:
            WindStream(s->limit1);
            if (   !WAdStreamb(s->limit1, maxcode, maxw, -1, FALSE)
                || s->limit1->lcode != maxcode)
               w0 = 0;
            else
               w0 = s->limit1->wpos;

            if (   !WAdStream(s->limit2, maxcode, w0 + 1, -1, FALSE)
                || s->limit2->lcode != maxcode)
               wlim = 0x7fffffff;
            else {
               wlim = s->limit2->wpos;
               if (wlim < maxw)
                  break;
            }

            bOK = TRUE;
            break;

          case LT_NULL:
            p0 = 0;
            plim = 0x7fffffff;
            maxcode = s->op[s->ops - 1]->lcode;
            bOK = TRUE;
            break;

          case LT_INT:
            p0 = 0;
            plim = 0x7fffffff;
            maxcode = s->op[s->ops - 1]->lcode;
            w0 = s->op[s->ops - 1]->wpos - s->limint;
            wlim = s->op[s->ops - 1]->wpos;
            bOK = TRUE;
         }

         if (!bOK)
            continue;
         /* Now fit all the other streams in backwards */
         if (   s->op[s->ops - 1]->lcode != maxcode
             || s->op[s->ops - 1]->pos > plim)
            continue;

         for (i = s->ops - 2; i >= 0; i--) {
            WindStream(s->op[i]);
            if (   !WAdStreambp(s->op[i], s->op[i + 1]->lcode,
                                s->op[i + 1]->pos - 1, FALSE))
               break;

            if (s->op[i]->lcode != maxcode ||
                s->op[i]->pos < p0)
               break;

            if (s->limtype == LT_INT && s->op[i]->wpos <= w0)
               break;

            if (s->limtype == LT_SGML && s->op[i]->pos > s->limit2->pos)
               break;
         }

         if (i >= 0)
            continue;

         s->pos = s->op[s->ops - 1]->pos;
         s->wpos = s->op[s->ops - 1]->wpos;
         s->pre = s->op[s->ops - 1]->pre;
         s->nxt = s->op[s->ops - 1]->nxt;
         s->lcode = s->op[s->ops - 1]->lcode;
         s->lw = s->op[s->ops - 1]->lw;
         s->lw0 = s->op[s->ops - 1]->lw0;
         s->wc = (int) (  s->op[s->ops - 1]->wc
                        + s->op[s->ops - 1]->wpos - s->wpos);
         return TRUE;
      }

      return FALSE;

    case TY_BPROD:
      if (s->limtype == LT_SGML)
         RewindStream(s->limit2);

      while (TRUE) {
         WORDNO      w0,
                     wx,
                     wlim;
         BOOL        bOK;
         int         ni = 0;
         int         nd;
         sara_long   p0;
         sara_long   px;
         sara_long   plim;
         sara_ulong  maxcode;
         WORDNO      maxw;
         int         ii;
      /* sara_ulong  nt; */

         bOK = FALSE;
         maxcode = 0;
         maxw = 0;
         ii = -1;

         /* Advance the last stream, which is the solution value. */
         if (!AdvanceStream(s->op[s->ops - 1]))
            return FALSE;

         /* Use the result to fix the limit values */
         switch (s->limtype) {

          case LT_SGML:
            maxcode = s->op[s->ops - 1]->lcode;
            px = s->op[s->ops - 1]->pos;
            SetLimits(s->limit1, px, maxcode);
            SetLimits(s->limit2, px, maxcode);
            WindStream(s->limit1);
   			RewindStream(s->limit2); /* new */


            if (!WAdStreambp(s->limit1, maxcode, px, FALSE))
               break;

            wx = w0 = s->limit1->wpos;
            p0 = s->limit1->pos;
            nd = 1;

            if (!WAdStreamp(s->limit2, maxcode, p0 + 1, FALSE))
               break;

            plim = s->limit2->pos;
            wlim = s->limit2->wpos;

            if (s->limit2->lcode != maxcode || plim < px)
               break;

            bOK = TRUE;
            break;

          case LT_XSGML:
            WindStream(s->limit1);
            if (   !WAdStreamb(s->limit1, maxcode, maxw, -1, FALSE)
                || s->limit1->lcode != maxcode)
               w0 = 0;
            else
               w0 = s->limit1->wpos;

            if (   !WAdStream(s->limit2, maxcode, w0 + 1, -1, FALSE)
                || s->limit2->lcode != maxcode)
               wlim = 0x7fffffff;
            else {
               wlim = s->limit2->wpos;
               if (wlim < maxw)
                  break;
            }

            bOK = TRUE;
            break;

          case LT_NULL:
            p0 = 0;
            plim = 0x7fffffff;
            maxcode = s->op[s->ops - 1]->lcode;
            bOK = TRUE;
            break;

          case LT_INT:
            p0 = 0;
            plim = 0x7fffffff;
            maxcode = s->op[s->ops - 1]->lcode;
            w0 = s->op[s->ops - 1]->wpos - s->limint;
            wlim = s->op[s->ops - 1]->wpos + s->limint;
            bOK = TRUE;
         }
         if (!bOK)
            continue;

         /* Now fit all the other streams in backwards */
         if (   s->op[s->ops - 1]->lcode != maxcode
             || s->op[s->ops - 1]->pos > plim)
            continue;

         for (i = s->ops - 2; i >= 0; i--) {
            WindStream(s->op[i]);
            if (s->limtype == LT_INT)
               if (!WAdStreamb(s->op[i], maxcode, wlim, -1, FALSE))
                  break;
               else;
            else if (!WAdStreambp(s->op[i], maxcode, plim, FALSE))
               break;

            if (   s->op[i]->lcode != maxcode
                || s->op[i]->pos < p0)
               break;
            if (s->limtype == LT_INT && s->op[i]->wpos < w0)
               break;
         }

         if (i >= 0)
            continue;
         if (s->limtype == LT_INT && !TestSpan(s))
            continue;
         s->pos = s->op[s->ops - 1]->pos;
         s->wpos = s->op[s->ops - 1]->wpos;
         s->pre = s->op[s->ops - 1]->pre;
         s->nxt = s->op[s->ops - 1]->nxt;
         s->lcode = s->op[s->ops - 1]->lcode;
         s->lw = s->op[s->ops - 1]->lw;
         s->lw0 = s->op[s->ops - 1]->lw0;
         s->wc = (int) (  s->op[s->ops - 1]->wc
                        + s->op[s->ops - 1]->wpos - s->wpos);
         return TRUE;
      }

      return FALSE;

    case TY_CASE:
		assert(FALSE);
      do
         if (!AdvanceStream(s->op[0]))
            return FALSE;
      while (!bFilterCase(s->op[0]->pos, s->op[0]->lcode,
                          s->xword, s->op[0]->frobpos, s->op[0]->lw));
      CopyProps(s, 0);
      return TRUE;
   }
   return TRUE; // unused
}


BOOL TestSpan(struct stream *s)
{
   int         nw;
   int         n;
   int         i;
   sara_long   imax;
   sara_long   imin;

   nw = s->limint;
   n = s->ops;
   imax = 0;
   imin = 0x7fffffff;

   for (i = 0; i < n; i++) {
      if (s->op[i]->wpos > imax)
         imax = s->op[i]->wpos;
      if (s->op[i]->wpos < imin)
         imin = s->op[i]->wpos;
   }

   return imax - imin + 1 <= nw;
}


BOOL bIDValOK(struct stream *s)
{
	return wcscmp(s->skval,GetWordListW(s->op[0]->wpos))==0;
}


BOOL RegressStream(struct stream *s)
{
   switch (s->type) {
    case TY_ATOM:               /* FALLTHROUGH */
    case TY_FILE:               /* FALLTHROUGH */
    case TY_SUBCORPUS:
      s->cursor--;
      return SetPos(s);

    default:
      return FALSE;
   }
}


void CloseQuery()
{
   switch (qs.type) {
    case TY_FILE:
      KillFileBuffers(qs.handle);
      fclose(qs.handle);
      break;
   }

   qs.type = 0;
   return;
}


BOOL poscmp(sara_ulong code1, sara_long pos1, sara_ulong code2,
            sara_long pos2)
{
	if (code1==MAXCODE) return TRUE;
	else if (code2==MAXCODE) return FALSE;
	return (ComparePos(code1,pos1,code2,pos2) > 0);
//   sara_long  i = code1 - code2;

//   return i > 0 || (i == 0 && pos1 > pos2);
}


int GetWords(char *s, char w[][MAXWORD])
{
   int   i = 0,
         j;

   while (i < MAXOPS) {
      while (isspace(*s) && *s != 0)
         s++;
      if (*s == 0)
         break;
      j = 0;
      while (!isspace(*s) && *s != 0)
         if (i < MAXOPS)
            w[i][j++] = *(s++);
      if (i < MAXOPS)
         w[i++][j] = 0;
      if (*s == 0)
         break;
   }

   return i;
}


#if !defined(_WIN32)
# define NSTREAMS 400
#else /* ! __unix__ */
# define NSTREAMS 400
#endif /* __unix__ */

static struct {
   BOOL      bUsed;
   struct stream s;
} ss[NSTREAMS];

struct stream *GrabStream(void)
{
   int   i;

   for (i = 0; i < NSTREAMS; i++)
      if (!ss[i].bUsed)
         break;

   if (i >= NSTREAMS) {
      bStreamErr = TRUE;
	  assert(FALSE);
      return NULL;
   }

   ss[i].bUsed = TRUE;
   ss[i].s.count = -1;
   ss[i].s.wtype = ID_WORD;
   ss[i].s.bOptional = FALSE;
   ss[i].s.limtype = LT_NULL;
   ss[i].s.ops = 0;
   ss[i].s.bFilter = FALSE;
   ss[i].s.cursor = -1;
   ss[i].s.frobpos = 0;
   ss[i].s.frobno = -1;
   ss[i].s.nw=0;
   ss[i].s.acc=-1;

   return &ss[i].s;
}


void FreeStreams(void)
{
   int   i;

   for (i = 0; i < NSTREAMS; i++)
      ss[i].bUsed = FALSE;

   return;
}


void FreeStream(struct stream *s)
{
   int   i;

   for (i = 0; i < NSTREAMS; i++)
      if (s == &ss[i].s)
         ss[i].bUsed = FALSE;

   return;
}

void FreeStreamR(struct stream* s)
{
	int i;
	for (i=0;i<s->ops;i++) 
		FreeStreamR(s->op[i]);
	FreeStream(s);
}


void SaveStreamPos(struct stream *s)
{
   int   i;

   for (i = 0; i < s->ops; i++)
      SaveStreamPos(s->op[i]);
   s->oldcursor = s->cursor;
   s->oldpos = s->pos;
   s->oldwpos = s->wpos;
   s->oldlcode = s->lcode;

   return;
}


void RestoreStreamPos(struct stream *s)
{
   int   i;

   for (i = 0; i < s->ops; i++)
      RestoreStreamPos(s->op[i]);
   s->cursor = s->oldcursor;
   s->pos = s->oldpos;
   s->wpos = s->oldwpos;
   s->lcode = s->oldlcode;

   return;
}


#if !defined(_WIN32)
# define NBUFF 1000
#else /* ! __unix__ */
# define NBUFF 400
#endif /* __unix__ */

#define MAXBUFFN 20000

union bpage {
   struct locent  locs[MAXILOC0];
   struct locent1 locs1[MAXILOC0];
};

union bpage   *b[MAXBUFFN];

struct {
   int      k;
   BOOL     bFile;
   union {
      int   hash;
      FILE *f;
   } owner;
   sara_long     use;
} buffercontrol[MAXBUFFN];

int AllocBuffers(int nb)
{
   int   i;
	if (nb >npages) nb=npages;
	if (nb > MAXBUFFN) nb=MAXBUFFN;
	if (nb < NBUFF) nb=NBUFF;
   bAutoAlloc = FALSE;
   for (i = 0; i < nb; i++) {
	   buffercontrol[i].use=-1;
      b[i + nba] = (union bpage *) malloc(sizeof(union bpage));
      if (b[i + nba] == NULL)
         break;
   }

   nbt = nb + nba;
   if (nbt<NBUFF) nbt=0;
   return nbt;
}

sara_ulong     scbuff[MAXSC];
FILE          *scbowner;

BOOL WAdStream(struct stream *s, sara_ulong cc, WORDNO w, int frobno, BOOL bEnd)
{
   int            kf;
   int            i;
   int            j;
   sara_long      n;
   int            kp;
   int            kq;
   WORDNO         lw;
   int            ii;
   sara_ulong     mincode;
   sara_ulong     maxcode;
   sara_long      minpos;
   sara_long      maxpos;
   BOOL           bb;

   switch (s->type) {

    case TY_ATOM:
      if (s->cursor == -1)
         AdvanceStream(s);

      if (bEnd && WordStream(s))
         w--;

	if (s->frobno != -1 && frobno != -1 && s->frobno < frobno) w++;
	if (CompareWord(s->lcode,s->wpos,cc,w) >= 0)
//	if ((s->wpos >= w && s->lcode == cc) || s->lcode > cc)
         return TRUE;

      CalcK(s, &kf, &kp);
      kp++;
      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf < s->lf) {
//         sara_long  ic = cc - b[i]->locs[maxiloc - 1].lcode;

//         lw = b[i]->locs[maxiloc - 1].word;
			if (CompareWord(b[i]->locs[maxiloc - 1].lcode,b[i]->locs[maxiloc - 1].word,cc,w) >= 0)
//		 if (ic < 0 || (ic == 0 && lw >= w))
            break;

         kf++;
         i = ReadStreamIndex(s, kf);
         n += maxiloc - kp;
         kp = 0;
      }
      kq = maxiloc;

      if (kf == s->lf) {
//         sara_long  ic = cc - b[i]->locs[s->last - 1].lcode;

//         lw = b[i]->locs[s->last - 1].word;
//         if (ic > 0 || (ic == 0 && lw < w))
			if (CompareWord(b[i]->locs[s->last - 1].lcode,b[i]->locs[s->last - 1].word,cc,w) < 0)
			 return FALSE;

         kq = s->last;
      }

      j = BinChop(i, kp, kq - 1, cc, w);
      n += j - kp + 1;
      s->cursor = n;
      return SetPos(s);

    case TY_FILE:
		assert(FALSE);
		if (s->cursor == -1)
         AdvanceStream(s);

      if (bEnd && WordStream(s))
         w--;

      if ((s->wpos >= w && s->lcode == cc) || s->lcode > cc)
         return TRUE;

      CalcK(s, &kf, &kp);
      kp++;
      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf < s->lf) {
         sara_long  ic = cc - b[i]->locs1[maxiloc - 1].lcode;

         lw = b[i]->locs1[maxiloc - 1].word;
         if (ic < 0 || (ic == 0 && lw >= w))
            break;
         kf++;
         i = ReadStreamIndex(s, kf); // this is appalling!
         n += maxiloc - kp;
         kp = 0;
      }
      kq = maxiloc;

      if (kf == s->lf) {
         sara_long  ic = cc - b[i]->locs1[s->last - 1].lcode;

         lw = b[i]->locs1[s->last - 1].word;
         if (ic > 0 || (ic == 0 && lw < w))
            return FALSE;
         kq = s->last;
      }
      j = BinChop1(i, kp, kq - 1, cc, w);
      n += j - kp + 1;
      s->cursor = n;
      SetPos(s);
      return TRUE;

    case TY_SUBCORPUS:
      i = ReadSubCorpus(s);
      for (j = 0; j < i; j++)
         if (scbuff[j] >= cc)
            break;
      if (j == i)
         return FALSE;
      s->cursor = j;
      SetPos(s);
      return TRUE;

    case TY_OR:
      ii = -1;
      mincode = MAXCODE;
      minpos = MAXPOS;
      for (i = 0; i < s->ops; i++) {
         if (!WAdStream(s->op[i], cc, w, frobno, bEnd))
            continue;
         if (poscmp(mincode, minpos, s->op[i]->lcode, s->op[i]->pos)) {
            ii = i;
            mincode = s->op[i]->lcode;
            minpos = s->op[i]->pos;
         }
      }

      if (ii < 0)
         return FALSE;
 /*     s->pos = s->op[ii]->pos;
      s->wpos = s->op[ii]->wpos;
      s->pre = s->op[ii]->pre;
      s->nxt = s->op[ii]->nxt;
      s->lcode = s->op[ii]->lcode;
	  s->frobno = s->op[ii]->frobno; */
	  CopyProps(s,ii);
      return TRUE;

    case TY_ALL:
      if (bEnd)
         w--;
      s->lcode = cc;
      s->wpos = w;
      s->wc = 1;
      return TRUE;

    case TY_NEG:
      if (bEnd)
         w--;
      SaveStreamPos(s->op[0]);

      while (WAdStream(s->op[0], cc, w, frobno, bEnd) && s->op[0]->wpos == w)
         w++;

      s->lcode = cc;
	  s->pos = 0x1000000L;

      s->wpos = w;
      s->wc = 1;
      RestoreStreamPos(s->op[0]);
      return TRUE;

    case TY_AND:

    xm:

      ii = 0;
      if (!WAdStream(s->op[0], cc, w, frobno, bEnd))
         return FALSE;

      maxcode = s->op[0]->lcode;
      maxpos = s->op[0]->pos;
      for (i = 1; i < s->ops; i++) {
         if (!WAdStreamp(s->op[i], s->op[0]->lcode, s->op[0]->pos, bEnd))
            return FALSE;

         if (poscmp(s->op[i]->lcode, s->op[i]->pos, maxcode, maxpos)) {
            ii = i;
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
         }
      }

      if (ii == -1)
         return FALSE;

      bb = TRUE;

      for (i = 0; i < s->ops; i++) {
         if (i == ii)
            continue;
         if (!WAdStreamp(s->op[i], s->op[ii]->lcode, s->op[ii]->pos, bEnd))
            return FALSE;
         bb &= (s->op[ii]->lcode == s->op[i]->lcode)
            && (s->op[ii]->pos == s->op[i]->pos);
      }

      if (!bb) {
         cc = s->op[ii]->lcode;
         w = s->op[ii]->wpos + 1;
         goto xm;
      }
      s->pos = s->op[0]->pos;
      s->wpos = s->op[0]->wpos;
      s->pre = s->op[0]->pre;
      s->nxt = s->op[0]->nxt;
      s->lcode = s->op[0]->lcode;
      s->wc = s->op[0]->wc;
      s->lw = s->op[0]->lw;
      s->lw0 = s->op[0]->lw0;

      return TRUE;

/*
 * These cases make no sense and must not be called.
 *
 *  case TY_IDC:
 *    wx = w;
 *    do {
 *       if (!WAdStream(s->op[0], cc, wx, bEnd))
 *          return FALSE;
 *       bOK = bIDValOK(s);
 *       wx = s->op[0]->wpos + 1;
 *    } while (!bOK);
 *
 *    CopyProps(s, 0);
 *    return TRUE;
 *
 *  case TY_ID:
 *    posx = pos;
 *    do {
 *       if (!WAdStreamp(s->op[0], cc, wx, bEnd))
 *          return FALSE;
 *       if (vars[s->kvar].bSet && vars[s->kvar].setter != s)
 *          bOK = s->op[0]->wpos == vars[s->kvar].val;
 *       else {
 *          vars[s->kvar].bSet = TRUE;
 *          vars[s->kvar].setter = s;
 *          vars[s->kvar].val = (int) s->op[0]->wpos;
 *          bOK=TRUE;
 *       }
 *       x = s->op[0]->wpos + 1;
 *    } while (!bOK);
 *
 *    CopyProps(s,0);
 *    return TRUE;
 *
 */                      
case TY_CASE:
	assert(FALSE);	 
	if (!WAdStream(s->op[0], cc, w, frobno, bEnd)) return FALSE;
    while (!bFilterCase(s->op[0]->pos, s->op[0]->lcode,
                          s->xword, s->op[0]->frobpos, s->op[0]->lw))
		if (!AdvanceStream(s->op[0])) return FALSE;
	CopyProps(s,0);
	return TRUE;	

default:
	assert(FALSE);
      corperr("Missing case", NULL);
      return FALSE;
   }
}


BOOL WAdStreamp(struct stream *s, sara_ulong cc, sara_long pos, BOOL bEnd)
{
   int            kf;
   int            i;
   int            j;
   sara_long      n;
   int            kp;
   int            kq;
   sara_long      lp;
   sara_long      posx;
   sara_ulong    cx;
   int            ii;
   sara_ulong     mincode;
   sara_ulong     maxcode;
   sara_long      minpos;
   sara_long      maxpos;
   BOOL           bOK;
   BOOL           bb;

   switch (s->type) {

    case TY_ATOM:
      if (s->cursor == -1)
         AdvanceStream(s);

/*
      if (bEnd && s->wtype==ID_WORD)
         w--;
 */
      if (s->lcode > cc)
         return FALSE;

      if (s->pos >= pos && s->lcode == cc)
         return TRUE;

      CalcK(s, &kf, &kp);
      kp++;
      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf < s->lf) {
//         sara_long  ic = cc - b[i]->locs[maxiloc - 1].lcode;

//         lp = b[i]->locs[maxiloc - 1].pos;
//         if (ic < 0 || (ic == 0 && lp >= pos))
			if (ComparePos(b[i]->locs[maxiloc - 1].lcode,b[i]->locs[maxiloc - 1].pos,cc,pos) >= 0)
			 break;

         kf++;
         i = ReadStreamIndex(s, kf);
         n += maxiloc - kp;
         kp = 0;
      }

      kq = maxiloc;

      if (kf == s->lf) {
//         sara_long  ic = cc - b[i]->locs[s->last - 1].lcode;

//         lp = b[i]->locs[s->last - 1].pos;
//         if (ic > 0 || (ic == 0 && lp < pos))
			if (ComparePos(b[i]->locs[s->last - 1].lcode,b[i]->locs[s->last - 1].pos,cc,pos) < 0)
            return FALSE;

         kq = s->last;
      }

      j = BinChopp(i, kp, kq - 1, cc, pos);
      n += j - kp + 1;
      s->cursor = n;
      return SetPos(s);

    case TY_ID:
      posx = pos;
      do {
         if (!WAdStreamp(s->op[0], cc, posx, bEnd))
            return FALSE;

         if (vars[s->kvar].bSet && vars[s->kvar].setter != s)
            bOK = s->op[0]->wpos == vars[s->kvar].val;
         else {
            vars[s->kvar].bSet = TRUE;
            vars[s->kvar].setter = s;
            vars[s->kvar].val = (int) s->op[0]->wpos;
            bOK = TRUE;
         }
         posx = s->op[0]->pos + 1;
      }

      while (!bOK);
      CopyProps(s, 0);
      return TRUE;

    case TY_IDC:
      posx = pos;     
      cx=cc;
      do {
         if (!WAdStreamp(s->op[0], cx, posx, bEnd))
            return FALSE;
         bOK = bIDValOK(s);
         posx = s->op[0]->pos + 1;     
         cx=s->op[0]->lcode;
      }

      while (!bOK);
      CopyProps(s, 0);
      return TRUE;

    case TY_FILE:
//		assert(FALSE);
      if (s->cursor == -1)
         AdvanceStream(s);

/*
      if (bEnd && s->wtype==ID_WORD)
         w--;
 */
      if ((s->pos >= pos && s->lcode == cc) || s->lcode > cc)
         return TRUE;

      CalcK(s, &kf, &kp);
      kp++;
      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf < s->lf) {
         sara_long  ic = cc - b[i]->locs1[maxiloc - 1].lcode;

         lp = b[i]->locs1[maxiloc - 1].pos;
         if (ic < 0 || (ic == 0 && lp >= pos))
            break;

         kf++;
         i = ReadStreamIndex(s, kf);
         n += maxiloc - kp;
         kp = 0;
      }

      kq = maxiloc;

      if (kf == s->lf) {
         sara_long  ic = cc - b[i]->locs1[s->last - 1].lcode;

         lp = b[i]->locs1[s->last - 1].pos;
         if (ic > 0 || (ic == 0 && lp < pos))
            return FALSE;
         kq = s->last;
      }

      j = BinChop1p(i, kp, kq - 1, cc, pos);
      n += j - kp + 1;
      s->cursor = n;
      SetPos(s);
      return TRUE;

    case TY_SUBCORPUS:
		assert(FALSE);
      i = ReadSubCorpus(s);

      for (j = 0; j < i; j++)
         if (scbuff[j] >= cc)
            break;

      if (j == i)
         return FALSE;

      s->cursor = j;
      SetPos(s);
      return TRUE;

    case TY_SEQ:
      {
         BOOL     b,
                  b1;
         BOOL     bAll;
         WORDNO   
                  i0,
                  i1;
		 int f0, f1;
		 BOOL bStrict;

         bAll = TRUE;
         for (i = 0; i < s->ops; i++) {
            if (s->op[i]->bOptional)
               if (s->op[i]->cursor == -1)
                  WAdStreamp(s->op[i], cc, pos, bEnd);
               else;
            else
               bAll &= WAdStreamp(s->op[i], cc, pos, bEnd);
         }

       xd:

         if (!bAll)
            return FALSE;

         maxcode = 0;
         maxpos = 0;
         ii = -1;

         for (i = 0; i < s->ops; i++)
            if (!s->op[i]->bOptional
                && poscmp(s->op[i]->lcode, s->op[i]->pos,
                          maxcode, maxpos)) {
               maxcode = s->op[i]->lcode;
               maxpos = s->op[i]->pos;
               ii = i;
            }

//         wi = s->op[ii]->wpos;
         b = TRUE;
//         i0 = wi + s->op[ii]->wc;
		 NextWord(s->op[ii],&i0,&f0);

         for (i = ii + 1; i < s->ops; i++) {
            BOOL  b2;

            b1 = b2 = WAdStream(s->op[i], maxcode, i0, f0, FALSE);
            if (b1) FakePos(s->op[i],s->op[i-1]->pos+1);
            b1 &= (s->op[i]->wpos == i0)
               && (s->op[i]->lcode == maxcode)
               && (s->op[i]->pos>s->op[i - 1]->pos);
            if (!b1 && s->op[i]->bOptional)
               continue;
            b &= b1;
            bAll &= b2;
            if (b)
               NextWord(s->op[ii],&i0,&f0);
         }
         PrevWord(s->op[ii],&i1,&f1,&bStrict);

         for (i = ii - 1; i >= 0; i--) {
            BOOL  b2;

            b1 = b2 = WAdStream(s->op[i], maxcode, i1, f1, bStrict);
         	if (b1) FakePos(s->op[i],s->op[i+1]->pos-1);

            if (bTrace)
               if (b1)
                  trace("SEQ", "Fitted %d", i);
               else
                  trace("SEQ", "Failed fit %d", i);
            b1 &= (s->op[i]->wpos + (bStrict?s->op[i]->wc:0) == i1)
               && (s->op[i]->lcode == maxcode)
               && (s->op[i]->pos<s->op[i + 1]->pos);
            if (!b1 && s->op[i]->bOptional)
               continue;
            b &= b1;
            bAll &= b2;
            if (b)
               PrevWord(s->op[i],&i1,&f1,&bStrict);;
         }

         if (!b) {
            bAll &= AdvanceStream(s->op[ii]);
            goto xd;
         }
         s->pos = s->op[0]->pos;
         s->wpos = s->op[0]->wpos;
         s->pre = s->op[LastIndex(s)]->pre;
         s->nxt = s->op[LastIndex(s)]->nxt;
         s->lcode = s->op[0]->lcode;
         s->lw = (int) (  (s->op[LastIndex(s)]->pos)
                        - (s->op[0]->pos)) + (s->op[LastIndex(s)]->lw);
         s->lw0 = (int) (  (s->op[LastIndex(s)]->pos)
                        - (s->op[0]->pos));
         s->wc = (int) (i0 - i1);
         return TRUE;
      }

    case TY_OR:
      ii = -1;
      mincode = MAXCODE;
      minpos = MAXPOS;

      for (i = 0; i < s->ops; i++) {
         if (!WAdStreamp(s->op[i], cc, pos, bEnd))
            continue;

         if (poscmp(mincode, minpos, s->op[i]->lcode, s->op[i]->pos)) {
            ii = i;
            mincode = s->op[i]->lcode;
            minpos = s->op[i]->pos;
         }
      }

      if (ii < 0)
         return FALSE;

/*      s->pos = s->op[ii]->pos;
      s->wpos = s->op[ii]->wpos;
      s->pre = s->op[ii]->pre;
      s->nxt = s->op[ii]->nxt;
      s->lcode = s->op[ii]->lcode;
	  s->frobno = s->op[ii]->frobno;
*/    
	  CopyProps(s,ii);
	  return TRUE;


    case TY_AND:

    xm:

      ii = -1;
      maxcode = 0;
      maxpos = 0;

      for (i = 0; i < s->ops; i++) {
         if (!WAdStreamp(s->op[i], cc, pos, bEnd))
            return FALSE;

         if (poscmp(s->op[i]->lcode, s->op[i]->pos, maxcode, maxpos)) {
            ii = i;
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
         }
      }

      if (ii == -1)
         return FALSE;

      bb = TRUE;

      for (i = 0; i < s->ops; i++) {
         if (i == ii)
            continue;

         if (!WAdStreamp(s->op[i], s->op[ii]->lcode, s->op[ii]->pos, bEnd))
            return FALSE;
         bb &= (s->op[ii]->lcode == s->op[i]->lcode)
            && (s->op[ii]->pos == s->op[i]->pos);
      }

      if (!bb) {
         cc = s->op[ii]->lcode;
         pos = s->op[ii]->pos + 1;
         goto xm;
      }

      s->pos = s->op[0]->pos;
      s->wpos = s->op[0]->wpos;
      s->pre = s->op[0]->pre;
      s->nxt = s->op[0]->nxt;
      s->lcode = s->op[0]->lcode;
      s->wc = s->op[0]->wc;
      s->lw = s->op[0]->lw;
      s->lw0 = s->op[0]->lw0;
      return TRUE;

    case TY_ALL:
/*
      if (bEnd)
         w--;
 */
      s->lcode = cc;
      s->pos = pos;
      s->wc = 1;
      return TRUE;

    case TY_NEG:
/*
      if (bEnd)
         w--;
 */
      SaveStreamPos(s->op[0]);

/*
      while (WAdStreamp(s->op[0],cc,pos,bEnd) && s->op[0]->wpos == w)
         w++;
 */
      s->lcode = cc;
      s->pos = pos;
      s->wc = 1;
      RestoreStreamPos(s->op[0]);
      return TRUE;

case TY_CASE:
	 assert(FALSE);
	if (!WAdStreamp(s->op[0], cc, pos, bEnd)) return FALSE;
    while (!bFilterCase(s->op[0]->pos, s->op[0]->lcode,
                          s->xword, s->op[0]->frobpos, s->op[0]->lw))
		if (!AdvanceStream(s->op[0])) return FALSE;
	CopyProps(s,0);
	return TRUE;	

    default:
      corperr("Missing case", NULL);
      return FALSE;
   }
}


int BinChop(int ip, int i1, int i2, sara_long cc, WORDNO w)
{
   int         i;
//   sara_long   c1;
   sara_long   c2;

   while (i2 > i1) {
      i = (i1 + i2) / 2;
//      c1 = b[ip]->locs[i].lcode - cc;

//      if (c1 > 0)
//         i2 = i;
//      else if (c1 == 0) {
//         c2 = b[ip]->locs[i].word - w;
	  c2=CompareWord(b[ip]->locs[i].lcode,b[ip]->locs[i].word,cc,w);
         if (c2 > 0)
            i2 = i;
         else if (c2 == 0)
            return i;
         else
            i1 = i + 1;
//      } else
  //       i1 = i + 1;
   }

   return i1;
}


int BinChopp(int ip, int i1, int i2, sara_long cc, sara_long pos)
{
   int         i;
//   sara_long   c1;
   sara_long   c2;

   while (i2 > i1) {
      i = (i1 + i2) / 2;
//      c1 = b[ip]->locs[i].lcode - cc;

//      if (c1 > 0)
//         i2 = i;
//      else if (c1 == 0) {
//         c2 = b[ip]->locs[i].pos - pos;
	  c2=ComparePos(b[ip]->locs[i].lcode,b[ip]->locs[i].pos,cc,pos);

	  if (c2 > 0)
            i2 = i;
         else if (c2 == 0)
            return i;
         else
            i1 = i + 1;
//      } else
  //       i1 = i + 1;
   }

   return i1;
}


int BinChop1(int ip, int i1, int i2, sara_long cc, WORDNO w)
{
   int         i;
   sara_long   c1;
   sara_long   c2;
	assert(FALSE);
   while (i2 > i1) {
      i = (i1 + i2) / 2;
      c1 = b[ip]->locs1[i].lcode - cc;

      if (c1 > 0)
         i2 = i;
      else if (c1 == 0) {
         c2 = b[ip]->locs1[i].word - w;
         if (c2 > 0)
            i2 = i;
         else if (c2 == 0)
            return i;
         else
            i1 = i + 1;
      } else
         i1 = i + 1;
   }

   return i1;
}


int BinChop1p(int ip, int i1, int i2, sara_long cc, sara_long pos)
{
   int         i;
   sara_long   c1;
   sara_long   c2;
//	assert(FALSE);
   while (i2 > i1) {
      i = (i1 + i2) / 2;
      c1 = b[ip]->locs1[i].lcode - cc;

      if (c1 > 0)
         i2 = i;
      else if (c1 == 0) {
         c2 = b[ip]->locs1[i].pos - pos;
         if (c2 > 0)
            i2 = i;
         else if (c2 == 0)
            return i;
         else
            i1 = i + 1;
      } else
         i1 = i + 1;
   }

   return i1;
}


int BinChopb(int ip, int i1, int i2, sara_long cc, WORDNO w)
{
   int         i;
//   sara_long   c1;
   sara_long   c2;

   while (i2 > i1) {
      i = (i1 + i2 + 1) / 2;
//      c1 = b[ip]->locs[i].lcode - cc;

//      if (c1 < 0)
//         i1 = i;
//      else if (c1 == 0) {
//         c2 = b[ip]->locs[i].word - w;
	  c2=CompareWord(b[ip]->locs[i].lcode,b[ip]->locs[i].word,cc,w);
         if (c2 < 0)
            i1 = i;
         else if (c2 == 0)
            return i;
         else
            i2 = i - 1;
//      } else
//         i2 = i - 1;
   }

   return i1;
}


int BinChopbp(int ip, int i1, int i2, sara_long cc, sara_long pos)
{
   int         i;
//   sara_long   c1;
   sara_long   c2;

   while (i2 > i1) {
      i = (i1 + i2 + 1) / 2;
//      c1 = b[ip]->locs[i].lcode - cc;

//      if (c1 < 0)
//         i1 = i;
//      else if (c1 == 0) {
//         c2 = b[ip]->locs[i].pos - pos;
	  c2=ComparePos(b[ip]->locs[i].lcode,b[ip]->locs[i].pos,cc,pos);
         if (c2 < 0)
            i1 = i;
         else if (c2 == 0)
            return i;
         else
            i2 = i - 1;
//      } else
//         i2 = i - 1;
   }

   return i1;
}


int BinChop1bp(int ip, int i1, int i2, sara_long cc, sara_long pos)
{
   int         i;
   sara_long   c1;
   sara_long   c2;
	assert(FALSE);
   while (i2 > i1) {
      i = (i1 + i2 + 1) / 2;
      c1 = b[ip]->locs1[i].lcode - cc;

      if (c1 < 0)
         i1 = i;
      else if (c1 == 0) {
         c2 = b[ip]->locs1[i].pos - pos;
         if (c2 < 0)
            i1 = i;
         else if (c2 == 0)
            return i;
         else
            i2 = i - 1;
      } else
         i2 = i - 1;
   }

   return i1;
}

int BinChop1b(int ip, int i1, int i2, sara_long cc, WORDNO w)
{
   int         i;
   sara_long   c1;
   sara_long   c2;
	assert(FALSE);
   while (i2 > i1) {
      i = (i1 + i2 + 1) / 2;
      c1 = b[ip]->locs1[i].lcode - cc;

      if (c1 < 0)
         i1 = i;
      else if (c1 == 0) {
         c2 = b[ip]->locs1[i].word - w;
         if (c2 < 0)
            i1 = i;
         else if (c2 == 0)
            return i;
         else
            i2 = i - 1;
      } else
         i2 = i - 1;
   }

   return i1;
}


BOOL WAdStreamb(struct stream *s, sara_ulong cc, WORDNO w, int frobno, BOOL bEnd)
{
   int            kf;
   int            i;
   int            j;
   sara_long      n;
   int            kp;
   int            kq;
   WORDNO         lw;
   int            ii;
   sara_ulong     maxcode;
   sara_long      maxpos;
   BOOL           bb;

   switch (s->type) {

    case TY_ATOM:
    	if (s->frobno != -1 && frobno != -1 && s->frobno < frobno && !bEnd ) w--;

//      if ((s->wpos <= w && s->lcode == cc) || s->lcode < cc)
		if (CompareWord(s->lcode,s->wpos,cc,w) <= 0) 
		  return TRUE;

      if (bEnd && WordStream(s))
         w--;

      CalcK(s, &kf, &kp);
      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf > s->ff) {
//         sara_long  ic = cc - b[i]->locs[0].lcode;

//         lw = b[i]->locs[0].word;
		if (CompareWord(b[i]->locs[0].lcode,b[i]->locs[0].word,cc,w) <= 0)
//         if (ic > 0 || (ic == 0 && lw <= w))
            break;

         kf--;
         i = ReadStreamIndex(s, kf);
         n -= kp;
         kp = maxiloc;
      }
      kq = 0;

      if (kf == s->ff) {
//         sara_long  ic = cc - b[i]->locs[s->first].lcode;

//         lw = b[i]->locs[s->first].word;
//         if (ic < 0 || (ic == 0 && lw > w))
		if (CompareWord(b[i]->locs[s->first].lcode,b[i]->locs[s->first].word,cc,w) > 0)
            return FALSE;
         kq = s->first;
      }

/*
      for (j = kp - 1; j >= kq; j--) {
         sara_long  ic = cc - b[i].locs[j].lcode;
         if (ic > 0 || (ic == 0 && b[i].locs[j].word <= w))
            break;
      }
 */

      j = BinChopb(i, kq, kp - 1, cc, w);
      n -= kp - j;
      s->cursor = n;
      SetPos(s);
      return TRUE;

case TY_FILE:
	assert(FALSE);
      if (s->cursor < CountStream(s))
         if ((s->wpos <= w && s->lcode == cc) || s->lcode < cc)
            return TRUE;
      CalcK(s, &kf, &kp);

      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf > s->ff) {
         sara_long  ic = cc - b[i]->locs1[0].lcode;

         lw = b[i]->locs1[0].word;
         if (ic > 0 || (ic == 0 && lw <= w))
            break;
         kf--;
         i = ReadStreamIndex(s, kf);
         n -= kp;
         kp = maxiloc;
      }
      kq = 0;

      if (kf == s->ff) {
         sara_long  ic = cc - b[i]->locs1[s->first].lcode;

         lw = b[i]->locs1[s->first].word;
         if (ic < 0 || (ic == 0 && lw > w))
            return FALSE;
         kq = s->first;
      }

      j = BinChop1b(i, kq, kp - 1, cc, w);
      n -= kp - j;
      s->cursor = n;
      SetPos(s);
      return TRUE;
    case TY_OR:
      ii = -1;
      maxcode = 0L;
      maxpos = 0L;

      for (i = 0; i < s->ops; i++) {
         SaveStreamPos(s->op[i]);
         if (!WAdStreamb(s->op[i], cc, w, frobno, FALSE))
            continue;

         if (poscmp(s->op[i]->lcode, s->op[i]->pos, maxcode, maxpos)) {
            ii = i;
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
         }
      }

      for (i = 0; i < s->ops; i++)
         if (i != ii)
            RestoreStreamPos(s->op[i]);

      if (ii == -1)
         return FALSE;
/*      s->pos = s->op[ii]->pos;
      s->wpos = s->op[ii]->wpos;
      s->pre = s->op[ii]->pre;
      s->nxt = s->op[ii]->nxt;
      s->lcode = s->op[ii]->lcode;
	  s->frobno = s->op[ii]->frobno; */
	  CopyProps(s,ii);
      return TRUE;

    case TY_SEQ:
      {
         BOOL     b,
                  b1;
         BOOL     bAll;
         WORDNO   
                  i0,
                  i1;
		 int f0, f1;
		 BOOL bStrict;

         bAll = TRUE;
         for (i = 0; i < s->ops; i++) {
            if (s->op[i]->bOptional)
               if (s->op[i]->cursor == -1)
                  WAdStreamb(s->op[i], cc, w, frobno, FALSE);
               else;
            else
               bAll &= WAdStreamb(s->op[i], cc, w, frobno, FALSE);
         }
       xd:
         if (!bAll)
            return FALSE;

         maxcode = MAXCODE;
         maxpos = MAXPOS;
         ii = -1;

         for (i = 0; i < s->ops; i++)
            if (   !s->op[i]->bOptional
                && poscmp(maxcode, maxpos, s->op[i]->lcode,
                          s->op[i]->pos)) {
               maxcode = s->op[i]->lcode;
               maxpos = s->op[i]->pos;
               ii = i;
            }

//        wi = s->op[ii]->wpos;
         b = TRUE;
//         i0 = wi + s->op[ii]->wc;
			NextWord(s->op[ii],&i0,&f0);
         for (i = ii + 1; i < s->ops; i++) {
            BOOL  b2;

            b1 = b2 = WAdStreamb(s->op[i], maxcode, i0, frobno, FALSE);
            if (b1) FakePos(s->op[i],s->op[i-1]->pos+1);
            
            b1 &= (s->op[i]->wpos == i0)
               && (s->op[i]->lcode == maxcode)
               && (s->op[i]->pos>s->op[i - 1]->pos);                  ;
            if (!b1 && s->op[i]->bOptional)
               continue;
            b &= b1;
            bAll &= b2;
            if (b)
               NextWord(s->op[ii],&i0,&f0);
         }
         PrevWord(s->op[ii],&i1,&f1,&bStrict);
         for (i = ii - 1; i >= 0; i--) {
            BOOL  b2;

            b1 = b2 = WAdStreamb(s->op[i], maxcode, i1, f1, bStrict);
         	if (b1) FakePos(s->op[i],s->op[i+1]->pos-1);

            if (bTrace)
               if (b1)
                  trace("SEQ", "Fitted %d", i);
               else
                  trace("SEQ", "Failed fit %d", i);
            b1 &= (s->op[i]->wpos + (bStrict?s->op[i]->wc:0) == i1)
               && (s->op[i]->lcode == maxcode)
               && (s->op[i]->pos<s->op[i + 1]->pos);
            if (!b1 && s->op[i]->bOptional)
               continue;
            b &= b1;
            bAll &= b2;
            if (b)
               PrevWord(s->op[i],&i1,&f1,&bStrict);
         }

         if (!b) {
            cc = s->op[ii]->lcode;
            w = s->op[ii]->wpos;    
            bAll &= WAdStreamb(s->op[ii],cc,w-1, f1, FALSE);

            goto xd;
         }
         s->pos = s->op[0]->pos;
         s->wpos = s->op[0]->wpos;
         s->pre = s->op[0]->pre;
         s->nxt = s->op[LastIndex(s)]->nxt;
         s->lcode = s->op[0]->lcode;
         s->lw = (int) (  (s->op[LastIndex(s)]->pos)
                        - (s->op[0]->pos)) + (s->op[LastIndex(s)]->lw);
         s->lw0 = (int) (  (s->op[LastIndex(s)]->pos)
                        - (s->op[0]->pos));
         s->wc = (int) (i0 - i1);
         return TRUE;
      }

    case TY_AND:

    xm:

      ii = -1;
      maxcode = MAXCODE;
      maxpos = MAXPOS;
      for (i = 0; i < s->ops; i++) {
         if (!WAdStreamb(s->op[i], cc, w, frobno, FALSE))
            continue;

         if (poscmp(maxcode, maxpos, s->op[i]->lcode, s->op[i]->pos)) {
            ii = i;
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
         }
      }

      if (ii == -1)
         return FALSE;

      bb = TRUE;
      for (i = 0; i < s->ops; i++) {
         if (i == ii)
            continue;

         if (!WAdStreamb(s->op[i], s->op[ii]->lcode, s->op[ii]->wpos, s->op[ii]->frobno, FALSE))
            return FALSE;
         bb &= (s->op[ii]->lcode == s->op[i]->lcode)
            && (s->op[ii]->wpos == s->op[i]->wpos);
      }

      if (!bb) {
         cc = s->op[ii]->lcode;
         w = s->op[ii]->wpos;
         goto xm;
      }
      s->pos = s->op[0]->pos;
      s->wpos = s->op[0]->wpos;
      s->pre = s->op[0]->pre;
      s->nxt = s->op[0]->nxt;
      s->lcode = s->op[0]->lcode;
      s->wc = s->op[0]->wc;
      return TRUE;

    case TY_ALL:
      s->lcode = cc;
      s->wpos = w;
      return TRUE;                  
    case TY_CASE:
		assert(FALSE);
			if (!WAdStreamb(s->op[0], cc, w, frobno, bEnd)) return FALSE;
    		while (!bFilterCase(s->op[0]->pos, s->op[0]->lcode,
                          s->xword, s->op[0]->frobpos, s->op[0]->lw))
				if (!RegressStream(s->op[0])) return FALSE;
			CopyProps(s,0);
			return TRUE;	


   }
	return TRUE; // unused
}


BOOL WAdStreambp(struct stream *s, sara_ulong cc, sara_long pos, BOOL bEnd)
{
   int            kf;
   int            i;
   int            j;
   sara_long      n;
   int            kp;
   int            kq;
   sara_long      lp;
   int            ii;
   sara_ulong     maxcode;
   sara_long      maxpos;
   BOOL           bb;
   sara_long      posx;
   sara_ulong     cx;
   BOOL           bOK;

   switch (s->type) {

    case TY_ATOM:
      pos -= s->frobpos;
      if (s->cursor < CountStream(s))
//         if ((s->pos <= pos && s->lcode == cc) || s->lcode < cc)
		if (ComparePos(s->lcode,s->pos,cc,pos) <= 0)
            return TRUE;

      CalcK(s, &kf, &kp);
      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf > s->ff) {
//         sara_long  ic = cc - b[i]->locs[0].lcode;

//         lp = b[i]->locs[0].pos;
//         if (ic > 0 || (ic == 0 && lp <= pos))
		if (ComparePos(b[i]->locs[0].lcode,b[i]->locs[0].pos,cc,pos) <= 0)
            break;
         kf--;
         i = ReadStreamIndex(s, kf);
         n -= kp;
         kp = maxiloc;
      }
      kq = 0;

      if (kf == s->ff) {
//         sara_long  ic = cc - b[i]->locs[s->first].lcode;

//         lp = b[i]->locs[s->first].pos;
//         if (ic < 0 || (ic == 0 && lp > pos))
		if (ComparePos(b[i]->locs[s->first].lcode,b[i]->locs[s->first].pos,cc,pos) > 0)
              return FALSE;
         kq = s->first;
      }

      j = BinChopbp(i, kq, kp - 1, cc, pos);
      n -= kp - j;
      s->cursor = n;
      SetPos(s);
      return TRUE;

    case TY_ID:

/*
      if (   s->op[0]->lcode < cc || s->op[0]->lcode == cc
          && s->op[0]->pos<pos)
          return TRUE;
 */
      if (!WAdStreambp(s->op[0], cc, pos, FALSE))
         return FALSE;

      if (s->op[0]->lcode != cc)
         return FALSE;

      if (vars[s->kvar].bSet && vars[s->kvar].setter != s) {
         int         kf;
         int         kp;
         int         i;
         sara_long   n;

         CalcK(s->op[0], &kf, &kp);
         i = ReadStreamIndex(s->op[0], kf);
         n = s->op[0]->cursor;

         while (b[i]->locs[kp].lcode == cc && n >= 0) {
            if (b[i]->locs[kp].word == vars[s->kvar].val)
               break;
            kp--;
            n--;
            if (kp < 0) {
               kp = maxiloc - 1;
               kf--;
               i = ReadStreamIndex(s->op[0], kf);
            }
         }

         if (b[i]->locs[kp].lcode != cc || n < 0)
            return FALSE;
         s->op[0]->cursor = n;
         SetPos(s->op[0]);
      } else {
         vars[s->kvar].bSet = TRUE;
         vars[s->kvar].setter = s;
         vars[s->kvar].val = (int) s->op[0]->wpos;
      }

      CopyProps(s, 0);
      return TRUE;

    case TY_IDC:
      posx = pos;
      cx = cc;
      do {
         if (!WAdStreambp(s->op[0], cx, posx, FALSE))
            return FALSE;
         bOK = bIDValOK(s);
         cx = s->op[0]->lcode;
         posx = s->op[0]->pos - 1;
      } while (!bOK);

      CopyProps(s, 0);
      return TRUE;

    case TY_FILE:
		assert(FALSE);
/*
      if (bEnd && s->wtype == ID_WORD)
         w--;
 */
      if (s->cursor < CountStream(s))
         if ((s->pos <= pos && s->lcode == cc) || s->lcode < cc)
            return TRUE;
      CalcK(s, &kf, &kp);

      i = ReadStreamIndex(s, kf);
      n = s->cursor;

      while (kf > s->ff) {
         sara_long  ic = cc - b[i]->locs1[0].lcode;

         lp = b[i]->locs1[0].pos;
         if (ic > 0 || (ic == 0 && lp <= pos))
            break;
         kf--;
         i = ReadStreamIndex(s, kf);
         n -= kp;
         kp = maxiloc;
      }
      kq = 0;

      if (kf == s->ff) {
         sara_long  ic = cc - b[i]->locs1[s->first].lcode;

         lp = b[i]->locs1[s->first].pos;
         if (ic < 0 || (ic == 0 && lp > pos))
            return FALSE;
         kq = s->first;
      }

      j = BinChop1bp(i, kq, kp - 1, cc, pos);
      n -= kp - j;
      s->cursor = n;
      SetPos(s);
      return TRUE;

/*
      j = BinChopbp(i,kq,kp-1,cc,pos);
 */

    case TY_SEQ:
      {
         BOOL     b,
                  b1;
         BOOL     bAll;
         WORDNO   
                  i0,
                  i1;
		 int f0, f1;
		 BOOL bStrict;

         bAll = TRUE;
         for (i = 0; i < s->ops; i++) {
            if (s->op[i]->bOptional)
               if (s->op[i]->cursor == -1)
                  WAdStreambp(s->op[i], cc, pos, FALSE);
               else;
            else
               bAll &= WAdStreambp(s->op[i], cc, pos, FALSE);
         }
       xd:
         if (!bAll)
            return FALSE;

         maxcode = MAXCODE;
         maxpos = MAXPOS;
         ii = -1;

         for (i = 0; i < s->ops; i++)
            if (   !s->op[i]->bOptional
                && poscmp(maxcode, maxpos, s->op[i]->lcode,
                          s->op[i]->pos)) {
               maxcode = s->op[i]->lcode;
               maxpos = s->op[i]->pos;
               ii = i;
            }

//         wi = s->op[ii]->wpos;
         b = TRUE;
//         i0 = wi + s->op[ii]->wc;
		 NextWord(s->op[ii],&i0,&f0);

         for (i = ii + 1; i < s->ops; i++) {
            BOOL  b2;

            b1 = b2 = WAdStreamb(s->op[i], maxcode, i0, f0, FALSE);
            if (b1) FakePos(s->op[i],s->op[i-1]->pos+1);
            
            b1 &= (s->op[i]->wpos == i0)
               && (s->op[i]->lcode == maxcode)
               && (s->op[i]->pos>s->op[i - 1]->pos);                  ;
            if (!b1 && s->op[i]->bOptional)
               continue;
            b &= b1;
            bAll &= b2;
            if (b)
               NextWord(s->op[i],&i0,&f0);
         }

//         i1 = wi;
		 PrevWord(s->op[ii],&i1,&f1,&bStrict);
         for (i = ii - 1; i >= 0; i--) {
            BOOL  b2;

            b1 = b2 = WAdStreamb(s->op[i], maxcode, i1, f1, bStrict);
            if (b1) FakePos(s->op[i],s->op[i+1]->pos-1);
            
            if (bTrace)
               if (b1)
                  trace("SEQ", "Fitted %d", i);
               else
                  trace("SEQ", "Failed fit %d", i);
            b1 &= (s->op[i]->wpos + (bStrict?s->op[i]->wc:0) == i1)
               && (s->op[i]->lcode == maxcode)
               && (s->op[i]->pos<s->op[i + 1]->pos);
            if (!b1 && s->op[i]->bOptional)
               continue;
            b &= b1;
            bAll &= b2;
            if (b)
               PrevWord(s->op[i],&i1,&f1,&bStrict);
         }

         if (!b) {
            cc = s->op[ii]->lcode;
            pos = s->op[ii]->pos;    
            bAll &= WAdStreambp(s->op[ii],cc,pos-1,FALSE);

            goto xd;
         }
         s->pos = s->op[0]->pos;
         s->wpos = s->op[0]->wpos;
         s->pre = s->op[0]->pre;
         s->nxt = s->op[LastIndex(s)]->nxt;
         s->lcode = s->op[0]->lcode;
         s->lw = (int) (  (s->op[LastIndex(s)]->pos)
                        - (s->op[0]->pos)) + (s->op[LastIndex(s)]->lw);
         s->lw0 = (int) (  (s->op[LastIndex(s)]->pos)
                        - (s->op[0]->pos));
         s->wc = (int) (i0 - i1);
         return TRUE;
      }

    case TY_OR:
      ii = -1;
      maxcode = 0L;
      maxpos = 0L;

      for (i = 0; i < s->ops; i++) {
         SaveStreamPos(s->op[i]);
         if (!WAdStreambp(s->op[i], cc, pos, FALSE))
            continue;

         if (poscmp(s->op[i]->lcode, s->op[i]->pos, maxcode, maxpos)) {
            ii = i;
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
         }
      }

      for (i = 0; i < s->ops; i++)
         if (i != ii)
            RestoreStreamPos(s->op[i]);

      if (ii == -1)
         return FALSE;

 /*     s->pos = s->op[ii]->pos;
      s->wpos = s->op[ii]->wpos;
      s->pre = s->op[ii]->pre;
      s->nxt = s->op[ii]->nxt;
      s->lcode = s->op[ii]->lcode;
	  s->frobno = s->op[ii]->frobno; */
	  CopyProps(s,ii);
      return TRUE;

    case TY_AND:

    xm:

      ii = -1;
      maxcode = MAXCODE;
      maxpos = MAXPOS;
      for (i = 0; i < s->ops; i++) {
         if (!WAdStreambp(s->op[i], cc, pos, FALSE))
            return FALSE;

         if (poscmp(maxcode, maxpos, s->op[i]->lcode, s->op[i]->pos)) {
            ii = i;
            maxcode = s->op[i]->lcode;
            maxpos = s->op[i]->pos;
         }
      }

      if (ii == -1)
         return FALSE;

      bb = TRUE;
      for (i = 0; i < s->ops; i++) {
         if (i == ii)
            continue;

         if (!WAdStreambp(s->op[i], s->op[ii]->lcode, s->op[ii]->pos, FALSE))
            return FALSE;
         bb &= (s->op[ii]->lcode == s->op[i]->lcode)
            && (s->op[ii]->pos == s->op[i]->pos);
      }

      if (!bb) {
         cc = s->op[ii]->lcode;
         pos = s->op[ii]->pos - 1;
         goto xm;
      }
      s->pos = s->op[0]->pos;
      s->wpos = s->op[0]->wpos;
      s->pre = s->op[0]->pre;
      s->nxt = s->op[0]->nxt;
      s->lcode = s->op[0]->lcode;
      s->wc = s->op[0]->wc;
      s->lw = s->op[0]->lw;
      s->lw0 = s->op[0]->lw0;
      return TRUE;

    case TY_ALL:
      s->lcode = cc;
      s->pos = pos;
      return TRUE;          
    case TY_CASE:
		assert(FALSE);	 
		if (!WAdStreambp(s->op[0], cc, pos, bEnd)) return FALSE;
    	while (!bFilterCase(s->op[0]->pos, s->op[0]->lcode,
                          s->xword, s->op[0]->frobpos, s->op[0]->lw))
			if (!RegressStream(s->op[0])) return FALSE;
		CopyProps(s,0);
		return TRUE;	

  
   }
	return TRUE; // unused
}

BOOL SetPos(struct stream *s)
{
   if (s->cursor < 0)
      return FALSE;

   switch (s->type) {
      int   kf,
            kp,
            ik;

    case TY_ATOM:
      if (!CalcK(s, &kf, &kp))
         return FALSE;
      ik = ReadIndex(kf);
      s->lcode = b[ik]->locs[kp].lcode;
      s->pos = b[ik]->locs[kp].pos + s->frobpos;
      s->wpos = b[ik]->locs[kp].word;
	  s->lw= b[ik]->locs[kp].len;
	  s->pre=b[ik]->locs[kp].seq-1;
	  s->nxt=b[ik]->locs[kp].seq+1;
	  s->nw=1;
      return TRUE;

    case TY_FILE:
      if (!CalcK(s, &kf, &kp))
         return FALSE;
      ik = ReadIndexFile(s->handle, kf);
      s->lcode = b[ik]->locs1[kp].lcode;
      s->pos = b[ik]->locs1[kp].pos;
      s->wpos = b[ik]->locs1[kp].word;
      s->lw = b[ik]->locs1[kp].lw;
      s->lw0 = b[ik]->locs1[kp].lw0;
//	  s->pre=b[ik]->locs1[kp].pre;
//	  s->nxt=b[ik]->locs1[kp].nxt;
	  s->wc=b[ik]->locs1[kp].wc;
      return TRUE;

    case TY_SUBCORPUS:
      ik = ReadSubCorpus(s);
      if (s->cursor >= ik)
         return FALSE;
      s->lcode = scbuff[s->cursor];
      s->wpos = 0;
      s->pos = 0;
      return TRUE;
   }
	return TRUE; // unused
}


BOOL SetPosEnd(struct stream *s)
{
   switch (s->type) {
      int       ik;

    case TY_ATOM:
      ik = ReadIndex(s->lf);
      s->lcode = b[ik]->locs[s->last - 1].lcode;
      s->pos = b[ik]->locs[s->last - 1].pos;
      s->wpos = b[ik]->locs[s->last - 1].word;
      s->cursor = CountStream(s);
      return TRUE;

    case TY_FILE:
      ik = ReadIndexFile(s->handle, s->lf);
      s->lcode = b[ik]->locs1[s->last - 1].lcode;
      s->pos = b[ik]->locs1[s->last - 1].pos;
      s->wpos = b[ik]->locs1[s->last - 1].word;
      s->lw = b[ik]->locs1[s->last - 1].lw;
      s->lw0 = b[ik]->locs1[s->last - 1].lw0;
      s->cursor = CountStream(s);
      return TRUE;

    case TY_SUBCORPUS:
      s->lcode = 0x7fffffff;
      s->cursor = CountStream(s);
      s->wpos = 0;
      s->pos = 0;
      return TRUE;
   }
	return TRUE; // unused
}


void SavePos(struct stream *s, STRSAVE * n)
{
   *n = s->cursor;
   return;
}


void RestorePos(struct stream *s, STRSAVE * n)
{
   s->cursor = *n;
   return;
}


BOOL CalcK(struct stream *s, int *f, int *p)
{
   sara_long  n = s->cursor;

   *f = s->ff;
   if (s->first + n < maxiloc) {
      *p = s->first + (int) n;
      return s->lf > s->ff || *p < s->last;
   }

   n -= maxiloc - s->first;
   (*f) += (int) (n / maxiloc + 1);
   *p = (int) (n % maxiloc);

   return *f < s->lf || *p < s->last;
}




void ClearBuffers(void)
{
   int   i;

   for (i = 0; i < MAXBUFFN; i++)
      buffercontrol[i].use = -1;

   return;
}

// fix this - should be a direct memory read!

void Loc(int n,struct xara_loc* l)
{
	int k, p, ik;
	p=n / maxiloc;
	k=n%maxiloc;
	ik=ReadIndex(p);
	memcpy(l,&b[ik]->locs[k],sizeof (struct xara_loc));
/*	l->fi=b[ik]->locs[k].lcode;
	l->off=b[ik]->locs[k].pos;
	l->nw=b[ik]->locs[k].word;
	l->len=b[ik]->locs[k].len;
	l->sb=b[ik]->locs[k].sb;
	l->pre=b[ik]->locs[k].pre;
	l->nxt=b[ik]->locs[k].nxt; */
}


extern void ReadPage(int,char*);

int ReadIndex(int k)
{
   int            i;
//   char           path[_MAX_PATH];
//   FILE          *fIdx;
//   struct ihdr    hdr;

   for (i = 0; i < nbt; i++)
      if (   buffercontrol[i].use >= 0
          && buffercontrol[i].owner.hash == 0
          && !buffercontrol[i].bFile
          && buffercontrol[i].k == k) {
         buffercontrol[i].use = nuse++;
         return i;
      }
   i = FreeBuffer();
//	strcpy(path,etcpath);
//	strcat(path,"\\xdblocs");
  // fIdx = fopen(path, "rb");
   ReadPage(k,(char*) b[i]);
 //  fseek(fLocs, k*maxiloc*sizeof (struct xara_loc),SEEK_SET);
//   for (j=0;j<maxiloc;j++) {
//	   struct xara_loc xl;
//	   fread(&xl,sizeof xl,1,fIdx);
//	   b[i]->locs[j].bNew=FALSE;
//	   fread(&b[i]->locs[j],sizeof xl,1,fIdx);
//	   b[i]->locs[j].lcode=xl.fi;
//	   b[i]->locs[j].pos=xl.off;
//	   b[i]->locs[j].word=xl.nw;
//	   b[i]->locs[j].len=xl.len;
//	   b[i]->locs[j].sb=xl.sb;
//	   b[i]->locs[j].pre=xl.pre;
//	   b[i]->locs[j].nxt=xl.nxt;
// }
//   fread(b[i], sizeof(struct xara_loc), maxiloc, fLocs);
//   fix_locent(b[i]->locs, hdr.nill);
//   fclose(fIdx);

   buffercontrol[i].owner.hash = 0;
   buffercontrol[i].bFile = FALSE;
   buffercontrol[i].k = k;
   buffercontrol[i].use = nuse++;
   nload++;

   return i;
}


void KillFileBuffers(FILE *f)
{
   int   i;

   for (i = 0; i < nbt; i++)
      if (   buffercontrol[i].use >= 0
          && buffercontrol[i].bFile
          && buffercontrol[i].owner.f == f)
         buffercontrol[i].use = -1;
   scbowner = NULL;
   return;
}


int ReadIndexFile(FILE *handle, int k)
{
   int   i;

   for (i = 0; i < nbt; i++)
      if (   buffercontrol[i].use >= 0
          && buffercontrol[i].k == k
          && buffercontrol[i].bFile
          && buffercontrol[i].owner.f == handle) {
         buffercontrol[i].use = nuse++;
         return i;
      }
   i = FreeBuffer();

   fseek(handle, (k * maxiloc * sizeof(struct locent1)), SEEK_SET);
   fread(b[i], sizeof(struct locent1), maxiloc, handle);
//   fix_locent(b[i]->locs, MAXILOC);
//   No! This is a temporary file and will be OK already.
   buffercontrol[i].owner.f = handle;
   buffercontrol[i].bFile = TRUE;
   buffercontrol[i].k = k;
   buffercontrol[i].use = nuse++;

   return i;
}


int ReadStreamIndex(struct stream *s, int k)
{
   if (s->type == TY_ATOM)
      return ReadIndex(k);
   else
      return ReadIndexFile(s->handle, k);
}


int ReadSubCorpus(struct stream *s)
{
   int   n = (int) CountStream(s);

   if (s->handle == scbowner)
      return n;
   scbowner = s->handle;
   fread(scbuff, sizeof(sara_long), n, s->handle);
   return n;
}


int FreeBuffer(void)
{
   int         i;
   int         ii;
   sara_long   minuse = nuse;

   if (nuse == 0)
      return 0;
   for (i = nba; i < nbt; i++)
      if (buffercontrol[i].use < minuse) {
         ii = i;
         minuse = buffercontrol[i].use;
      }
   return ii;
}


sara_long LastSGML(WORDNO w, sara_ulong cc, char *tag, int ty)
{
   struct stream *s;
   sara_long      p;

      s = MakeAtomStream(tag, 0, ty);
	  SetLimitsW(s,w,cc);
   if (s == NULL)
      return LastSGML(w, cc, txt0, ID_TAGO);
   WindStream(s);

   if (!WAdStreamb(s, cc, w, -1, FALSE)||cc != s->lcode) {
		p=-1;
   }
   else p = s->pos;
   FreeStream(s);
   return p;
}

sara_long LastSGMLw(WORDNO w, sara_ulong cc, char *tag, int ty)
{
   struct stream *s;
   sara_long      p;

      s = MakeAtomStream(tag, 0, ty);
	  SetLimitsW(s,w,cc);
   if (s == NULL)
      return -1;
   WindStream(s);

   if (!WAdStreamb(s, cc, w, -1, FALSE)||cc != s->lcode) {
		p=-1;
   }
   else p = s->wpos;
   FreeStream(s);
   return p;
}


sara_long LastSGMLp(sara_long pos, sara_ulong cc, char *tag, int ty)
{
   struct stream *s;
   sara_long      p;

      s = MakeAtomStream(tag, 0, ty);
	  SetLimits(s,pos,cc);

   if (s == NULL)
      return LastSGMLp(pos, cc, txt0, ID_TAGO);

   WindStream(s);

   if (!WAdStreambp(s, cc, pos, FALSE) || cc != s->lcode)
      if (!strcmp(tag, txt0))
         p = 0;
      else
/*         p = LastSGMLp(pos, cc, txt0, ID_TAGO); */
		p=0;
   else
      p = s->pos;

   FreeStream(s);
   return p;
}

char* LastSGMLv(sara_long* pos, sara_ulong cc, char *tag, int ty)
{
   struct stream *s;
   int p;

      s = MakeAtomStream(tag, 0, ty);
	  SetLimits(s,*pos,cc);

   if (s == NULL)
      return NULL;

   WindStream(s);

   if (!WAdStreambp(s, cc, *pos, FALSE) || cc != s->lcode)
   {
	   FreeStream(s);
	   return NULL;
   }
   p = s->wpos;
	*pos=s->pos;
   FreeStream(s);
   return GetWordList(p);
}

struct _ld 
{
	int pos;
	int code;
	int w;
};

struct _ld* ldtab;
int ild;

void MakeLocToDocTable()
{
	struct stream *s=MakeAtomStream("document",0,it_global_attribute_value); int i, k;
	ild=k=CountStream(s);
	ldtab=(struct _ld*) malloc(k*sizeof (struct _ld));
	i=0;
	while (AdvanceStream(s)) {
		ldtab[i].pos=s->pos;
		ldtab[i].code=s->lcode;
		ldtab[i++].w=s->wpos;
	}
}

int LocToDoc(sara_long pos,sara_ulong code)
{
	int i;
	for (i=0;i<ild;i++) {
		if (ComparePos(ldtab[i].code,ldtab[i].pos,code, pos)>0)
			return i-1;
	}
	return ild-1;
}

int LocToDocW(WORDNO w,sara_ulong code)
{
	int i;
	for (i=0;i<ild;i++) {
		if (ComparePos(ldtab[i].code,ldtab[i].w,code, w)>0)
			return i-1;
	}
	return ild-1;
}

void DocToLoc(int k,sara_long* pos,sara_ulong* code)
{
	*pos=ldtab[k].pos;
	*code=ldtab[k].code;
}

int ScopeSize(sara_long pos,sara_ulong cc,char* tag)
{
	struct stream* s; int w, ww; sara_long pp;
       s = MakeAtomStream(tag, 0, it_start);
	   SetLimits(s,pos,cc);
   if (s==NULL) return 0;
   WindStream(s);
   if (!WAdStreambp(s, cc, pos+1, FALSE) || cc != s->lcode) return 0;
	w=s->wpos;
	pp=s->pos;
	FreeStream(s);	
      s = MakeAtomStream(tag, 0, it_end);
	  SetLimits(s,pos,cc);
   if (s==NULL) return 0;
   RewindStream(s);
   AdvanceStream(s);
   if (!WAdStreamp(s, cc, pp, FALSE) || cc != s->lcode) return 0;
   if (s->pos < pos) return 0;
	ww=s->wpos;
	FreeStream(s);	
	return ww-w;
}
	

sara_long NextSGMLp(sara_long pos, sara_ulong cc, char *tag, int ty)
{
   struct stream *s;
   sara_long      p;
      s = MakeAtomStream(tag, 0, ty);
	  SetLimits(s,pos,cc);

   if (s == NULL)
      return NextSGMLp(pos, cc, txt0, ID_TAGE);

   RewindStream(s);
   AdvanceStream(s);

   if (!WAdStreamp(s, cc, pos, FALSE) || cc != s->lcode)
      if (!strcmp(tag, txt0))
         p = pos + 1000;
      else
         p = NextSGMLp(pos, cc, txt0, ID_TAGE);
   else
      p = s->pos;

   FreeStream(s);
   return p;
}

char* NextSGMLv(sara_long *pos, sara_ulong cc, char *tag, int ty)
{
   struct stream *s;
   int      p;
      s = MakeAtomStream(tag, 0, ty);
	  SetLimits(s,*pos,cc);

   if (s == NULL)
      return NULL;

   RewindStream(s);
   AdvanceStream(s);

   if (!WAdStreamp(s, cc, *pos, FALSE) || cc != s->lcode)
   {
	   FreeStream(s);
	   return NULL;
   }
   p = s->wpos;
	*pos=s->pos;
   FreeStream(s);
   return GetWordList(p);
}


sara_long NextSGML(WORDNO w, sara_ulong cc, char *tag, int ty)
{
   struct stream *s;
   sara_long      p;
	SGMLFold(tag);

      s = MakeAtomStream(tag, 0, ty);
	  SetLimitsW(s,w,cc);

   if (s == NULL)
      return NextSGML(w, cc, txt0, it_end);

   RewindStream(s);
   AdvanceStream(s);

   if (!WAdStream(s, cc, w, -1, FALSE) || cc != s->lcode ) {
//      if (!strcmp(tag, txt0))
  //       p = s->pos + 1000;
    //  else
//		  p = NextSGML(w, cc, txt0, ID_TAGE); }
//		  p = NextSGML(0, cc, txt0, ID_TAGE); }
	   p=-1;}
   else 
	p = s->pos;

   FreeStream(s);
   return p;                    /* better error handling here! */
}

sara_long NextSGMLw(WORDNO w, sara_ulong cc, char *tag, int ty)
{
   struct stream *s;
   sara_long      p;
	SGMLFold(tag);

      s = MakeAtomStream(tag, 0, ty);
	  SetLimitsW(s,w,cc);

   if (s == NULL)
      return NextSGMLw(w, cc, txt0, it_end);

   RewindStream(s);
   AdvanceStream(s);

   if (!WAdStream(s, cc, w, -1, FALSE) || cc != s->lcode ) {
//      if (!strcmp(tag, txt0))
  //       p = s->pos + 1000;
    //  else
//		  p = NextSGML(w, cc, txt0, ID_TAGE); }
//		  p = NextSGML(0, cc, txt0, ID_TAGE); }
	   p=-1;}
   else 
	p = s->wpos;

   FreeStream(s);
   return p;                    /* better error handling here! */
}

long OldCountWords(sara_ulong cc)
{
	struct stream* s; long n;
	s=MakeAtomStream(txt0,0,ID_TAGE);
	WAdStream(s,cc,0,-1,FALSE);
	n=s->wpos;
	FreeStream(s);
	return n;
}

struct stream pstream;



struct stream* MakePosStream(char* pos)
{
	xairo_uchar* ww=Wide(pos);
	struct stream* s=MakePosStreamW(ww);
	DW(ww);
	return s;
}

struct stream* MakePosStreamW(xairo_uchar* pos)
{
	struct stream* s; int i=0;
	if (nwt==0) return NULL;
	for (i=0;i<nwt;i++) {
		xairo_uchar* n=Wide(wtags[i].name);
		xairo_uchar* p=Wide(wtags[i].name);
		s=MakeAttStream(n,p,pos,it_local_attribute);
		DW(n); DW(p);
		if (s != NULL) break;
	}
	if (s != NULL) s->wc=1;
	return s;
}



struct stream *MakeAtomStream(char *w, int extra, int wtype)
{
	xairo_uchar* ww=Wide(w);
	struct stream* s=MakeAtomStreamW(ww,extra,wtype);
	DW(ww);
	return s;
}


struct stream *MakeAtomStreamW(const xairo_uchar *w, int extra, int wtype)
{
   struct stream *s = GrabStream();
   struct lookup  lur;
   int            i;

#if !defined(_WIN32)
   fflush(stdout);
#endif

   if (s == NULL) {
      return NULL;
   }

   wcscpy(lur.word, w);
   wcscpy(s->xword, w);

   if (!LookUpWord(&lur, 0)) {
      FreeStream(s);
      return NULL;
   } else if (!GetPos1(&lur, extra, wtype)) {
      FreeStream(s);
      return NULL;
   }

   s->type = TY_ATOM;
   wcscpy(s->word, w);
   i = lur.sel;
   s->ihash = lur.ihash;
   s->extra = extra;
   s->wtype = wtype;
   s->wc = (wtype == ID_WORD) ? 1 : 0;
   s->count = -1;
   s->first = lur.sig[i].first;
   s->ff = lur.sig[i].ff;
   s->last = (i + 1 < lur.nsig) ? lur.sig[i + 1].first : lur.last;
   s->lf = (i + 1 < lur.nsig) ? lur.sig[i + 1].ff : lur.lf;
   s->lw = wcslen(lur.word);
   s->lw0=0;
   s->acc=lur.sig[i].acc;

   return s;
}


struct stream *MakeIDStream(char *w, char *d, int wtype)
{
   struct stream *s = GrabStream();
   int            kvar = atoi(w);
   s->op[0] = MakeAtomStream(d, 0, wtype);
   s->ops = 1;
   s->type = TY_ID;
   s->kvar = kvar;
   return s;
}


struct stream *MakeIDCStream(int kx, WORDNO k[10], char *d, int wtype)
{
   int            i;
   struct stream *s = GrabStream();
   s->op[0] = MakeAtomStream(d, 0, wtype);
   if (s->op[0] == 0)
      return NULL;

   s->ops = 1;
   s->type = TY_IDC;
   s->nkvals = kx;

   for (i = 0; i < kx; i++)
      s->kval[i] = k[i];

   return s;
}

struct stream *MakeNewIDCStreamW(xairo_uchar* elt,xairo_uchar* att,xairo_uchar* val,xairo_uchar* extra,BOOL bG)
{
	struct stream *s0=MakeAttStream(elt,att,val,bG?it_global_attribute_value:it_local_attribute_value);
	struct stream *s;
	if (s0==NULL) return NULL;
	s = GrabStream();
	s->ops = 1;
	s->op[0]=s0;
	s->type = TY_IDC;
	wcscpy(s->skval,extra);
	return s;
}

struct stream *MakeNewIDCStream(char* elt,char* att,char* val,char* extra,BOOL bG)
{
	xairo_uchar* e=Wide(elt);
	xairo_uchar* a=Wide(att);
	xairo_uchar* v=Wide(val);
	xairo_uchar* x=Wide(extra);
	struct stream *s=MakeNewIDCStreamW(e,a,v,x,bG);
	DW(e); DW(a);
	DW(v); DW(x);
	return s;
}


#if !defined(SERVER)

void Subquery(void)
{
   while (TRUE)
      switch (Menu(&sqm)) {
         int   i;

       case MN_DISCARD:
         DiscardUnmarked();
         return;

       case MN_SELECTION:
         if (bFilter)
            break;
         EditGetNumber("Select how many? ", &i);
         if (i <= 0)
            break;
         Retain(i, CountStream(&qs));
         return;

       case MN_MAIN:
         return;
      }
}


void SaveQuery(void)
{
   char  nm[MAXNAME + 1];

   if (qs.type == 0) {
      printf("No query to save\n");
      return;
   }

   EditGetWord("Query name: ", nm);
   nm[MAXNAME] = 0;
   SaveQueryFile(&qs, nm);
}

#endif /* ! SERVER */


void CountQuery(char* s,const char* sc, int p, int* n,int* nt)
{
	int k, kt; int lc; FILE* f; struct locent1 l; int is=FindSubCorpus(sc); BOOL bIn;
	k=kt=0; lc=-1;; 
	if (is==-1) return;
	f = fopen(GetQPath(s),"r");
	if (f==NULL) return;
	while (fread(&l,sizeof l,1,f)) {
		int d=LocToDoc(l.pos,l.lcode);
		if (lc != d) {
			bIn=TestSubCorpus2(d,is,p);
			if (bIn) kt++;
			lc=d;
		}
		if (bIn) k++;
	}
	fclose(f);
	*n=k;
	*nt=kt;
}

void CountContent(char* s,const char* sc, int p, char* elt, int* n, int *nt)
{
	int k, kt;  sara_ulong lc; FILE* f; struct locent1 l; int is=FindSubCorpus(sc); BOOL bIn;
	k=kt=0; lc=0xf000000; 
	if (is==-1) return;
	f = fopen(GetQPath(s),"r");
	if (f==NULL) return;
	while (fread(&l,sizeof l,1,f)) {
		if (lc != l.lcode) {
			bIn=TestSubCorpus2(l.lcode,is,p);
			if (bIn) kt++;
			lc=l.lcode;
		}
		if (bIn) k+=ScopeSize(l.pos,l.lcode,elt);
	}
	fclose(f);
	*n=k;
	*nt=kt;
}

sara_long SaveQueryFile(struct stream *s, char *n, int *nt)
{
   FILE             *f = NULL;
   struct locent1    l;
   int               i = 0;
   int               j = 0;
   sara_long         m = 0;
   sara_ulong        lc = 0xf000000;
   int doc=-1; int d;

   *nt = 0;

   f = fopen(GetQTPath(n), "w");
   if (f == NULL)
      return -2;

   RewindStream(s);
//   l.bNew = FALSE;

   while (XAdvanceStream(s)) {
      if (s->bFilter && i >= nfil)
         break;

      if (s->bFilter && filter[i] > j++)
         continue;

      l.lcode = s->lcode;
      l.pos = s->pos;
      l.word = s->wpos;
      l.lw = s->lw;
	  l.lw0=s->lw0;
//	  l.pre=s->pre;
	  l.nxt=s->nxt;
	  l.wc=s->wc;
	  assert(l.lw >= 0);

      if (!fwrite(&l, sizeof(l), 1, f)) {
         fclose(f);
         f = fopen(GetQPath(n), "w");
         fclose(f);
         return -2;
      }
	  d=LocToDoc(l.pos,l.lcode);
      if (d != doc) {
         doc = d;
         (*nt)++;
      }
      i++;
      m++;
   }

   if (bInt) {
      fclose(f);
      f = fopen(GetQTPath(n), "w");
      fclose(f);
      return -3;
   }

   fclose(f);

   return m;
}

#if !defined(SERVER)

void SaveSubCorpus(void)
{
   char        nm[MAXNAME + 1];
   FILE       *f;
   char        path[_MAX_PATH + 1];
   int         i = 0;
   int         j = 0;
   sara_ulong  lastcode = 0;

   if (qs.type == 0) {
      printf("No query to save\n");
      return;
   }

   EditGetWord("Subcorpus name: ", nm);
   nm[MAXNAME] = 0;
   sprintf(path, "%s%s.scp", etcpath, nm);

   f = fopen(path, "r");
   if (f != NULL) {
      char  msg[MAXNAME + 50];

      fclose(f);
      sprintf(msg, "Subcorpus %s already exists. Overwrite", nm);
      if (!yn(msg))
         return;
   }

   f = fopen(path, "w");
   RewindStream(&qs);

   while (AdvanceStream(&qs)) {
      if (bFilter && i >= nfil)
         break;

      if (bFilter && filter[i] > j++)
         continue;

      if (qs.lcode == lastcode)
         continue;

      fwrite(&qs.lcode, sizeof(lastcode), 1, f);
      lastcode = qs.lcode;
      i++;
   }

   fclose(f);

   return;
}


void LoadQuery(void)
{
   char        nm[MAXNAME + 1];
   FILE       *f;
   char        path[_MAX_PATH];
   sara_long   ss;

   EditGetWord("Query name: ", nm);
   nm[MAXNAME] = 0;
   sprintf(path, "%s%s.sqy", etcpath, nm);

   f = fopen(path, "r");
   if (f == NULL) {
      printf("Query %s not found\n", nm);
      return;
   }

   qs.type = TY_FILE;
   fseek(f, 0, SEEK_END);
   ss = ftell(f);
   rewind(f);

   qs.count = (int) ss / sizeof(struct locent1);
   qs.first = 0;
   qs.ff = 0;
   qs.last = qs.count % MAXILOC;
   qs.lf = qs.count / MAXILOC;
   qs.handle = f;
   printf("Loaded %i solutions\n", qs.count);

   return;
}

#endif /* ! SERVER */


struct stream *MakeFileStreamW(xairo_uchar *file)
{
	assert(FALSE);
	return NULL;
}

struct stream *MakeFileStream(char *file)
{
   FILE          *f;
   char           path[_MAX_PATH];
   sara_long      ss;
   struct stream *s;

   sprintf(path, "%s%s.sqy", etcpath, file);

   f = fopen(path, "r");
   if (f == NULL) {
#if !defined(SERVER)
      printf("Query %s not found\n", file);
#endif /* ! SERVER */
      return NULL;
   }

   s = GrabStream();
   s->type = TY_FILE;
   fseek(f, 0, SEEK_END);
   ss = ftell(f);
   rewind(f);
   s->count = (int) ss / sizeof(struct locent1);
   s->first = 0;
   s->ff = 0;
   s->last = (int) s->count % maxiloc;
   s->lf = (int) s->count / maxiloc;
   s->handle = f;
   s->wc = 1;
   return s;
}


struct stream *MakeSCStreamW(xairo_uchar *file)
{
	assert(FALSE);
	return NULL;
}

struct stream *MakeSCStream(char *file)
{
   FILE          *f;
   char           path[_MAX_PATH];
   sara_long      ss;
   struct stream *s;

   sprintf(path, "%s%s.scp", etcpath, file);

   f = fopen(path, "r");
   if (f == NULL) {
#if !defined(SERVER)
      printf("Subcorpus %s not found\n", file);
#endif /* ! SERVER */
      return NULL;
   }

   s = GrabStream();
   s->type = TY_SUBCORPUS;
   fseek(f, 0, SEEK_END);
   ss = ftell(f);
   rewind(f);
   s->count = (int) ss / sizeof(sara_long);
   s->handle = f;
   s->wc = 0;

   return s;
}

// Obsolete

BOOL bFilterCase(sara_long pos, sara_ulong code, xairo_uchar *fil, int offs, int l)
{
   char  path[_MAX_PATH] = "";
   FILE *fText;
   int   k;
   char  ins[_MAX_PATH];
   xairo_uchar  buff[MAXWORD + 1];

   GetDocPath(code, ins, path);
   fText = fopen(path, "r");
   if (fText==NULL) return TRUE;
   fseek(fText, (pos + offs), SEEK_SET);
   k = fread(buff, 1, l + 10, fText);
   buff[k] = 0;

//   NormSpaces(buff);
   fclose(fText);
   return !wcsncmp(fil, buff, wcslen(fil));
}


void NormSpaces(char *s)
{
   char *ss = s;

   while (*s) {
      if (isspace(*s)) {
         *ss = ' ';
         s++;
         ss++;
         while (*s && isspace(*s))
            s++;
      } else {
         *ss = *s;
         s++;
         ss++;
      }
   }
   *ss = 0;
}


struct stream *MakeSGMLStream2(char *name, int n, char *attnames[],
                               char *attvals[], char *attextras[])
{
	assert(FALSE);
	return NULL;
}

							   
							   
struct stream *MakeSGMLStream2W(xairo_uchar *name, int n, xairo_uchar *attnames[],
                               xairo_uchar *attvals[], xairo_uchar *attextras[])
{
   int            i,
                  i0,
                  nx;
   struct stream *s,
                  *s1;
	s1 = GrabStream();
	s1->type = TY_AND;
	s1->wtype = ID_TAGO;
	s1->wc = 0;
	s1->lw=0;
//	SGMLFold(name);
   if (name[0] != 0 && n==0) {
	   s = MakeAtomStreamW(name, 0, it_start);
		if (s == NULL)
		return s;
	s1->op[0] = s;
		nx=1;
   } else nx=0;

		i0 = 0;

   while (i0 < n) {
      struct stream *dis;
      int            k,
                     j,
                     kk;

      i = i0 + 1;

      while (i < n && SameAttribute(name, attnames[i0], attvals[i0],
                                    attnames[i], attvals[i]))
         i++;

      k = i - i0;
      dis = GrabStream();
      dis->type = TY_OR;
      kk = 0;               
      
/* Here we should consolidate multiple seaches of the same IDC stream, as they can already cope with 
disjunctions internally with great efficiency */      

      for (j = 0; j < k; j++) {
         struct stream *a = MakeAttributeStreamW(name, attnames[i0 + j],
                                          attvals[i0 + j], attextras[i0 + j]);
         if (a)
            dis->op[kk++] = a;
      }

      dis->ops = kk;
      if (kk == 0)
         return NULL;

      if (kk == 1)
         s1->op[nx++] = dis->op[0];
      else
         s1->op[nx++] = dis;
      i0 = i;
   }
   s1->ops = nx;
   return s1;
}


struct stream *MakeAttributeStream(char* elt, char* att, char* val, char* extra)
{
	xairo_uchar* e=Wide(elt);
	xairo_uchar* a=Wide(att);
	xairo_uchar* v=Wide(val);
	xairo_uchar* x=Wide(extra);
	struct stream* ss=MakeAttributeStreamW(e,a,v,x);
	DW(e); DW(a); DW(v);
	DW(x);
	return ss;
}

// the query should specify whether the attribute is global
// the server should not need to use this dsc based data any more
const xairo_uchar _s_0[]={'0',0};
const xairo_uchar _s_ast[]={'*',0};
const xairo_uchar _s_und[]={'*',0};

struct stream *MakeAttributeStreamW(xairo_uchar* elt, xairo_uchar* att, xairo_uchar* val, xairo_uchar* extra)
{
	BOOL bG=(wcscmp(elt,_s_0)==0);
	if (extra[0]) {
			if (wcscmp(extra,_s_ast)==0)
				return MakeRegExpStreamA(val,att,elt,bG);
			else if (wcscmp(extra,_s_und)==0) 
				return MakeVarStream(elt,att,val,bG?it_global_attribute_value:it_local_attribute_value);
			else
				return MakeNewIDCStreamW(elt,att,val,extra,bG);
	} else {
				return MakeAttStream(bG?(xairo_uchar*) _s_0:elt,att,val,bG?it_global_attribute:it_local_attribute);
		}
}

struct stream *MakeAttributeStreamWold(xairo_uchar* elt, xairo_uchar* att, xairo_uchar* val, xairo_uchar* extra)
{
	int i; BOOL bG=TRUE; int at;
	for (i=0;i<natts;i++){
		if (SGMLCompW(atttab[i].element,_s_0) &&
			SGMLCompW(atttab[i].name,att) &&
			((atttab[i].attv & 0x3fff) != AT_MULTIDREF || SGMLCompW(atttab[i].attdesc,val))) break;
	}
	if (i==natts) {
		bG=FALSE;
		for (i=0;i<natts;i++){
			if (SGMLCompW(atttab[i].element,elt) &&
				SGMLCompW(atttab[i].name,att) &&
				((atttab[i].attv & 0x3fff) != AT_MULTIDREF || SGMLCompW(atttab[i].attdesc,val))) break;
		}
		if (i==natts) return NULL;
	}
    at = atttab[i].attv & 0x3fff;
	switch (at) {
	case AT_NULL:
		return NULL;
	case AT_MULTIDREF:
        return MakeNewIDCStreamW(elt,att,val,extra,bG);
	case AT_CATT:
		return MakeAttStream(bG?(xairo_uchar*) _s_0:elt,att,val,it_content_attribute);
	default:
		{ 
			if (wcscmp(extra,_s_ast)==0)
				return MakeRegExpStreamA(val,att,elt,bG);
			else if (wcscmp(extra,_s_und)==0) 
				return MakeVarStream(elt,att,val,bG?it_global_attribute_value:it_local_attribute_value);
			else
				return MakeAttStream(bG?(xairo_uchar*) _s_0:elt,att,val,bG?it_global_attribute:it_local_attribute);
		}
	}
}


struct stream *MakeSGMLStream(char *name, int n, char *attnames[],
                              char *attvals[])
{
   struct stream *s,
                 *s1;
   int            i,
                  j;
   int            ival;
   s = MakeAtomStream(name, 0, ID_TAGO);

   if (n == 0 || s == NULL)
      return s;

   s1 = GrabStream();
   s1->type = TY_AND;
   s1->wtype = ID_TAGO;
   s1->ops = n + 1;
   s1->op[0] = s;
   s1->wc = 0;

   for (j = 0; j < n; j++) {
      int   at;
      char *p,
           *a0;
      int   kdis = 0;
      char  attdis[10][30];

      for (i = 0; i < natts; i++)
         if (   !_stricmp(attnames[j], atttab[i].name)
             && (   !_stricmp(name, atttab[i].element)
                 || atttab[i].element[0] == '0'))
            break;

      if (i == natts)
         return NULL;
      at = atttab[i].attv & 0x3fff;

      if (at !=AT_CDATA && at !=AT_MULTIDREF)
         _strupr(attvals[j]);

      a0 = attvals[j];

      while ((p = strchr(a0, '|')) != NULL) {
         int   l = p - attvals[j];

         strncpy(attdis[kdis], a0, l);
         attdis[kdis++][l] = 0;
         a0 += l + 1;
      }

      strcpy(attdis[kdis++], a0);
      switch (at) {
         int   ii;

       case AT_NULL:
         s1->op[j + 1] = NULL;
         break;

       case AT_MULTIDREF:
         {
            WORDNO    k;
            WORDNO    kvals[10];
            int       iii;

            for (ii = 0; ii < natts; ii++)
               if (!_stricmp(attnames[j], atttab[ii].name) &&
                   !_stricmp(name, atttab[ii].element) &&
                   idcomp(attdis[0], atttab[ii].attdesc, "000", &k))
                  break;
            for (iii = 0; iii < kdis; iii++)
               idcomp(attdis[iii], atttab[ii].attdesc, "000", kvals + iii);
            s1->op[j + 1] = MakeIDCStream(kdis, kvals,
                                          atttab[ii].attdesc,
                                          atttab[ii].val);
            break;
         }

       case AT_REFID:
         ival = atttab[i].val;
         for (ii = 0; ii < natts; ii++)
            if (!_stricmp(atttab[ii].name, "id") &&
                !_stricmp(atttab[ii].element, atttab[i].attdesc))
               break;
         i = ii;
         goto foo;

       case AT_ID:
         ival = atttab[i].val;

       foo:
         s1->op[j + 1] = MakeIDStream(attvals[j], atttab[i].attdesc, ival);
         break;

       default:
         s1->op[j + 1] = MakeAtomStream(attvals[j], 0, atttab[i].val);
         break;
      }
      if (s1->op[j + 1] == NULL)
         return NULL;
   }
   return s1;
}


BOOL SameAttribute(xairo_uchar *elt, xairo_uchar *a1, xairo_uchar *v1, xairo_uchar *a2, xairo_uchar *v2)
{
/*   int      i,
            j,
            at;
*/
   if (wcscmp(a1, a2)!= 0)
      return FALSE;

/*   for (i = 0; i < natts; i++)
      if (   SGMLCompW(atttab[i].name,a1)
          && (SGMLCompW(atttab[i].element,elt)
              || atttab[i].element[0] == '0'))
         break;

   if (i == natts)
      return FALSE;
   at = atttab[i].attv & 0x3fff;

   if (at !=AT_MULTIDREF)
      return TRUE;

   for (j = 0; j < natts; j++)
      if (   SGMLCompW(atttab[j].name,a1)
          && SGMLCompW( atttab[j].element,elt))
         break;

   if (j == natts)
      return FALSE;
*/
   return TRUE;
}


struct stream *OldMakeAttStream(char *elt, char *attname, char *val)
{
   int            at;
   struct stream *s1;
   int            i,
                  ival;
   char          *p,
                 *a0;
   int            kdis = 0;
   char           attdis[10][30];

   for (i = 0; i < natts; i++)
      if (   !_stricmp(attname, atttab[i].name)
          && (!_stricmp(elt, atttab[i].element)
              || atttab[i].element[0] == '0'))
         break;

   if (i == natts)
      return NULL;
   at = atttab[i].attv & 0x3fff;

   if (at !=AT_CDATA && at !=AT_MULTIDREF)
      _strupr(val);
   a0 = val;

   while ((p = strchr(a0, '|')) != NULL) {
      int   l = p - val;

      strncpy(attdis[kdis], a0, l);
      attdis[kdis++][l] = 0;
      a0 += l + 1;
   }

   strcpy(attdis[kdis++], a0);

   switch (at) {
      int       ii;

    case AT_NULL:
      s1 = NULL;
      break;

    case AT_MULTIDREF:
      {
         WORDNO    k;
         WORDNO    kvals[10];
         int       iii;

         for (ii = 0; ii < natts; ii++)
            if (!_stricmp(attname, atttab[ii].name) &&
                !_stricmp(elt, atttab[ii].element) &&
                idcomp(attdis[0], atttab[ii].attdesc, "000", &k))
               break;    
         if (ii==natts) return NULL;      
         for (iii = 0; iii < kdis; iii++)
            idcomp(attdis[iii], atttab[ii].attdesc, "000", kvals + iii);
//		 if (kdis==1) s1=PCQStream(elt, attname,atttab[ii].attdesc,kvals[0]); 		
         s1 = MakeIDCStream(kdis, kvals, atttab[ii].attdesc, atttab[ii].val);
         break;
      }

    case AT_REFID:
      ival = atttab[i].val;
      for (ii = 0; ii < natts; ii++)
         if (!_stricmp(atttab[ii].name, "id") &&
             !_stricmp(atttab[ii].element, atttab[i].attdesc))
            break;
      i = ii;
      goto foo;

    case AT_ID:
      ival = atttab[i].val;

    foo:

      if (isdigit(val[0]))
		s1 = MakeIDStream(val, atttab[i].attdesc, ival);
	  else
	  {
		  WORDNO kval;
		  if (!idcomp(val,atttab[i].attdesc,"000",&kval)) return NULL;
		  s1=MakeIDCStream(1,&kval,atttab[i].attdesc, ival);
	  }
      break;

    default:
      s1 = MakeAtomStream(val, 0, atttab[i].val);
      break;
   }
   return s1;
}


void NewQuery(void)
{

#if !defined(SERVER)
   ClearMarks();
#endif /* ! SERVER */

   bFilter = FALSE;
   bCase = FALSE;
   bHdr = FALSE;

   return;
}


sara_long xscore(struct locent1 *l, struct stream *s, int kwin1, int kwin2)
{
   sara_long   ks = 0;
   WORDNO      w = l->word - kwin1;

   if (w < 0)
      w = 0;

   if (!WAdStream(s, l->lcode, w, -1, FALSE))
      return 0;

   while (s->lcode == l->lcode && s->wpos <= l->word + kwin2) {
      if (s->wpos!=l->word) 
		ks++;
      if (!XAdvanceStream(s))
         break;
   }

   return ks;
}


sara_long cscore(struct stream *s1, struct stream *s2, int kwin)
{
   sara_long  ks = 0;

   while (XAdvanceStream(s1)) {
      WORDNO   w = s1->wpos - kwin;

      if (w < 0)
         w = 0;
      WAdStream(s2, s1->lcode, w, -1, FALSE);

      while (s2->lcode = s1->lcode && s2->wpos <= s1->wpos + kwin) {
         ks++;
         if (!XAdvanceStream(s2))
            return ks;
      }
   }
   return ks;
}


BOOL Get1Sol(sara_ulong text, xairo_uchar *elt, xairo_uchar *att, xairo_uchar* pfx, xairo_uchar *sol,int max)
{

   FreeStreams();
   if (!wcscmp(att, L("-")))
      return Get1Elt(text, elt, sol, max);
   if (!wcscmp(pfx, L("-")))
		return Get1AttText(text,elt,att,sol);
   return Get1Val(text,elt,att,pfx,sol);

/*
   for (i = 0; i < natts; i++)
      if (!_stricmp(elt, atttab[i].element) && !_stricmp(att, atttab[i].name))
         break;

   if (!(atttab[i].attv & AT_PLURAL))
      return FALSE;

   for (i = 0; i < natts; i++) {
      char      t[20];
      WORDNO    k;

      if (_stricmp(elt, atttab[i].element) || _stricmp(att, atttab[i].name))
         continue;
      if (!Get1Att(atttab[i].attdesc, text, atttab[i].val, &k))
         continue;
      sprintf(t, " %s%d", atttab[i].attdesc, (int) k);
      strcat(sol, t);
   }                                      
   return TRUE;
*/
 }


BOOL Get1AttText(sara_ulong text,xairo_uchar* elt,xairo_uchar* att,xairo_uchar* sol)
{
   struct stream *s1; xairo_uchar tag[1001];
   BOOL           b = TRUE;
   sara_long pos; sara_ulong lcode;
	DocToLoc(text,&pos,&lcode);

   s1 = MakeAtomStreamW(elt, 0, ID_TAGO);
   if (s1 == NULL)
      return FALSE;

   RewindStream(s1);

   if (!WAdStreamp(s1, lcode, pos, FALSE))
      b = FALSE;

   if (b) {
	   int j;
      TextExtract(lcode, s1->pos, s1->pos+1000, tag);

		tag[1000] = 0;
		for (j=0;j<1000;j++) {
			if (tag[j]=='>') break;
		}
		tag[j+1]=0;
   }

   if (b) {
	   xairo_uchar *s;
	   s=wcsstr(tag,att);
	   if (s==NULL) b=FALSE;
		s+=wcslen(att);
		if (b && *s != '=') b=FALSE;
		s++;
		if (b && *s == '\"') {
			s++;
			while (*s != '\"') {
				*sol++=*s++;
			}
		} else if (b) {
			while (isalnum(*s)) *sol++=*s++;
		}
		*sol=0;
   }


   FreeStream(s1);

   return b;
}


BOOL Get1Att(char *desc, sara_ulong text, int att, WORDNO * k)
{
   struct stream *s;
   BOOL           b = TRUE;

   s = MakeAtomStream(desc, 0, att);

   if (s == NULL)
      return FALSE;

   if (!WAdStream(s, text, 0, -1, FALSE) || s->lcode != text)
      b = FALSE;
   else
      *k = s->wpos;
   FreeStream(s);
   return b;
}


BOOL Get1Elt(sara_ulong text, xairo_uchar *elt, xairo_uchar *sol,int max)
{
	return GetNElt(text,elt,sol,max,0);
}

BOOL GetNElt(sara_ulong text, const xairo_uchar *elt, xairo_uchar *sol,int max,int n)
{
   struct stream *s1,
                 *s2;
   sara_long pos; sara_ulong lcode;
   
   BOOL           b = TRUE; int k1, k2;
	DocToLoc(text,&pos,&lcode);
   
   s1 = MakeAtomStreamW(elt, 0, it_start);
   if (s1 == NULL)
      return FALSE;

   s2 = MakeAtomStreamW(elt, 0, it_end);

   RewindStream(s1);
 
   if (!WAdStreamp(s1, lcode, pos, FALSE))
      b = FALSE;
   RewindStream(s2);

   if (!WAdStreamp(s2, lcode, s1->pos, FALSE))
      b = FALSE;
   s1->cursor+=n;
   if (!SetPos(s1)) return FALSE;
   s2->cursor+=n;
   if (!SetPos(s2)) return FALSE;
   if (LocToDoc(s2->pos,s2->lcode) != (int) text) b=FALSE;

   k1=s1->pos;
   k2=s2->pos;
   if (k2<k1) return FALSE;
   if (k2>k1+max) k2=k1+max;
   if (b)
      TextExtract(lcode,k1,k2, sol);

   FreeStream(s1);
   FreeStream(s2);

   return b;
}

BOOL Get1Val(sara_ulong text, xairo_uchar *elt, xairo_uchar* att, xairo_uchar* pfx, xairo_uchar *sol)
{
   struct stream *s1;
   sara_long pos; sara_ulong lcode;
   
   BOOL           b = TRUE;
	DocToLoc(text,&pos,&lcode);
   
	if (wcscmp(pfx,L("0"))==0) // - would be better
		s1 = MakeAttStream(elt, att, att, it_local_attribute_value);
	else
		s1 = MakeAttStream(elt, att, pfx, it_local_attribute_value);

   if (s1 == NULL)
      return FALSE;

   RewindStream(s1);

   if (!WAdStreamp(s1, lcode, pos, FALSE))
      b = FALSE;

   if (LocToDoc(s1->pos,lcode) != (int) text) b=FALSE;

   if (b)
	   wcscpy(sol,GetWordListW(s1->wpos));
 
   FreeStream(s1);

   return b;
}


struct at {
   int            ff[MAXTEXTS + 1];
   int            first[MAXTEXTS + 1];
   struct stream  s;
};
struct at acctab2[ACCMAX];


struct stream *AccelerateStream(char *s, int ex, int ty, sara_ulong cc)
{
	xairo_uchar* w=Wide(s);
	struct stream* ss=AccelerateStreamW(w,ex,ty,cc);
	DW(w);
	return ss;
}

struct stream *AccelerateStreamW(xairo_uchar *w, int ex, int ty, sara_ulong cc)
{
   int            i;
   struct stream *s;
   for (i = 0; i < nacc; i++)
#ifdef CASE_KLUDGE
      if (!wcscmp(w, acctab[i].word) && ty == acctab[i].type
          && ex == acctab[i].extra)
#else
      if (!wcscmp(w, acctab[i].word) && ty == acctab[i].type
          && ex == acctab[i].extra)
#endif
         break;

   if (i == nacc)
      return NULL;

   s = &acctab2[i].s;
   s->ff = acctab2[i].ff[cc];
   s->first = acctab2[i].first[cc] - 1; /* -1 because of bug in
                                         * indexer
                                         */
   s->lf = acctab2[i].ff[cc + 1];
   s->last = acctab2[i].first[cc + 1] - 1;
   s->count = -1;
   return s;
}



void OldSetLimits(struct stream *s, sara_ulong cc)
{
   int   i;

   switch (s->type) {
    case TY_ATOM:
      for (i = 0; i < nacc; i++)
#ifdef CASE_KLUDGE
         if (   !stricmp(s->word, acctab[i].word)
             && s->extra == acctab[i].extra
             && s->wtype == acctab[i].type)
#else
		 if (   !wcscmp(s->word, acctab[i].word)
             && s->extra == acctab[i].extra
             && s->wtype == acctab[i].type)
#endif
			 break;

      if (i == nacc)
         return;

      s->ff = acctab2[i].ff[cc];
      s->first = acctab2[i].first[cc] - 1; /* -1 because of bug in
                                            * indexer
                                            */
      s->lf = acctab2[i].ff[cc + 1];
      s->last = acctab2[i].first[cc + 1] - 1;
      s->count = -1;
      return;

    default:
      for (i = 0; i < s->ops; i++)
         SetLimits(s->op[i], 0, cc);
   }
}


BOOL myscanf(FILE *f, char *s, int *type, int *extra)
{
   char  buff[100];

   if (!fgets(buff, sizeof(buff), f))
      return FALSE;

   strcpy(s, strtok(buff, " "));

   *type = atoi(strtok(NULL, " "));
   *extra = atoi(strtok(NULL, " "));

   return TRUE;
}

struct xara_ahdr ahd;

int ** acctab3;

void SetLimits(struct stream *s, sara_long pos, sara_ulong cc)
{
	int k, i1, i2; int x;
	if (s==NULL) return;
	k=s->acc;
	if (k==-1) return;
	x=LocToDoc(pos,cc);
	i1=acctab3[k][x];
	s->first=i1 % maxiloc;
	s->ff=i1/maxiloc;
	if ((int) x+1 < ahd.nt) {
		i2=acctab3[k][x+1];
		s->last=i2 % maxiloc;
		s->lf=i2 / maxiloc;
	}
}

void SetLimitsW(struct stream *s, WORDNO w, sara_ulong cc)
{
	int k, i1, i2; int x;
	if (s==NULL) return;
	k=s->acc;
	if (k==-1) return;
	x=LocToDocW(w,cc);
	i1=acctab3[k][x];
	s->first=i1 % maxiloc;
	s->ff=i1/maxiloc;
	if ((int) x+1 < ahd.nt) {
		i2=acctab3[k][x+1];
		s->last=i2 % maxiloc;
		s->lf=i2 / maxiloc;
	}
}


BOOL GetAccels()
{
	char path[_MAX_PATH]; FILE* f; int i;
	strcpy(path,idxpath);
	strcat(path,SEPCHARS "xdbaccel");
	f=fopen(path,"rb");
	if (f==NULL) return FALSE;
	fread(&ahd,sizeof ahd,1,f);
	acctab3=(int**) malloc(ahd.na*sizeof (int*));
	for (i=0;i<ahd.na;i++) {
		acctab3[i]=(int*) malloc(ahd.nt*sizeof (int));
		fread(acctab3[i],sizeof (int),ahd.nt,f);
	}
	fclose(f);
	return TRUE;
}

void OldGetAccels(void)
{
   int   i;    
   struct stream *s;

   for (i = 0; i < nacc; i++) {
      s = MakeAtomStreamW(acctab[i].word,
                                     acctab[i].extra, acctab[i].type);
                                     
	  if (s==NULL) {
		  syslog(LOG_WARNING,"Open accelerator stream %d failed",i);
		  continue;
	  }
	  else {
		  acctab2[i].s=*s;
#if !defined(_WIN32)
      fflush(stdout);
#endif
      LoadAccel(i);
#if !defined(_WIN32)
      fflush(stdout);
#endif
	  }
   }
}


void LoadAccel(int i)
{
   char  path[_MAX_PATH];
   FILE *f;
   int   j;

   sprintf(path, "%s%i.acc", etcpath, i);
   f = fopen(path, "r");

   for (j = 0; j < ntexts; j++) {
      struct accentry accx;

      fread(&accx, sizeof(accx), 1, f);
      fix_accentry(&accx, 1);
      acctab2[i].ff[j] = accx.y;
      acctab2[i].first[j] = accx.x;
   }

   acctab2[i].ff[ntexts] = acctab2[i].s.lf;
   acctab2[i].first[ntexts] = acctab2[i].s.last;
   fclose(f);
}

struct stream* PCQStream(char* e,char* a,char* v,WORDNO k)
{
	int i;    char name[10];
	for (i=0;i<npc;i++)
		if (!strcmp(e,pcqtab[i].elt) && !strcmp(a,pcqtab[i].att) && !strcmp(v,pcqtab[i].attval) && k== pcqtab[i].val) break;
	if (i==npc) return NULL;
	sprintf(name,"pcq%d",i);
	return MakeFileStream(name);
}	
		

int LastIndex(struct stream* s)
{
	int i;
	for (i=s->ops-1;i>0;i--) {
		if (s->op[i]->type != TY_NEG) return i;
	}
	return 0;
}

BOOL WordStream(struct stream* s)
{
	if (s->wtype==it_content) return TRUE;
	if (s->wtype==it_content_attribute) return TRUE;
	if (s->wtype==it_addkey) return TRUE;
	return FALSE;
}

int stricmp(const char* s1,const char* s2)
{
	int k=0;
	while (*s1 && *s2 && (k=tolower(*s1++)-tolower(*s2++)));
	return k;
}

char* strupr(char* s)
{
	while (*s) *s++=toupper(*s);
	return NULL;
}

char* strlwr(char* s)
{
	while (*s) *s++=tolower(*s);
	return NULL;
}




}

