#include "Corpinc.h"


unsigned char WordFold(unsigned char);
int ClassifyPOS(char*);
void WPush(char*,int);
void WPop(char**,int*);
void WInit();
BOOL WAdStream(struct stream *, sara_ulong, WORDNO, int, BOOL);
void ScoreHW(xairo_uchar*);
int chash(const xairo_uchar*);
int AddLemma(const char*,int,const char*);
void ScoreWord2(char*,long,int);
extern char lemma[MAXWORD];
int PrevLoc(int);
int NextLoc(int);
xairo_uchar* HeadWord(int,int,BOOL*);
int WN(int);
void ClearDup();
const xairo_uchar* GetContName(int);

BOOL isspace0(char);
void ScoreWord(int);
int QuickFrequency(const xairo_uchar*,int);
BOOL QuickFrequencyG0(const xairo_uchar*);
int QuickForms(const xairo_uchar*);
double score(int,int,int);
long NUsages();
long SCCountWords(char*,int);
void CTabFree();

double cform(int,int,int,int);
void GetFTable(char*);
//--------------------------------------------------------------- 
// Iterate
//
// Iterate calls the function that is its argument for every entry
// in the index. 
//---------------------------------------------------------------
extern void Ents(char*);
extern BOOL LoadLemmaList();


#define MAXKTEST 100

//char tbuff[MAXCONTENT];
//long tpos[MAXCONTENT];
int t;

long pp, ph; int nw1, nw2;
int ncoll;
int ncollmax=0;
int nhits, scs; 
BOOL bEnd;
int ktest;
static char* test[MAXKTEST]; BOOL bTestMode;
int method, limit, maxs; double minz;
int hapax;
static struct regexpnew *re;
int cohtab[0x400];
extern char sElement[MAXNAME+1];


#define NCOLLMAX 2000

struct _ct {
	xairo_uchar w[MAXWORD];
	int x;
	int freq;
	double score;
	int next;
	BOOL dup;
} *colltab;

int qc(const void* v1,const void* v2)
{
	struct _ct* c1=(struct _ct*) v1;
	struct _ct* c2=(struct _ct*) v2;
	double c=c2->score-c1->score;
	if (c>0) return 1;
	else if (c<0) return -1;
	else return 0;
}

void CTab(int n,xairo_uchar** w,int* f, double* s)
{
	*w=colltab[n].w;
	*f=colltab[n].x;
	*s=colltab[n].score;
}



void InitHash(int max)
{
	int i; 
	for (i=0;i<0x400;i++) cohtab[i]=-1;
}

#define SEEDHASH 4000


void Score(int wn1,int wn2,int w1,int w2,int* d)
{
	BOOL bC;
		int k1=wn1;
		int k2=wn2;
		int i;
		ClearDup();
		i=0;
		while (i<w1) {
			xairo_uchar* t=HeadWord(k1,0,&bC);
			if (t) {
				ScoreHW(t);
				i++;
			}
			k1--;
			if (k1 < 0 || !bC) break;
		}
		i=0; 
		while (i<w2) {
			xairo_uchar* t=HeadWord(k2,0,&bC);
			if (t) {
				ScoreHW(t);
				i++;
			}
			k2++;
			if (!bC) break; 
		}
		(*d)+=w1+w2;
}

void ScoreX(struct locent1* l,char* w,int* d)
{
	int w1=LastSGML(l->word,l->lcode,w,ID_TAGO); int w2;
	if (w1 < 0) return;
	w2=NextSGML(w1,l->lcode,w,ID_TAGE);
	if (w2 < 0) return;
	if (w2<l->word) return;
	Score(l->nxt-2,l->nxt,l->nxt-2-w1,w2-l->nxt,d);
	return;
}

BOOL SetWindow(struct locent1* l,char* w,int* w1,int* w2)
{
	int v1=LastSGMLw(l->word,l->lcode,w,ID_TAGO); int v2;
	if (v1 < 0) return FALSE;
	v2=NextSGMLw(v1+1,l->lcode,w,ID_TAGE);
	if (v2 < 0) return FALSE;
	if (v2<l->word) return FALSE;
	*w1=l->word-v1;
	*w2=v2-l->word;
	return *w1 >= 0 && *w2 >= 0;
}



int MakeCTab0(char* name,int w1,int w2,int nl,xairo_uchar* pattern,char* we,BOOL bX)
{
	char* sol; struct locent1 l; FILE* f; int mm;
	int ol=nlemma; int d; BOOL bCA=(nl > 0); struct _ct* oct;
	int m, i, tt, ncoll0;  nw1=w1; nw2=w2;
	if (nl) {
		nlemma=nl-1;
		LoadLemmaList();
	}
	bInt=FALSE;
	re=ParseRegExp(pattern,FALSE);
	sol = GetQPath(name); 
	ncoll=0; 
	if (ncollmax > 0) return -1;
	colltab=(struct _ct *) calloc(NCOLLMAX+SEEDHASH,sizeof (struct _ct));
	ncollmax=NCOLLMAX+SEEDHASH;
	InitHash(SEEDHASH);
	if ((f = fopen(sol, "r")) == NULL) {
		syslog(LOG_ERR, "Couldn't open %s\n", name);
		return -1;
	}
	fseek(f,0,SEEK_END);
	nhits=ftell(f)/sizeof l;
	scs=NUsages();
	fseek(f,0,SEEK_SET);
	syslog(LOG_DEBUG,"Started table");
	tt=0;
	d=0;
	while (fread(&l,sizeof(l),1,f)) {
		if (bX) 
			if (!SetWindow(&l,we,&w1,&w2)) continue;
		Score(l.nxt-2,l.nxt,w1,w2,&d);

		if (TestInterrupt()) {fclose(f); return -1;}
		tt++;

	}
	fclose(f);
	if (colltab==NULL) return -1;
	syslog(LOG_DEBUG,"Looking up frequencies");
	for (i=0;i<ncoll;i++) {
		int f=colltab[i].freq; double s=0;
		if (f==0 && colltab[i].x > hapax) {
			f=QuickFrequency(colltab[i].w,nl); 
			assert(f != 0);
		}
		if (colltab[i].x <= hapax) colltab[i].x=0;
		if (colltab[i].x > 0 && f > 0)
			s=score(colltab[i].x,f,d);
		else 
			s=-1000;
		colltab[i].score=s;
		colltab[i].freq=f;
	}
	syslog(LOG_DEBUG,"Sorting");
	qsort(colltab,ncoll,sizeof (struct _ct),qc);
	for (i=0;i<ncoll;i++) 
		if (colltab[i].x==0) break;
	ncoll0=i;
	syslog(LOG_DEBUG,"Done");
	switch (limit) {
	case 0:
		m=maxs;
		break;
	case 1:
		for (i=0;i<ncoll0;i++)
			if (colltab[i].score<minz) break;
		m=i;
	}
	if (nl) {
		nlemma=ol;
		LoadLemmaList();
	}
	mm=min(m,ncoll0);
	oct=colltab;
	colltab=(struct _ct*) calloc(mm,sizeof(struct _ct));
	memcpy(colltab,oct,mm*sizeof(struct _ct));
	free(oct);
	return mm;
}

int MakeCTab(char* name,int w1,int w2,int nl,xairo_uchar* pattern)
{
	return MakeCTab0(name,w1,w2,nl,pattern,"",FALSE);
}

int MakeCTabX(char* name,char* w,int nl,xairo_uchar* pattern)
{
	return MakeCTab0(name,0,0,nl,pattern,w,TRUE);
}

BOOL bRet;







int chash(const xairo_uchar* c)
{
	int h=c[0] & 0x1F;
	if (c[0]) h+=(c[1]&0x1F) << 5;
	return h;
}

void ClearDup()
{
	int i;
	for (i=0;i<ncoll;i++)
		colltab[i].dup=FALSE;
}

void ScoreHW(xairo_uchar* hw)
{
	int k, n, h; int* p; int kt;
	if (!pMatch(hw,re)) return;
	h=chash(hw);
	kt=cohtab[h];
	p=&cohtab[h];
	while (kt != -1) {
		if (!wcscmp(hw,colltab[kt].w)) break;
		p=&colltab[kt].next;
		kt=colltab[kt].next;
	}
	if (kt==-1) {
//		f=QuickFrequency(hw);
//		assert(f != 0);
//		if (f==0) return;
		k=0;
	}
	else {
//		f=colltab[i].freq;
		k=colltab[kt].x;
	} 
	k++;
//	s=score(k,f);
	if (kt != -1) {
		if (!colltab[kt].dup) colltab[kt].x=k;
		colltab[kt].dup=TRUE;
//		colltab[i].score=s;
		return;
	}
	if (ncoll >= ncollmax) {
		int p0;
		ncollmax+=NCOLLMAX;
		p0=((char*) p)-((char*)colltab);
		colltab=realloc(colltab,ncollmax*sizeof (struct _ct));
		if (colltab==NULL) return;
		p=(int*) (((char*) colltab)+p0);
	}
	n=ncoll;
	ncoll++;
	wcsncpy(colltab[n].w,hw,MAXWORD);
	colltab[n].x=k;
	colltab[n].dup=TRUE;
	colltab[n].next=-1;
	colltab[n].freq=0;
	*p=n;
//	colltab[n].score=s;
//	colltab[n].freq=f;
}

int nwo;


double score(int k,int f,int d)
{
	double p=((double) f)/scs;
	return cform(k,f,d,nhits);
}

BOOL ACScore(char* q,int kwin1,int kwin2,int meth,xairo_uchar* cql,long* ns,double* sc)
{
	int om=method; int n;
	method=meth;
	n=MakeCTab(q,kwin1,kwin2,0,cql);
	method=om;
	if (n) {
		*ns=colltab[0].x;
		*sc=colltab[0].score;
	}
	CTabFree();
	return n != 0;
}

double cform(int x,int f,int d,int nhits)
{
	double s; double p=f/(double) NUsages();
	assert(d > 0); assert(p > 0);
	switch (method) {
	case 0: {  // z score
		s=x-p*d;
		s=s/sqrt(d*p*(1-p));
		break;
			}
	case 1: {
		int a=x; 
		int b=f;
		int c=nhits;
		int d=NUsages()-a-b-c;
		double x=a*(double) NUsages()/(b*c);
		double s1=log(x);
		double s2=log(2);
		s=s1/s2;
			}
	}
	return s;
}

void CTabThin(char* oldn,char* newn,int w1,int w2,int nl,xairo_uchar* node,int* ns,int* nt,BOOL bX,char* welt)
{
	char *p1, *p2; struct locent1 l; xairo_uchar* tok; int i;
	FILE *fin, *fout; struct stream *s=NULL; struct stream *ss=NULL;
	xairo_uchar oc;
	p1=GetQPath(oldn);
	p2=GetQPath(newn);
	fin=fopen(p1,"r");
	fout=fopen(p2,"w");
	*ns=*nt=0;
	s=GrabStream();
	s->type=TY_OR;
	i=0;
	while (*node) {
        while (*node==' ') node++;
		if (*node==0) break;
		tok=node;
		while (*node && *node != ' ') node++;
		oc=*node;
		*node=0;
        if (nl) 
			ss=MakeAllPosStream(tok,GetContName(nl-1));
		else 
			ss=MakeLemmaStream(tok);
		*node=oc;
		if (ss==NULL) continue;
		s->op[i++]=ss;
	}
	s->ops=i;
	s->wc=1;
	if (i==0) return;
	if (i==1) {
		s->ops=0;
		FreeStreamR(s);
		s=ss;
	}
	while (fread(&l,sizeof(l),1,fin)) {
		WORDNO  w    ; BOOL bRW=FALSE; int nw;
		if (bX && !SetWindow(&l,welt,&w1,&w2)) continue;
		w = l.word - w1;
		if (!WAdStream(s, l.lcode, w, -1, FALSE))
			break;
//		nw=WN(l.nxt)-l.word-1;
		nw=l.wc-1;
		if (s->lcode == l.lcode && s->wpos >= l.word && s->wpos <= l.word+nw)
		{
			bRW=TRUE;
			if (!WAdStream(s,l.lcode,l.word+1,-1,FALSE)) 
				break;
		}
//		else 
			if (s->lcode == l.lcode &&  s->wpos <= l.word + nw+ w2) {
			struct locent1 ll;
			ll.lcode=l.lcode;
			if (s->pos<l.pos) {
				ll.pos=s->pos;
				ll.word=s->wpos;
//				ll.pre=s->pre;
				ll.lw=l.lw+l.pos-s->pos;
				ll.nxt=l.nxt;
				ll.wc=l.wc+l.word-s->wpos;
			} else {
				ll.pos=l.pos;
				ll.word=l.word;
//				ll.pre=l.pre;
				ll.lw=s->lw+s->pos-l.pos;
				ll.nxt=s->nxt;
				ll.wc=s->wpos+s->wc-l.word;
			}
			fwrite(&ll,sizeof ll,1,fout);
			(*ns)++;
		} // else if (bRW) RewindStream(s);
	}
	fclose(fin);
	fclose(fout);
	FreeStreamR(s);
}

CTabOptions(int m,int l,char* p,int hap)
{
	method=m;
	limit=l;
	hapax=hap;
	maxs=100; minz=4.5; 
	switch (l) {
	case 0:
		maxs=atoi(p);
		break;
	case 1:
		minz=atof(p);
		break;
	}
}

BOOL isspace0(char c)
{
	return 0 <= c && c <= 32;
}

void CTabFree()
{
	free(colltab);
	ncollmax =0;
}


