#include "SServer.h"
#include "AttributeDictionary.h"
#include "WordList.h"
#include "Parameters.h"
#include "DataReader.h"

XAIRO_NAMESPACE_BEGIN

CAttributeDictionary::CAttributeDictionary(CWordList* wl,CXairoServer* s):m_wl(wl),m_server(s)
{
}

CAttributeDictionary::~CAttributeDictionary()
{
	delete [] m_tl;
}

// Note that at present the type dictionary lacks namespace support
int CAttributeDictionary::Lookup(const xairo_uchar* a,const xairo_uchar* e,const xairo_uchar* ns)
{
	typ ty;
	if (wcscmp(e,L("0"))==0) {
		ty=it_global_attribute;
	} 
	else 
		ty=it_local_attribute;
	int i;
	for (i=0;i<m_ktl;i++) {
		xara_type* t=&m_tl[i];
		if (t->t != ty) continue;
		if (ty==it_local_attribute) {
			if (wcscmp(a,m_wl->GetWordW(t->att))==0 && wcscmp(e,m_wl->GetWordW(t->element))==0
				/* && wcscmp(ns,m_wl->GetWordW(t->euri))==0 */ ) 
				break;
		} else 
			if (wcscmp(a,m_wl->GetWordW(t->att))==0 /* && wcscmp(ns,m_wl->GetWordW(t->auri))==0*/) break;
	}
	if (i==m_ktl) return -1;
	return m_tl[i].first;
}


bool CAttributeDictionary::Load()
{
	const xairo_uchar* path=m_server->GetParam()->exppath(PARAM_INDEXPATH,L("xdbtype"));
	FILE* f=_wfopen(path,L("rb"));
	if (f==NULL){
		m_server->BootLog(L("The file xdbtype is missing\n"));
		return false;
	}
	fseek(f,0,SEEK_END);
	int k=ftell(f);
	fseek(f,0,SEEK_SET);
	m_ktl=k/sizeof (struct xara_type);
	CDataReader* d=new CDataReader(m_ktl,f);
	m_tl=new xara_type [k];
	d->ReadType(m_ktl,m_tl);
	fclose(f);
	return true;
}

XAIRO_NAMESPACE_END
