#pragma once

XAIRO_NAMESPACE_BEGIN

#define NKEYS 100

class CDBKey {
	friend class CKDB;
public:
	int getId() {return n;}
private:
	int id;
	int n;
	int pid;
	FILE* f;
	int l;
	bool bNull;
	int count;
	const char* pre;
	CDBKey() {bNull=true; count=-1; f=NULL;}
//	CDBKey(int n0,int l0):n(n0),l(l0),bNull(false),count(-1){}
};

class CXairoServer;

class CKDB
{
public:
	CKDB();
	~CKDB();
	CDBKey* newkey(int,const char *p="x");
	void closekey(CDBKey*);
	int record(CDBKey*,void*,unsigned,int);
	void deletekey(CDBKey*);
	int countrecords(CDBKey*);
	bool recorded(CDBKey*,int,void*);
	bool frecorded(CDBKey*,int,void*);
	void fop(CDBKey*);
	void fcl(CDBKey*);
	bool Init(CXairoServer*);
	const xairo_uchar* getId(CDBKey*);
	CDBKey* getKey(int,int);
private:
	CXairoServer* m_server;
	int m_n;
	char m_tmppath[_MAX_PATH];
	CDBKey** m_keys;
	int m_nkeys;
	void keypath(CDBKey*,char*);
};

XAIRO_NAMESPACE_END
