#include "RegularExpression.h"

XAIRO_NAMESPACE_BEGIN


CRegularExpression::CRegularExpression(const xairo_uchar* pattern,bool bcase):m_pattern(pattern),m_bCase(bcase)
{
}

CRegularExpression::~CRegularExpression()
{
}
// Do this properly with Unicode

bool CRegularExpression::rawchar(xairo_uchar w)
{
	if ('a'<=w && w <= 'z') return true;
	if ('A'<=w && w <= 'Z') return true;
	return false;
}



UnicodeString CRegularExpression::Predict(int max)
{
	int i;
	UnicodeString pre;
	for (i=0;i<max-1;i++) {
		if (m_pattern[i]==0 || !rawchar(m_pattern[i])) break;
		pre+=m_pattern[i];
	}
	return pre;
}

bool CRegularExpression::Parse()
{
	if (m_pattern[0]==0) return false;
	UErrorCode pErr=U_ZERO_ERROR; UParseError pE;
	m_e=RegexPattern::compile((const UChar*) m_pattern,UREGEX_COMMENTS|(m_bCase?0:UREGEX_CASE_INSENSITIVE),pE,pErr);
	if (U_FAILURE(pErr)) {
		return false;
	}
	return true;
}


bool CRegularExpression::Match(const xairo_uchar* x)
{
	UErrorCode pErr=U_ZERO_ERROR;
	UnicodeString s((const UChar*) x);
	RegexMatcher* m=m_e->matcher(s,pErr);
	UBool b=m->matches(pErr);
	delete m;
	return b==1;
}

XAIRO_NAMESPACE_END
