#include "SServer.h"
#include "SB.h"
#include "WordList.h"
#include "Parameters.h"
#include "DataReader.h"

XAIRO_NAMESPACE_BEGIN

CSB::CSB(CWordList* wl,CXairoServer* s):m_wl(wl),m_server(s)
{
}

CSB::~CSB()
{
	for (int i=0;i<m_kk;i++) {
		delete [] m_sb[i].w.con;
	}
	delete [] m_sb;
}

bool CSB::Load()
{
	int ncont=m_wl->GetNAddkeys();
	FILE* fStreamBase=_wfopen(m_server->GetParam()->exppath(PARAM_INDEXPATH,L("xdbdict")),L("rb"));
	if (fStreamBase==NULL) {
		m_server->BootLog(L("The dictionary is missing\n"));
		return false;
	}
	fseek(fStreamBase,0,SEEK_END);
	int k=ftell(fStreamBase);
	fseek(fStreamBase,0,SEEK_SET);
	m_x=sizeof (xara_streambase) + ncont*sizeof (int)-4; // better keep in hdr
	m_kk=k/m_x;
	CDataReader* d=new CDataReader(m_x,fStreamBase);
	m_sb=new xara_streambase [m_kk];
	if (m_sb==NULL) {
		m_server->BootLog(L("Insufficient memory for dictionary (%d needed)\n"),k);
		return false;
	}
	d->ReadStreamBase(m_kk,ncont,m_sb);
	return true;
}

xara_streambase* CSB::GetSB(int i)
{
	return &m_sb[i];
}

XAIRO_NAMESPACE_END
