#pragma once

XAIRO_NAMESPACE_BEGIN

#define MAXLTNAME 10
#define MAXNF 100
#define MAXTAX 100
#define MAXWORD 100
#define MAXNAME 10

struct _lemmatab {
	char name[MAXLTNAME];
	int idx;
	char info[MAXLTNAME];
};

struct _catab {
	char name[MAXLTNAME];
	int idx;
	int nf;
	int fil[MAXNF];
	xairo_uchar def[MAXWORD];
};

struct _tax {
	xairo_uchar name[MAXNAME];
	int nc;
};


class CWordList
{
	friend class CXairoGrammar;
public:
	CWordList(CXairoServer*);
	~CWordList();
	const xairo_uchar* GetWordW(int);
	const char* GetWord(int);
	int Count() {return m_wlsize;}
	bool Load();
	int LookupW(const xairo_uchar*);
	int GetDictPtr(int i) {return m_wl[i].dicptr;}
	int addkey_index(const xairo_uchar*);
	int lemma_index(const xairo_uchar*);
	int GetNAddkeys() {return m_ncont;}
	int GetNLemmas() {return m_nls;}
	void SetLS(int n,xairo_uchar** a) {m_nls=n; m_ls=a;}
private:
	xara_wl* m_wl;
	int	m_hashsize, m_wlsize, m_places, m_shift, m_ntax;
	int *m_hi;
	xara_wl_header_tax* m_tax;
	int hash(const xairo_uchar*);
	CXairoServer* m_server;
	int m_ncont;
	xara_wl_header_addkey* m_cont;
	int m_nls;
	xairo_uchar** m_ls;

};

XAIRO_NAMESPACE_END
