#include "SServer.h"
#include "WordList.h"
#include "XairoAddkeyFilter.h"

XAIRO_NAMESPACE_BEGIN

CXairoAddkeyFilter::CXairoAddkeyFilter(CDBKey* k,CXairoServer* s)
{
	m_key=k;
	m_server=s;
}

CXairoAddkeyFilter::~CXairoAddkeyFilter(void)
{
}

#define FAK L("ak(%d)")

const xairo_uchar* CXairoAddkeyFilter::getId()
{
	m_bOwns=false;
	return CXairoServer::MakeId(FAK,m_key->getId());
}


CXairoAddkeyFilter::CXairoAddkeyFilter(const xairo_uchar* id,CXairoServer* s):m_server(s)
{
	int k;
	CXairoServer::ScanId(FAK,id,&k);
	m_key=m_server->GetDB()->getKey(k,sizeof(int));
	m_bOwns=false;
}

int CXairoAddkeyFilter::getCount() const
{
		return m_server->GetDB()->countrecords(m_key)-1;
}

const xairo_uchar* CXairoAddkeyFilter::getVal(int n) const
{
	int p;
	if (!m_server->GetDB()->recorded(m_key,n+1,&p)) return 0;
	return m_server->GetWL()->GetWordW(p);
}

const xairo_uchar* CXairoAddkeyFilter::getKey() const
{
	int p;
	if (!m_server->GetDB()->recorded(m_key,0,&p)) return 0;
	return m_server->GetWL()->GetWordW(p);
}

int CXairoAddkeyFilter::getValN(int n) const
{
	int p;
	if (!m_server->GetDB()->recorded(m_key,n+1,&p)) return -1;
	return p;
}


XAIRO_NAMESPACE_END