#include "SServer.h"
#include "Dictionary.h"
#include "WordList.h"
#include "XairoAddkeyValueList.h"
#include "XairoAddkeyValue.h"

XAIRO_NAMESPACE_BEGIN


CXairoAddkeyValueList::~CXairoAddkeyValueList(void)
{
}

int CXairoAddkeyValueList::getCount()
{
	CDictionary *d=m_server->GetDict(m_nd);
	return d->Count();
}

CXairoIAddkeyValue* CXairoAddkeyValueList::getAddkeyValue(int n)
{
	CDictionary *d=m_server->GetDict(m_nd);
	xara_lemma* l=d->LookupEntry(n);
	const xairo_uchar* s=m_server->GetWL()->GetWordW(l->word[0]);
	return new CXairoAddkeyValue(s,l->freq);
}

#define AKVL L("akvl(%d)")

const xairo_uchar* CXairoAddkeyValueList::getId()
{
	return CXairoServer::MakeId(AKVL,m_nd);
}

CXairoAddkeyValueList::CXairoAddkeyValueList(const xairo_uchar* id,CXairoServer* s):m_server(s)
{
	int k=CXairoServer::ScanId(AKVL,id);
	m_nd=k;
}

XAIRO_NAMESPACE_END