#pragma once

#include "../XairoHeader.h"

XAIRO_NAMESPACE_BEGIN


class CXairoAttributeValue : public CXairoIAttributeValue
	{
	public:
		CXairoAttributeValue(const xairo_uchar* val,int f,const xairo_uchar* g,int sb,CXairoServer* s):m_val(val),m_frequency(f),m_gloss(g),m_sb(sb),m_server(s) {}
		CXairoAttributeValue(const xairo_uchar*,CXairoServer*);
		~CXairoAttributeValue();
		XAIRO_API_EXPORT const xairo_uchar* getValue() {return m_val;}
		XAIRO_API_EXPORT int getFrequency() {return m_frequency;}
		XAIRO_API_EXPORT int getFilteredFrequency(const CXairoICorpusTextFilter*);
		XAIRO_API_EXPORT const xairo_uchar* getGloss() {return m_gloss;}
		const xairo_uchar* getId();
	private:
		const xairo_uchar* m_val;
		int m_frequency;
		const xairo_uchar* m_gloss;
		int m_sb;
		CXairoServer* m_server;
};

XAIRO_NAMESPACE_END
