#include "SServer.h"
#include "XairoSolution.h"
#include "XairoCollocationTable.h"
#include "WordList.h"
#include "XairoCollocate.h"

XAIRO_NAMESPACE_BEGIN

CXairoCollocationTable::CXairoCollocationTable(CDBKey* k,CXairoServer* s):m_key(k),m_server(s)
{
}

CXairoCollocationTable::~CXairoCollocationTable()
{
}

int CXairoCollocationTable::getCount()
{
	return m_server->GetDB()->countrecords(m_key);
}

CXairoICollocate* CXairoCollocationTable::getCollocate(int n)
{
	_colt c;
	m_server->GetDB()->recorded(m_key,n,&c);
	return new CXairoCollocate(m_d,c.p,c.freq,c.x,c.score,m_server);
}


#define FCOL L("col(%d,%d)")

const xairo_uchar* CXairoCollocationTable::getId()
{
	return CXairoServer::MakeId(FCOL,m_key->getId(),m_d);
}

CXairoCollocationTable::CXairoCollocationTable(const xairo_uchar* id,const xairo_uchar* ak,_cwin win,CXairoServer* s):m_server(s)
{
	int k=0;
	CXairoServer::ScanId(FCOL,id,&k,&m_d);
	m_key=m_server->GetDB()->getKey(k,sizeof(struct _colt));
	m_addkey=ak;
	m_cwin=win;
}

CXairoCollocationTable::CXairoCollocationTable(const xairo_uchar* id,CXairoServer* s):m_server(s)
{
	int k=0;
	CXairoServer::ScanId(FCOL,id,&k,&m_d);
	m_key=m_server->GetDB()->getKey(k,sizeof(struct _colt));
}

XAIRO_NAMESPACE_END
