#pragma once


#include "XPathTokeniser.h"
#include "Grammar.h"

XAIRO_NAMESPACE_BEGIN

class CXairoXpathValue;

enum _xnt {NT_TEXT,NT_ATT};

struct _xrange {
	_xnt nt;
	xara_loc start;
	xara_loc end;
	int parent;
	const xairo_uchar* elt;
	int pos,size;
	const xairo_uchar* def_uri;
};

enum _xopty {XOP_STR,XOP_PATH};

struct _xop {
	_xopty ty;
	const xairo_uchar* string;
	const xairo_uchar* path;
};

enum _xtty {XTTY_POS,XTTY_PATH,XTTY_COMP};


struct _xtest {
	_xtty xtty;
	int pos;
	const xairo_uchar* xpath;
	_xop op1, op2;
};


struct _xpc {
	const xairo_uchar* elt;
	const xairo_uchar* att;
	const xairo_uchar* ns;
	bool bParent, bAtt, bAbs;
	int ntests;
	_xtest* tests;
};

#include "../XairoHeader.h"

class CXairoCorpusText : public CXairoICorpusText
{
public:
	CXairoCorpusText(int,CXairoServer*);
//	CXairoCorpusText(const xairo_uchar*,CXairoServer*);
	~CXairoCorpusText();
	XAIRO_API_EXPORT const xairo_uchar* getTitle();
	XAIRO_API_EXPORT CXairoIXpathValue* evalXpath(const xairo_uchar* path);
	XAIRO_API_EXPORT int classify(const CXairoIGrammar::Partition*);
	XAIRO_API_EXPORT int getWordCount();
	XAIRO_API_EXPORT bool isSelected(CXairoICorpusTextFilter*);
	XAIRO_API_EXPORT CXairoITextEntity* getTextEntity();
	XAIRO_API_EXPORT int getIndex(){return m_i;}
	const xairo_uchar* NodeText(_xrange*);
	const xairo_uchar* getId(); 

private:
	_xpc* parseXpath(const xairo_uchar*,int& k);
	const xairo_uchar* EvalAttribute(const xairo_uchar*,const xairo_uchar*,const xairo_uchar*,xara_loc);
	CXairoXpathValue* evalXpathinContext(const xairo_uchar*,_xrange);
	bool pathchar(xairo_uchar);
	CXairoXpathValue* FilterNodes(CXairoXpathValue*,_xpe*);
	CXairoXpathValue* FilterNodesOnce(_xpe*,CXairoXpathValue*);
	CXairoXpathValue* evalXpathinContext(_xpe*,_xrange*);
	bool FilterByCQL(_xrange*,const xairo_uchar*);
	const xairo_uchar* EvalPrefix(const xairo_uchar* p,_xrange* r);

	CXairoXpathValue* ApplyNCTest(CXairoXpathValue*,_xpe*,bool);
	CXairoXpathValue* ApplyNCTest(_xrange*,_xpe*,bool);
	CXairoXpathValue* ApplyNCATest(CXairoXpathValue*,_xpe*);
	CXairoXpathValue* ApplyNCATest(_xrange*,_xpe*);
	_xrange* GetRootNode();
	CXairoXpathValue* EvalFn(_xpe*,_xrange*);
	bool Compare(_xpe*,_xpe*,_xrange*);
	int m_i;
	CXairoServer* m_server;
	_xrange m_range;
	void InitRange();
};

XAIRO_NAMESPACE_END
