#include "SServer.h"
#include "XairoCorpusTextList.h"
#include "Stream.h"
#include "XairoCorpusText.h"
#include "XairoCorpusTextFilter.h"
#include "XairoSolveError.h"

XAIRO_NAMESPACE_BEGIN

CXairoCorpusTextList::CXairoCorpusTextList(CXairoServer* s):m_server(s)
{
}

CXairoCorpusTextList::~CXairoCorpusTextList()
{
}

int CXairoCorpusTextList::getCount()
{
	CAtomStream* ds=m_server->GetDocumentStream();
	return ds->Count();
}

CXairoICorpusText* CXairoCorpusTextList::getCorpusText(int i)
{
	return new CXairoCorpusText(i,m_server);
}

CXairoICorpusTextFilter* CXairoCorpusTextList::getCorpusTextFilter(CXairoIGrammar::Partition* p,int n)
{
	int nt=getCount();
	CDBKey* key=m_server->GetDB()->newkey(sizeof(int),"ctf");
	for (int i=0;i<nt;i++) {
		if (getCorpusText(i)->classify(p)==n) m_server->GetDB()->record(key,&i,sizeof(int),1);
	}
	m_server->GetDB()->closekey(key);
	return new CXairoCorpusTextFilter(key,m_server);
}

CXairoICorpusTextFilter* CXairoCorpusTextList::getCorpusTextFilter(int nt,int* t)
{
	int ns=0;
	for (int i=0;i<nt;i++)
		if (t[i]) ns++;
	if (ns==0) 
		throw new CXairoError(CXairoIError::ERR_FILTER,L("No texts selected"));
	if (nt==0) return NULL;
	CDBKey* key=m_server->GetDB()->newkey(sizeof(int),"ctf");
	for (int i=0;i<nt;i++) {
		m_server->GetDB()->record(key,&t[i],sizeof(int),1);
	}
	m_server->GetDB()->closekey(key);
	return new CXairoCorpusTextFilter(key,m_server);
}

XAIRO_NAMESPACE_END
