#include "SServer.h"
#include "XairoExtendedForm.h"
#include "WordList.h"
#include "SB.h"

XAIRO_NAMESPACE_BEGIN


const xairo_uchar* CXairoExtendedForm::getAdditionalKey(const xairo_uchar* n)
{
	int i=m_server->GetWL()->addkey_index(n);
	if (i < 0) return L("");
	xara_streambase *sb=m_server->GetSB()->GetSB(m_i);
	return m_server->GetWL()->GetWordW(sb->w.con[i]);
}

const xairo_uchar* CXairoExtendedForm::getNorm()
{
	xara_streambase *sb=m_server->GetSB()->GetSB(m_i);
	return m_server->GetWL()->GetWordW(sb->w.val);
}

const xairo_uchar* CXairoExtendedForm::getText()
{
	xara_streambase *sb=m_server->GetSB()->GetSB(m_i);
	return m_server->GetWL()->GetWordW(sb->w.xval);
}

const xairo_uchar* CXairoExtendedForm::getData(int i)
{
	enum sbt {SB_VAL,SB_XVAL,SB_URI,SB_NAME,SB_EURI,SB_ELEMENT};
	xara_streambase *sb=m_server->GetSB()->GetSB(m_i);
	int kw=-1;
	switch (i) {
		case SB_VAL:
			kw=sb->w.val;
			break;
		case SB_XVAL:
			kw=sb->w.xval;
			break;
		case SB_URI:
			kw=sb->w.uri;
			break;
		case SB_NAME:
			kw=sb->w.name;
			break;
		case SB_EURI:
			kw=sb->w.euri;
			break;
		case SB_ELEMENT:
			kw=sb->w.name;
			break;
	}
	if (kw < 0) return L("");
	return m_server->GetWL()->GetWordW(kw);
}

CXairoIExtendedForm::type CXairoExtendedForm::getType()
{
	xara_streambase *sb=m_server->GetSB()->GetSB(m_i);
	return (CXairoIExtendedForm::type) sb->w.t;
}


XAIRO_NAMESPACE_END
