#pragma once

#include "../XairoHeader.h"

XAIRO_NAMESPACE_BEGIN

class CXairoITextEntity;
class CXairoICorpusText;



class CXairoHit : public CXairoIHit
{
public:
	CXairoHit(xara_loc,int,CXairoServer*);
	~CXairoHit();
	XAIRO_API_EXPORT const xairo_uchar* getText(int,int);
	XAIRO_API_EXPORT CXairoICorpusText* getCorpusText();
	XAIRO_API_EXPORT const xairo_uchar* getUnit();
	XAIRO_API_EXPORT CXairoITextEntity* getTextEntity();
	XAIRO_API_EXPORT unsigned int getCursorStart() {return m_loc.seq;}
	XAIRO_API_EXPORT unsigned int getCursorEnd() {return m_loc.seq+m_loc.nw;}
	int getDocNo() {return m_doc;}
	int getFileNo() {return m_loc.fi;}
private:
	xara_loc m_loc;
	int m_doc;
	CXairoServer* m_server;
	bool m_bMissing;
	const xairo_uchar* Ellipsis(const xairo_uchar* w,int,int,int max,const xairo_uchar*);
	struct _node* GetNode(const xairo_uchar* in,int& k);
	struct _node* GetElementNode(const xairo_uchar* w,int& k);
	struct _charent* GetEntity(const xairo_uchar* w,int&);
	const xairo_uchar* AttEnts(const xairo_uchar*,int);
	const xairo_uchar* CanonicalEntity(_charent*,int);
};

XAIRO_NAMESPACE_END
