#include "SServer.h"
#include "XairoWordList.h"
#include "Dictionary.h"

XAIRO_NAMESPACE_BEGIN


CXairoWordList::CXairoWordList(CDBKey* k,int d,CXairoServer* s):m_key(k),m_server(s),m_dict(d)
{
}

CXairoWordList::~CXairoWordList()
{
	m_server->GetDB()->deletekey(m_key);
}

int CXairoWordList::getCount()
{
	return m_server->GetDB()->countrecords(m_key);
}

CXairoWord* CXairoWordList::getWord(int n)
{
	CXairoWord::_ff  p;
//	CDictionary* d=m_server->GetDict(m_dict);
	if (!m_server->GetDB()->recorded(m_key,n,&p)) return 0;
//	xara_lemma* w=d->LookupEntry(p);
	return new CXairoWord(m_dict,p,m_server);
}

#define FWL L("wl(%d,%d)")

const xairo_uchar* CXairoWordList::getId()
{
	return CXairoServer::MakeId(FWL,m_key->getId(),m_dict+1);
}

CXairoWordList::CXairoWordList(const xairo_uchar* id,CXairoServer* s):m_server(s)
{
	int k,d;
	CXairoServer::ScanId(FWL,id,&k,&d);
	m_dict=d-1;
	m_key=m_server->GetDB()->getKey(k,sizeof(CXairoWord::_ff));
}

XAIRO_NAMESPACE_END
