#pragma once

#include "../XairoHeader.h"

XAIRO_NAMESPACE_BEGIN

struct _xrange;

enum _xptype {XPT_NODESET,XPT_STRING,XPT_NUMBER,XPT_BOOL};

class CXairoCorpusText;


class CXairoXpathValue : public CXairoIXpathValue
{
public:
	CXairoXpathValue(CXairoCorpusText*);
	CXairoXpathValue(const xairo_uchar*,_xptype,CXairoCorpusText*);
	CXairoXpathValue(int,CXairoCorpusText*);
	CXairoXpathValue(_xrange*,CXairoCorpusText*);
	CXairoXpathValue(bool,CXairoCorpusText*);
	~CXairoXpathValue(void);
	bool IsNumber() {return m_type==XPT_NUMBER;}
	void Add(_xrange*);
	void Add(CXairoXpathValue*);
	int Count();
	_xrange* Node(int);

	XAIRO_API_EXPORT const xairo_uchar* getText();
	bool getBool();
	int getNumber();

	bool Compare(CXairoXpathValue*);
private:
	_xptype m_type;
	const xairo_uchar* m_text;
	int m_n;
	_xrange* m_nodes;
	CXairoCorpusText* m_ct;
	bool m_bool;
	int m_nalloc;
	const xairo_uchar* m_string;
};

XAIRO_NAMESPACE_END
