#include "stdafx.h"
#include "XairoProxyCollocationTable.h"
#include "XairoProxyCollocate.h"

CXairoProxyCollocationTable::CXairoProxyCollocationTable(const xairo_uchar* id,CXairoProxyServer* s):
	m_id(id),m_server(s)
{
}

CXairoProxyCollocationTable::~CXairoProxyCollocationTable(void)
{
}

int CXairoProxyCollocationTable::getCount()
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_STRING;
	x[0].s=m_id;
	s=RPCCall(L("CollocationTable_getCount"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

CXairoICollocate* CXairoProxyCollocationTable::getCollocate(int i)
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_I4; x[1].i=i;
	s=RPCCall(L("CollocationTable_getCollocate"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar* wid=RPCStringParam(d,0);
	int h=RPCIntParam(d,1);
	double sc=RPCDoubleParam(d,2);
	return new CXairoProxyCollocate(wid,h,sc,m_server);

}
