#include "stdafx.h"
#include "XairoProxyCorpusText.h"
#include "XairoProxyCorpusTextFilter.h"
#include "XairoProxyXpathValue.h"
#include "XairoProxyTextEntity.h"

CXairoProxyCorpusText::~CXairoProxyCorpusText(void)
{
}

const xairo_uchar* CXairoProxyCorpusText::getTitle()
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=m_id;
	s=RPCCall(L("CorpusText_getTitle"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}

int CXairoProxyCorpusText::getIndex()
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=m_id;
	s=RPCCall(L("CorpusText_getIndex"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

int CXairoProxyCorpusText::classify(const CXairoIGrammar::Partition* p)
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_I4; x[0].i=m_id;
	x[1].t=XMLRPC_STRING; x[1].s=((CXairoProxyGrammar::Partition*) p)->getId();
	s=RPCCall(L("CorpusText_classify"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

CXairoIXpathValue* CXairoProxyCorpusText::evalXpath(const xairo_uchar* path)
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_I4; x[0].i=m_id;
	x[1].t=XMLRPC_STRING; x[1].s=path;
	s=RPCCall(L("CorpusText_evalXpath"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar * id=RPCStringParam(d,0);
	return new CXairoProxyXpathValue(id);
}

int CXairoProxyCorpusText::getWordCount()
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=m_id;
	s=RPCCall(L("CorpusText_getWordCount"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

bool CXairoProxyCorpusText::isSelected(CXairoICorpusTextFilter* f)
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_I4; x[0].i=m_id;
	x[1].t=XMLRPC_STRING; x[1].s=((CXairoProxyCorpusTextFilter*) f)->getId();
	s=RPCCall(L("CorpusText_isSelected"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCBoolParam(d,0);

}

CXairoITextEntity* CXairoProxyCorpusText::getTextEntity()
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=m_id;
	s=RPCCall(L("CorpusText_getTextEntity"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return new CXairoProxyTextEntity(RPCStringParam(d,0));
}
