#include "stdafx.h"
#include "XairoProxyForm.h"
#include "XairoProxyCorpusTextFilter.h"
#include "XairoProxyAddkeyFilter.h"

CXairoProxyForm::~CXairoProxyForm(void)
{
}


int CXairoProxyForm::getFrequency() 
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	s=RPCCall(L("Form_getFrequency"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}


int CXairoProxyForm::getFilteredFrequency(const CXairoICorpusTextFilter* f) 
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_STRING; x[1].s=((CXairoProxyCorpusTextFilter*) f)->getId();
	s=RPCCall(L("Form_getFilteredFrequency"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}



const xairo_uchar* CXairoProxyForm::getAdditionalKey(const xairo_uchar* key)
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_STRING; x[1].s=key;
	s=RPCCall(L("Form_getAdditionalKey"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}

const xairo_uchar* CXairoProxyForm::getNorm()
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	s=RPCCall(L("Form_getNorm"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}

const xairo_uchar* CXairoProxyForm::getText()
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	s=RPCCall(L("Form_getText"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}

bool CXairoProxyForm::included(const CXairoIAddkeyFilter* f)
{
	CXairoProxyAddkeyFilter* ff=(CXairoProxyAddkeyFilter*) f;
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_STRING; x[1].s=ff->getId();
	s=RPCCall(L("Form_included"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCBoolParam(d,0);
}
