#include "stdafx.h"
#include "XairoProxyServer.h"
#include "XairoProxySolveError.h"

CXairoProxyGrammar::CXairoProxyGrammar()
{
}

CXairoProxyGrammar::~CXairoProxyGrammar(void)
{
}

int CXairoProxyGrammar::getLemmaSchemeCount() const
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("Grammar_getLemmaSchemeCount"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

const xairo_uchar* CXairoProxyGrammar::LemmaScheme::getFacet(int i) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_I4; x[1].i=i;
	s=RPCCall(L("Grammar_LemmaScheme_getFacet"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}

const CXairoProxyGrammar::LemmaScheme* CXairoProxyGrammar::getLemmaScheme(int i) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=i;
	s=RPCCall(L("Grammar_getLemmaScheme"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar * id=RPCStringParam(d,0);
	const xairo_uchar * n=RPCStringParam(d,1);
	const xairo_uchar * g=RPCStringParam(d,2);
	int nf=RPCIntParam(d,3);
	return new LemmaScheme(id,n,g,nf,m_server);
}

int CXairoProxyGrammar::getRegionCount() const
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("Grammar_getRegionCount"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

const xairo_uchar* CXairoProxyGrammar::Region::getValue(int i) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_I4; x[1].i=i;
	s=RPCCall(L("Grammar_Region_getValue"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}

const CXairoProxyGrammar::Region* CXairoProxyGrammar::getRegion(int i) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=i;
	s=RPCCall(L("Grammar_getRegion"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar * id=RPCStringParam(d,0);
	const xairo_uchar * n=RPCStringParam(d,1);
	const xairo_uchar * g=RPCStringParam(d,2);
	int nf=RPCIntParam(d,3);
	int nak=RPCIntParam(d,4);
	return new Region(id,n,g,nf,nak,m_server);
}

const CXairoProxyGrammar::Addkey* CXairoProxyGrammar::Region::getAddkey() const
{
	return (CXairoProxyGrammar::Addkey*) m_server->getGrammar()->getAddkey(m_nak);
}



int CXairoProxyGrammar::getAddkeyCount() const
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("Grammar_getAddkeyCount"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

const CXairoProxyGrammar::Addkey* CXairoProxyGrammar::getAddkey(int i) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=i;
	s=RPCCall(L("Grammar_getAddkey"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar * id=RPCStringParam(d,0);
	const xairo_uchar * n=RPCStringParam(d,1);
	const xairo_uchar * g=RPCStringParam(d,2);
	bool b=RPCBoolParam(d,3);
	const xairo_uchar * cbid=RPCStringParam(d,4);
	const xairo_uchar * att=RPCStringParam(d,5);
	return new Addkey(id,n,g,b,cbid,att,m_server);
}

int CXairoProxyGrammar::getNamespaceCount() const
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("Grammar_getNamespaceCount"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

const CXairoProxyGrammar::Namespace* CXairoProxyGrammar::getNamespace(int i) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=i;
	s=RPCCall(L("Grammar_getNamespace"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar * u=RPCStringParam(d,0);
	return new Namespace(u);
}

int CXairoProxyGrammar::getElementCount() const
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("Grammar_getElementCount"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

const CXairoProxyGrammar::Element* CXairoProxyGrammar::getElement(int i) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=i;
	s=RPCCall(L("Grammar_getElement"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar * id=RPCStringParam(d,0);
	const xairo_uchar * n=RPCStringParam(d,1);
	const xairo_uchar * g=RPCStringParam(d,2);
	int ac=RPCIntParam(d,3);
	const xairo_uchar * u=RPCStringParam(d,4);
	bool bB=RPCBoolParam(d,5);
	return new Element(id,n,g,ac,u,bB,m_server);
}

int CXairoProxyGrammar::getGlobalAttributeCount() const
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("Grammar_getGlobalAttributeCount"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

const CXairoProxyGrammar::Attribute* CXairoProxyGrammar::getGlobalAttribute(int i) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=i;
	s=RPCCall(L("Grammar_getGlobalAttribute"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar * id=RPCStringParam(d,0);
	const xairo_uchar * n=RPCStringParam(d,1);
	const xairo_uchar * g=RPCStringParam(d,2);
	const xairo_uchar * u=RPCStringParam(d,3);
	const xairo_uchar * c=RPCStringParam(d,4);
	int p=RPCIntParam(d,5);
	const xairo_uchar * t=RPCStringParam(d,6);
	bool bB=RPCBoolParam(d,7);
	return new Attribute(id,n,g,u,c,L("0"),(CXairoIGrammar::Attribute::ip) p,t,bB,m_server);
}

const CXairoProxyGrammar::Partition* CXairoProxyGrammar::getRootPartition() const
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("Grammar_getRootPartition"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar * id=RPCStringParam(d,0);
	const xairo_uchar * n=RPCStringParam(d,1);
	const xairo_uchar * dx=RPCStringParam(d,2);
	int c=RPCIntParam(d,3);
	bool b=RPCBoolParam(d,4);
	return new Partition(id,n,dx,c,b,m_server);
}

const CXairoProxyGrammar::Attribute* CXairoProxyGrammar::Element::getAttribute(int i) const 
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_I4; x[1].i=i;
	s=RPCCall(L("Grammar_getAttribute"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar * id=RPCStringParam(d,0);
	const xairo_uchar * n=RPCStringParam(d,1);
	const xairo_uchar * g=RPCStringParam(d,2);
	const xairo_uchar * u=RPCStringParam(d,3);
	const xairo_uchar * c=RPCStringParam(d,4);
	int p=RPCIntParam(d,5);
	const xairo_uchar * t=RPCStringParam(d,6);
	bool bB=RPCBoolParam(d,7);
	return new Attribute(id,n,g,u,c,m_name,(CXairoIGrammar::Attribute::ip) p,t,bB,m_server);
}

const CXairoProxyGrammar::Partition* CXairoProxyGrammar::Partition::getDivision(int i) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_I4; x[1].i=i;
	s=RPCCall(L("Grammar_Partition_getDivision"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar * id=RPCStringParam(d,0);
	const xairo_uchar * n=RPCStringParam(d,1);
	const xairo_uchar * dx=RPCStringParam(d,2);
	int c=RPCIntParam(d,3);
	bool b=RPCBoolParam(d,4);
	return new Partition(id,n,dx,c,b,m_server);
}

int CXairoProxyGrammar::Partition::getWordCount() const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	s=RPCCall(L("Grammar_Partition_getWordCount"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

int CXairoProxyGrammar::Partition::getIndex() const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	s=RPCCall(L("Grammar_Partition_getIndex"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

const xairo_uchar* CXairoProxyGrammar::Codebook::lookup(const xairo_uchar* s0) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_STRING; x[1].s=s0;
	s=RPCCall(L("Grammar_Codebook_lookup"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}

int CXairoProxyGrammar::Codebook::getCount() const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	s=RPCCall(L("Grammar_Codebook_getCount"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

void CXairoProxyGrammar::Codebook::getPair(int i,const xairo_uchar** n1,const xairo_uchar** n2) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_I4; x[1].i=i;
	s=RPCCall(L("Grammar_Codebook_getPair"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	*n1=RPCStringParam(d,0);
	*n2=RPCStringParam(d,1);
}

int CXairoProxyGrammar::getLabelCount() const
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("Grammar_getLabelCount"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

const CXairoProxyGrammar::Label* CXairoProxyGrammar::getLabel(int i) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=i;
	s=RPCCall(L("Grammar_getLabel"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar * elt=RPCStringParam(d,0);
	const xairo_uchar * att=RPCStringParam(d,1);
	return new Label(elt,att);
}

int CXairoProxyGrammar::getWTagCount() const
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("Grammar_getWTagCount"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

const xairo_uchar* CXairoProxyGrammar::getWTag(int i) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=i;
	s=RPCCall(L("Grammar_getWTag"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}

int CXairoProxyGrammar::getCodePageCount() const
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("Grammar_getCodePageCount"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

const xairo_uchar* CXairoProxyGrammar::getCodePage(int i) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=i;
	s=RPCCall(L("Grammar_getCodePage"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCStringParam(d,0);
}

int CXairoProxyGrammar::getCharacterEntityCount() const
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("Grammar_getCharacterEntityCount"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}
	
void CXairoProxyGrammar::getCharacterEntity(int i,const xairo_uchar** c,int* v) const
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_I4; x[0].i=i;
	s=RPCCall(L("Grammar_getCharacterEntity"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	*c=RPCStringParam(d,0);
	*v=RPCIntParam(d,1);
}

const char* CXairoProxyGrammar::getDSC() const
{
	const xairo_uchar* s;
	DOMElement* d;
	s=RPCCall(L("Grammar_getDSC"),0,NULL);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar* w=RPCStringParam(d,0);
	char* c=new char[wcslen(w)+1];
	if (c==NULL) throw new CXairoProxyError(CXairoIError::ERR_XMLRPC,"malloc failed");
	wcstombs(c,w,wcslen(w)+1);
	return c;
}

