#include "stdafx.h"
#include "XairoProxyWordList.h"
#include "XairoProxyWord.h"

CXairoProxyWordList::CXairoProxyWordList(const xairo_uchar* id,CXairoProxyServer* s):m_id(id),m_server(s)
{
}

CXairoProxyWordList::~CXairoProxyWordList(void)
{
}

int CXairoProxyWordList::getCount()
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[1];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	s=RPCCall(L("WordList_getCount"),1,x);
	d=m_server->RPCRemote(s); delete [] s;
	return RPCIntParam(d,0);
}

CXairoIWord* CXairoProxyWordList::getWord(int i)
{
	const xairo_uchar* s;
	DOMElement* d;
	xmlrpc_arg x[2];
	x[0].t=XMLRPC_STRING; x[0].s=m_id;
	x[1].t=XMLRPC_I4; x[1].i=i;
	s=RPCCall(L("WordList_getWord"),2,x);
	d=m_server->RPCRemote(s); delete [] s;
	const xairo_uchar* id=RPCStringParam(d,0);
	int f=RPCIntParam(d,1);
	int fc=RPCIntParam(d,2);
	const xairo_uchar* norm0=RPCStringParam(d,3);
	return new CXairoProxyWord(id,f,fc,norm0,m_server);
}